2011-03-29  Vincent Povirk  <madewokherd@gmail.com>

	System.Windows.Forms.Mime: Use freedesktop.org only on Unix
	platforms.

2011-02-11  Miguel de Icaza  <miguel@gnome.org>

	[fix] changing Form.Enabled sometimes can change the list of
	OpenForms, fixes 671098

2011-02-01  Geoff Norton  <grompf@sublimeintervention.com>

	Avoid a stack overflow when deactivating a window

2011-01-06  Thomas Goldstein  <stifu@free.fr>

	Replace decimal to hex string conversion code with a much more
	simple alternative (suggested by Oliver Thimm). Fixes bug 661750.

2011-01-06  Thomas Goldstein  <stifu@free.fr>

	Remove #if NET_2_0.

2011-01-01  Thomas Goldstein  <stifu@free.fr>

	Add missing properties that should be copied when cloning a
	TreeNode. Fixes bug 661753.

2010-12-22  Thomas Goldstein  <stifu@free.fr>

	Remove null check in ComboBox.SelectedText setter (now handled in
	TextBoxBase).

2010-12-22  Thomas Goldstein  <stifu@free.fr>

	If SelectedText is given a null value, set it to String.Empty.

2010-12-21  Thomas Goldstein  <stifu@free.fr>

	When ComboBox.SelectedText is given a null value, set it to
	String.Empty. Fixes bug 660294.

2010-12-16  Jonathan Pobst  <monkey@jpobst.com>

	Move line inside if () to fix 2 tests.

	Broke by 9aa23d8ebec0f5c60ae66fee3df8a3c6c39cf191.

2010-12-16  Miguel de Icaza  <miguel@gnome.org>

	[winforms] undo accidental removal of a line

2010-12-16  Miguel de Icaza  <miguel@gnome.org>

	[winforms] revert patch, it regresses the test suite:
	https://github.com/mono/mono/commit/8334fe3a56c978ffe7f8cb199536f9b3234afdbe

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Pass 4 of removing NET_2_0 from winforms

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Pass 3 of removing NET_2_0 from winforms

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Pass 3 of removing NET_2_0 from winforms

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Pass 2 of removing NET_2_0 from winforms

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Pass 2 of removing NET_2_0 from winforms

2010-12-12  Miguel de Icaza  <miguel@gnome.org>

	Pass 1 of removing NET_2_0 from winforms

2010-12-11  Thomas Goldstein  <stifu@free.fr>

	[winforms] Small optimizations, use properties that do not compute
	values

2010-12-10  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Style, braces

2010-12-10  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Use conditional attributes, not ifdefs to insert
	conditional code

2010-12-10  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Use conditional attributes, not ifdefs to insert
	conditional code

2010-12-10  Gonzalo Paniagua Javier  <gonzalo.mono@gmail.com>

	Line endings

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Fix graphics leak

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Fix graphics leak

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] For what it appeared to be a crasher from the
	JumboPatch

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Reorder code a bit

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Avoid leaking the Graphics

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Avoid leaking the Graphics + style

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Cope with null current regions

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Cope with small windows

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Style

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Style

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Style, reduce full sizes of common types

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Do not leak Graphics in Invalidate + some Style

2010-12-10  Miguel de Icaza  <miguel@gnome.org>

	[winforms] style, and NET_2_0 dropped

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Style

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Cope with null Hwnd value from Hwnd.ObjectFromHandle

2010-12-10  Ralph Leckett  <rleckett@gmail.com>

	[winforms] Win32 fixes for window class name

	This is extracted from Ralph Leckett's jumbo-patch to winforms

2010-12-10  Thomas Goldstein  <stifu@free.fr>

	[winforms] quick cleanup patches for a few WinForms classes

2010-12-10  Miguel de Icaza  <miguel@gnome.org>

	[winforms] Prepare for Gnome 3, by not depending on libgnomeui

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	[winforms] Fix ContextMenuStrip vertical position can be wrong.

	Fixes #658945

	This can lead to the top of the context menu being off the screen.
	This only happens with context menus with lots of items.

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	[winforms] WM_SETFOCUS is sent before Keyboard Focus is changed.

	Switches Keyboard focus so that it occurs before WM_SETFOCUS is
	sent.

	This means that the wrong keyboard im is selected while process
	winform events caused by WM_SETFOCUS.

	Attaching patch that changes this so that keyboard im is focused
	before WM_SETFOCUS is sent.

	Fixes: #557277

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	* XplatUIStructs.cs: Added user messages WM_XIM_PREEDITSTART,
	WM_XIM_PREEDITDONE, WM_XIM_PREEDITDRAW, WM_XIM_PREEDITCARET *
	X11Keyboard.cs: Changed preedit callbacks to emit WM_XIM_*
	messages * X11Structs.cs: Added XIMFeedbackStruct and XIMFeedback
	enum.

	Here is some sample code which make use of this feature:

	/// <summary> /// Proof on concept implementation of a user
	defined TextBox that does on-the-spot /// input method editing.
	/// There is a number of know flaws - eg. doesn't end preedit when
	user moves cursor with mouse. /// Need to run with
	MONO_WINFORMS_XIM_STYLE=on-the-spot mono /// </summary> public
	class OnTheSpotTextBox : TextBox, XIM.IPreedit { // store text
	before preedit. string backup;

	#region IPreedit implementation public int PreeditStart (IntPtr
	clientData, IntPtr callData) { Console.WriteLine ("PreeditStart");
	backup = Text; return 100; }

	public int PreeditDone (IntPtr clientData, IntPtr callData) {
	Clear (); AppendText (backup); return 0; }

	public int PreeditDraw (IntPtr clientData, IntPtr callData) {
	XIM.PreeditDrawInfo info = new XIM.PreeditDrawInfo (callData);
	Console.WriteLine ("PreeditDraw PreeditDrawInfo {0}", info); if
	(info.ChangeLength > 0) { Clear (); AppendText (backup); } if
	(info.Caret > 0) AppendText (info.Text); return 0; }

	public int PreeditCaret (IntPtr clientData, IntPtr callData) {
	XIM.PreeditCaretInfo info = new XIM.PreeditCaretInfo (clientData);
	Console.WriteLine ("PreeditCaret PreeditCaretInfo {0}", info);
	return 0; }

	protected override void WndProc (ref Message m) { switch (m.Msg) {

	case /*WM_USER*/0x400 + 0x1d00: // WM_XIM_PREEDITSTART // The
	WParam value identifies what is occurring. PreeditStart (m.WParam,
	m.LParam); break; case /*WM_USER*/0x400 + 0x1d01: //
	WM_XIM_PREEDITDONE PreeditDone (m.WParam, m.LParam); break; case
	/*WM_USER*/0x400 + 0x1d02: // WM_XIM_PREEDITDRAW PreeditDraw
	(m.WParam, m.LParam); break; case /*WM_USER*/0x400 + 0x1d03: //
	WM_XIM_PREEDITCARET PreeditCaret (m.WParam, m.LParam); break; }
	base.WndProc (ref m); }

	#endregion

	}

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	[winforms] Add modal support to Forms

	This fixes 614850 "Modal dialogs should prevent closing their
	parent windows."

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	[winforms] DataGridView.cs : Made MoveCurrentCell not attempt
	access Column index -1.

	Fixes #516960

2010-12-10  Tom Hindle  <tom_hindle@sil.org>

	[winforms,fix] Prevent Clipboard APIs from running any Idle
	handlers

	Fixes: 641756

	This prevents idle methods to be invoked when calling the
	Clipboard APIs on X11, which is not the expected behavior.

	The description from the bug report is:

	Mono X11 Clipboard handling calls UpdateMessageQueue, which has
	the side affect of potentially calling Idle handlers.

	If any Idle handlers call Clipboard functions, this can cause idle
	handler reentry.

	See attached test case.

	Incidentally removing the reentry check from the idle handler will
	actually cause mono to segfault.

	I will attach a patch shortly which fixes this by overloading
	UpdateMessageQueue to allow Clipboard methods to call a version
	that doesn't run idle processing.

2010-12-10  Thomas Goldstein  <stifu@free.fr>

	[winforms, fix] Keep the carret in sync with changes to the text
	entry value

	Patch from Thomas Goldstein for bug #621475

	The IndexOutOfRangeException is apparently a caret position bug.
	As a workaround, doing textbox.SelectionStart = 0; before
	resetting the Text avoids the bug.

	Here's a patch to fix the bug. Basically, it applies the same
	caret updates whether the Text is null/empty or not. I hope I can
	get away with the minor style updates without having to submit
	them as a separate patch...

2010-12-10  Andy Hume  <andyhume32@yahoo.co.uk>

	[fix, winforms] Fix the ProgressBar speed in Marquee situations

	This issue was identified as:

	Marquee speed is very weird, changing between very very fast and
	very very very very fast, and in inverse to the speed setting?

	In https://bugzilla.novell.com/show_bug.cgi?id=440220

	Also fixes this bug which was the test case isolated:

	https://bugzilla.novell.com/show_bug.cgi?id=655797

2010-12-10  Nagappan Alagappan  <nagappan@gmail.com>

	[winforms, datagrid, fix] fixes crasher reported in 416111

2010-10-31  Miguel de Icaza  <miguel@gnome.org>

	Expose some of our internals to the Mono.Winforms assembly

2010-10-31  Miguel de Icaza  <miguel@gnome.org>

	Fix broken patch

2010-10-31  Miguel de Icaza  <miguel@gnome.org>

	Allow this file to expose its types as public if needed

2010-10-25  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ComboBox.cs: Fire the Mouse* events when using the child
	TextBox. Fixes #647689.

2010-10-25  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListView.cs: When updating the Z-order for our controls don't
	forget to add the implicit scrollbars we well. Fixes #648449.

2010-10-24  Marek Safar  <marek.safar@gmail.com>

	Warnings cleanup.

2010-10-20  Latif Khalifa  <lkalif@openmetaverse.org>

	Avoid nullref when clearing TextBox that has not yet been
	displayed

2010-09-27  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* Form.cs: When setting DialogResult call RaiseCloseEvents instead
	of directly setting 'closing', since we need to have our
	FormClosing event invoked *before* the form dissapears, so the
	user can properly cancel the close operation if desired. Fixes
	#631810.

2010-09-26  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* X11Keyboard.cs: Manually handle the conversion of the string
	returned by XLookupString, just as we were already doing for XIM
	support - using StringBuilder directly was somehow returning a
	corrupt buffer from time to time. Fixes #639939.

2010-09-21  acken  <acken@acken.no>

	Had an issue where the linklabel was clicked, the form was redrawn
	with some changes and some internal behavior called the OnGotFocus
	where sorted_links now was null and focused_index was 0. Don't
	know wheter that is wrong but solved the issue with a nullcheck

2010-08-31  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListBox.cs: Invalidate the selection border when horizontally
	scrolling - the call to ScrollWindow is not enough, so we need to
	update by ourselves the new margin of the selection border by a
	quite small offset. Fixes #512136.

2010-08-31  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* NotifyIcon.cs: Use SystemColors.Menu to paint the background of
	the control, since at least in gnome the menu and the panel share
	the back color (unfortunately we can't just leave the rectangle
	transparent, as some window managers use a default white). Fixes
	#581287.

2010-08-31  Tom Hindle  <tom_hindle@sil.org>

	* TreeView.cs: Create a new method to check that the new valid for
	the vertical scroll is in the valid range - this is specially
	important when the size of the TreeView can show less than one
	element. Fixes #624915.

2010-08-16  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* DataGridView.cs: When refreshing the scrolling info, set the
	values for the internal scrollbars even if we are forced to not
	display them, since they are used to compute the navigation, which
	should be available *always*.

2010-08-15  Thomas Goldstein  <stifu@free.fr>

	* ListControl.cs: Use the actual value of the items in the Format
	event, just as .net does. Fixes #620326.

2010-08-15  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListViewItem.cs: * ListView.cs: Force an update in the selection
	if a new added/inserted item to ListViewItemCollection is already
	selected.

2010-08-15  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListViewItem.cs: Remove all the NET_2_0 directives since we
	don't need them anymore.

2010-08-14  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* TextBoxBase.cs: In Text property always call
	Document.SetSelectionToCaret just like we do in other places
	calling Document.Empty(). This way we don't leave our selection
	stuff in an inconsistent state.

2010-08-09  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* Application.cs: At the end of the message loop in RunLoop don't
	break the loop if the Form handle has been destroyed already -
	which means that we *need* to wait for WM_QUIT and handle it
	properly instead, so it doesn't end up affecting other forms.

2010-08-08  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListView.cs: When using Details view re-populate our implicit
	control collection to our header control is always on top. We
	could try to just use BringToFront but since these controls are
	implicit, we are not gracefully handling them.

2010-08-07  Carlos Alberto Cortez  <calberto.cortez@gmail.com>

	* ListView.cs: Don't call Dispose for our implicit scrollbars, as
	the default Control.Dispose impl is already disposing all the
	implicit controls. This was generating extra Layout events when
	disposing.

2010-07-08 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* ThemeWin32Classic.cs: implement ResetDefaults.
	Fixes bug #581956.

2010-07-05  Dick Porter  <dporter@codicesoftware.com>

	* MenuAPI.cs: Only handle mnemonic key shortcuts when the context
	menu is visible.  Fixes bug 616739.

2010-07-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: The images drawn in the column header must be
	vertically centered. Fixes #616432.
	Patch by Thomas Goldstein (stifu@free.fr).

2010-06-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Don't use the Font property of our TabPages - use our
	own Font property instead, as .Net does.
	Fixes some bits of #551032.

2010-06-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Call Invalidate when removing a tab page. We were
	depending on the redraw routines of SelectedIndex, which could be not
	enough to detect the real affected area.

2010-06-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Don't set SelectedTabIndex when getting the focus *at
	all*.
	Fixes #613765.

2010-06-24  Dick Porter  <dporter@codicesoftware.com>

	* Fix NullReferenceException when keyboard shortcut activates
	disabled context menu item.  Fixes bug 615940.

2010-06-22  Dick Porter  <dporter@codicesoftware.com>

	* TextControl.cs, XplatUIX11.cs, XplatUICarbon.cs: Expand paint
	regions slightly so that the full extents of text get painted.
	Fixes bug 464464.

2010-06-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNode.cs: Clone should detect the type of the current instance
	and properly create the correct object.
	Fixes #613708.

2010-06-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When setting SelectedIndex and the new selected tab
	bounds are obscured by the scrollers, take into account the self tab
	when looking for the proper bounds to adjust the slider. This is specially
	important when we need to adjust the slider pos for the *last* tab page.
	Fixes #615382.

2010-06-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Show the tooltip depending on the value 
	of ShowTooltips.
	Fixes #615376.

2010-06-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Implement ToolTip support for our tab pages.
	Fixes part of #515045.

2010-06-19  Jonathan Pobst  <monkey@jpobst.com>

	* FontDialog.cs: Make the 16 colors in the color drop down
	match .Net.  Patch by Thomas Goldstein (stifu@free.fr).
	[Fixes bug #506726]

2010-06-19  Jonathan Pobst  <monkey@jpobst.com>

	* FontDialog.cs: Show all 16 colors in the color drop down
	to match .Net.  Patch by Thomas Goldstein (stifu@free.fr).
	[Fixes bug #508523]

2010-06-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When calculating the size of our tabs use
	MinimumTabWidth only if SizeMode is other than Fixed.
	Patch by Thomas Goldstein (stifu@free.fr).

2010-05-20  Andreia Gaita <avidigal@novell.com> 

	* X11Dnd.cs: Fix a few crashers, making sure the client window is valid
	when dragging

2010-05-15  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* TabControl.cs: Properly implement ItemSize, which should depend on
	Font and ImageList -if available-, instead of having a fixed height.
	Setting ImageList should cause a Redraw also.
	Fixes #599950.

2010-05-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: ItemSize should be returning two times the padding
	values instead of one.

2010-05-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: ItemSize should include the padding value.
	Update the retrieval of this info in SizeTab as well.
	Fixes part of #604034.

2010-05-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ScrollableControl.cs: It seems .Net is creating DockPadding lazyly,
	which means that *any* padding for children controls is not applied
	*until* DockPadding is accesed using its getter.
	* FlowLayoutPanel.cs:
	* TableLayoutPanel.cs:
	* Form.cs: These children classes need to have the DockPadding
	property available *always*, so create it for them in their respective
	constructors.
	Fixes #599506.

2010-05-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Properly adjust SmallChange and LargeChange values for
	our scrollbars depending on the view. Also, update the maximum allowed
	value when setting the values from SetScrollValue to use the already
	available information contained within them.
	Fixes the remaining bits of #543785.

2010-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: When calculating the scrollbars, take into account the
	height of the horizontal scrollbar (if visible) to assign the maximum
	value for our vertical one.
	Fixes #543785.

2010-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: Do some clean up by renaming some of our
	local vars in Add and AddSorted, so we have better readibility.
	Patch from Thomas Goldstein (stifu@free.fr).

2010-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: When adding a sorted node return the correct
	position of that node instead of returning the count.
	Patch from Thomas Goldstein (stifu@free.fr).

2010-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: In SetupNode remove the redundant check,
	since we only need to have a valid tree view to call UpdateBelow.
	Patch from Thomas Goldstein (stifu@free.fr).

2010-05-04  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Patch from adrian.taylor@realvnc.com to avoid
	blocking the message loop while processing events.

2010-05-03  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: Just as we did with TreeView, start the drag
	computation in MouseDown instead of MouseMove, in order to avoid
	firing the ItemDrag event more than one time per clicked item.

2010-05-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: our internal textbox should show selection only if it
	is enabled. Don't set HideSelection since it's preventing us
	from correctly hide the selection when needed. Finally connect a
	handler in case our parent ComboBox gets its Enabled state changed.
	Fixes #600433.

2010-05-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: Set our internal fields related to the starting drag
	position from MouseDown to MouseMove - we need to make sure
	that the OnItemDragged event is fired only *one* time per element
	clicked.
	Fixes #551734.

2010-05-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: Instead of Sorting from SetupNode, do it
	directly from Add (which uses AddSorted for this purpose) and Insert.
	This way we first avoid a double sort, take advantage of our fast
	version of Add for the default sorting, and also supress the call to Sort
	when using our indexer setter (.Net ignores the sorting in this case).

2010-05-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: When Adding a new node don't remove it from
	any previous collection. Even if this seems a little buggy, this is
	what .Net does.
	Fixes #601766.

2010-05-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* StatusStrip.cs: In SetDisplayedItems call ClearInternal on
	displayed_items instead of Clear, since this is only an internal
	collection and we don't want to have our items have their Parent/Owner
	modified.
	Fixes the remaining bits of #590100.

2010-05-02  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridViewCell.cs: Avoid a NRE in GetValue if the cell doesn't 
	have a DataGridView associated yet.
	[Fixes bug #600786]

2010-05-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripItemCollection.cs: When calling Clear set Owner and Parent
	properties to null for each of the items in the collection, just as
	Remove/RemoveAt do. Implement a ClearInternal method that clears the
	collection without modifying the mentioned properties.
	* ToolStrip.cs:
	* ToolStripOverflow.cs: Call ToolStripItemCollection.ClearInternal
	for our internal collections.
	This should fix #590100, which producing a race when the garbage
	collector was calling ToolStripItem.Dispose, which in turn was firing
	a Layout in the ToolStrip.

2010-04-27  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridView.cs: Fix multiple issues when inserting and adding new 
	columns.

2010-04-27  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripSplitButton.cs:
	* ToolStripDropDownItem.cs:
	* ToolStripMenuItem.cs: Update overrides.
	* ToolStripItem.cs: Pass the number of clicks to HandleClick when
	firing OnMouseUp, so we can later fire either OnClick or
	OnDoubleClick.

	Fixes #558632.

2010-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When emitting the complete RTF value escape chars
	above 0x80, at .Net seems to do. This way we are able to make
	round-trip assignations between the setter and getter of the
	RichTextBox.Rtf property.
	Fixes part of #586901.

2010-04-26  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridView.cs: Handle all possible cases for when a new column is 
	added and there are existing rows with existing cells both in the 
	non-databound and the databound scenario.
	[Fixes bug #583387]

2010-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When retrieving data from the x11 clipboard and we
	are using either XA_STRING or OEMTEXT try to detect if we have escaped
	unicode chars, and unescape them as needed. This us used by some
	(gnome) applications to pass unicode chars in a non-unicode context.
	Fixes #596402.

2010-04-25  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridViewCellCollection.cs, DataGridView.cs: 
	Ensure column cell templates are properly applied.
	[Fixes bug #583404]

2010-04-24  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridViewColumnCollection.cs: When adding a column also 
	set the DisplayIndex if its now set by the user already.
	[Fixes bug #583387]

2010-04-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* NotifyIcon.cs: Make BalloonWindow expose the owner's Handle.
	* Theme.cs:
	* ThemeWin32Classic.cs: Add a HideBalloonWindow method to force to
	close an active balloon window.
	* XplatUIX11.cs: When removing from the system tray try to close
	the balloon window. This is important when we hide a NotifyIcon and
	thus need to close its related balloon window as well.
	Fixes bits of #590093.

2010-04-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When adding a NotifyIcon to the system tray, mark its
	Hwnd.mapped as true, since its handle is going to be mapped later by
	the tray (not us), but we need to know it's alive and can later properly unmap
	it.
	Fixes part of #590093.

2010-04-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: When adding/inserting/setting a new node call
	TreeView.Sort if needed, and update/recalculate this entire
	collection in that case.
	* TreeView.cs: Make 'sorted' internal, instead of directly using
	Sorted, as this one could trigger a complete Sort() operation.

2010-04-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: We must use the comparer supplied by TreeViewNodeSorter
	*always*, since it is used recursively, so checking for a number of
	top level nodes is useless. This should fix a case where we were not
	sorting any node with a single root node.

2010-04-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGridView.cs: Call the base Paint impl last, instead of do that
	at the beginning, to let handlers draw on top of us. 
	Fixes the remaining bits of #587563.

2010-04-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripItem.cs: Separate the background rendering from the Paint
	routine, so we can both make sure the background stuff is done first,
	and we also let our items fire the OnPaint event handlers before or
	after their own routines.
	* ToolStripLabel.cs: Move the base call to OnPaint to the end, so any
	user's Paint handler can draw on top of us, like .Net does.
	Fixes #587563.

2010-04-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When checking for the values returned by
	_NET_WORKAREA, use current_desktop+1 instead of current_desktop, since
	we need the actual value, instead of the index (which is 0 based, and
	is not working in this case). Patch by Andy Stühr
	(andysmuell@hammerhartes.de).
	Fixes #494234.

2010-04-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolTip.cs: Make TipState internal.
	* ToolStrip.cs: Use the same idea of ToolTip'state to have our
	internal timer close the tooltip window after a delay, instead of
	waiting for the mouse to move to a different item. Also, hide the
	tooltip window when the handle is destroyed, and also when the control
	is getting hidden.
	Fixes #581273.

2010-03-31  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Selection should be available after the first time the
	handle has been created, even if later the handle is destroyed or
	temporary invalidated.
	Fixes #584070.

2010-03-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When receiving a double click on a node, toggle it only
	if it has one or more nodes - just as .net does.
	Fixes #578079.

2010-03-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Keyboard.cs: Small correction for the previous patch: I forgot to
	take into account the case where the buffer used in XLookupString is
	not empty, but filled with garbage.

2010-03-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Keyboard.cs: When handling the key events, sometimes calling
	either Xutf8LookupString or XLookupString with special chars (such
	backspace and enter) can result in a buffer filled with garbage, or
	empty - thus re-use the value returned by the same functions to fill
	the gap.
	Fixes #582691.

2010-02-25  Ivan Zlatev  <ivan@ivanz.com>

	* Control.cs: ControllCollaction IList implementation wasn't calling the 
	Add implementation causing ParentChanged and all sorts of other events not to 
	get fired.
	[Fixes bug #580042]

2010-02-25  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridView.cs: If we are setting a new data source and it is 
	data bindable clear DataMember before binding.
	[Fixes bug #554296]

2010-02-25  Ivan Zlatev  <ivan@ivanz.com>

	* DataGridViewCheckBoxCell.cs: Toggle the checkbox on Space key press.
	[Fixes bug #574259]

2010-02-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When retrieving SelectedRtf/Rtf properly escape any
	RTF reserved char, so we don't end up messing around the actual rtf
	values.
	Fixes part of #575731.

2010-02-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Line.cs: When setting the Text property, if the new text is larger
	than the previous one, call Grow to update our internal 'widths'
	array, to be properly in sync with the new text.
	Fixes #569530.

2010-02-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When calculating the layout for the tab pages, take
	into account the ImageList size info if it exists, even if it is
	empty.

2010-02-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* StatusStrip.cs:
	* XplatX11.cs:
	* X11Structs: Implement the new BeginMoveResize method, designed to
	instruct the window manager to init a resize operation on a top level
	form. This is used by StatusStrip.
	* XplatUI.cs:
	* XplatUIDriver.cs:
	* XplatUIWin32.cs:
	* XplatUICarbon.cs: Fill the gaps by creating stubs and updating the
	method calls.
	Fixes #573299.

2010-02-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When creating DrawItemEventArgs pass the fore color and
	back color arguments depending on the higlight/focus state, just like
	.net.
	Fixes #572643.

2010-01-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When the normal drop down window is closed, make sure
	that the auto complete list -if any- is closed as well, instead of
	stay open without need.

2010-01-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: When showing the autocomplete listbox, make sure it's on
	top, by calling the raw XplatUI.SetZOrder for it, since we can't
	properly call BringToFront on it as it is parentless. This fixes an
	issue when using this feature with ComboBox's own parentless listbox.
	Fixes the remaining bits of #489339.

2010-01-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUI.cs:
	* XplatUIDriver:
	* XplatUICarbon:
	* XplatUIWin32:
	* XplatUIX11.cs: 
	* XplatUIStructs: Implement support for different kind of audible
	alerts in Windows, and update the requiered classes.
	* MessageBox.cs: 
	* TextBoxBase.cs: Update calls to XplatUI.AudibleAlert.
	Fixes #473725.

2010-01-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When use manually setting DropDownHeight, ignore the
	MaxDropDownHeight property - also rename our field 'count' to
	'visible_items_count' to avoid confusion as much as possible.
	Fixes an issue with several items, showing an incorrect layout.

2010-01-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: SelectedText should set Modified to true. Observe
	that this is happening just here, not for the Text property, and
	neither for the TextBoxBase impl.
	Fixes #569950.

2010-01-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripMenuItem.cs: Put the Checked/CheckState logic in a single
	place and synchronize the events properly. Fixes a lack of
	coordination between the events - which should be fired together.

2010-01-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TrackBar.cs: Move our events code to a single method, allowing it to
	optionally fire the Scroll event. This way we both avoid the
	duplicated calls to OnScroll and also will be able to fire Scroll
	*before* OnValueChanged in other places.
	Fixes #568026.

2010-01-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RadioButton.cs: When drawing, if Appearance is Button use the old
	normal routine in the theme engine, instead of using the one in 2.0,
	since this last one doesn't support proper rendering of the control as
	a button.
	Fixes #567904.

2010-01-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* GroupBoxRenderer.cs: Properly use SystemColors.GrayText to draw to
	text of the group box if it is disabled.
	Fixes #567847.

2009-12-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs: When changing the cursor and updating it, do update the
	cursor immediately even if there's a child control under the current
	cursor position - this is exactly what .net does.
	Fixes #555780.

2009-11-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: In OnLeave, do cancel or end current edit, depending on
	the commit_new_row value, instead of just trying to cancel if a new
	row had been added. This is important when modifying existing rows and
	then moving the focus out of the control.

2009-11-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUICarbon.cs: Implement the overriden AudibleAlert
	function in XplatUICarbon.  Currently it throws
	NotImplementedException which will kill a WinForms application showing
	a dialog box.
	Patch by  Erik Ylvisaker (erik@agatelib.org).

2009-11-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: In CurrentCell, the check to do nothing in case we are
	in the same cell as specified *and* not editing is wrong.

2009-11-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When removing the cells, don't do anything if the
	specified row is the extra cell we use to add new ones.

2009-11-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: CurrentCell should be *used* if the new value is the
	same as the current one, since we could need to activate the edition
	in the current row. Also, when beginning the edition, do nothing if,
	basides having an empty source, we are sure we don't have the new
	cell, which could obviously start it.
	Fixes other bits of #323154.

2009-11-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When we get notified by a change in the position of our
	data source, don't set CurrentRow if the source is empty, as there's
	no need to do anything else in the first place, and second, the logic
	in the CurrentRow setter (public property) will add a new row by
	default in this case (that is, when the source is empty).
	Fixes part of #323154.

2009-11-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripMenuItem.cs: Don't try to use SystemColors.MenuText if fore
	color is SystemColors.ControlText, as this system color detection
	should be done *completely*. This is specially important when
	detecting colors in systems running Gtk+ and dark themes.

2009-11-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: Add a new internal property to get the maximum possible
	visible rows in the grid. We cannot use VisibleRowCount since this
	value can, depending on the scroll position, return a +1 or -1 value,
	so we need an absolute way to know whether we need a scroll bar or
	not. Also, update VLargeChange to avoid code duplication.
	Fixes a vertical scroll mismatch happening trying to add a new row
	while the scrollbar has reached its maximum value.

2009-11-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGridTextBoxColumn.cs:
	* DataGrid.cs: Position the cursor in the add row should *not* show
	yet another new row - that will happen till we get any real input data
	from the user. When that happens, we will also mark the new row as
	ready to commit - otherwise, when the cursor moves to a different row,
	the just added row will be discarded. This is exactly what .Net seems
	to do.

2009-11-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: The large value for our vertical scrollbar should
	depend on the number of visible rows, instead of trying to re-use the
	value of VisibleRowCount, which is the value of *current* visible
	rows, and can easily end messed up if new rows are added/removed.

2009-11-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When moving the scroll, *dont* ever end the current
	edit - this could seriously mess up our current edit cycle, specially
	when adding new rows.

2009-11-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: In OnKeyDown call the base implementation first -
	this way we let the user tell us whether we should handle the key or
	not.
	Fixes #543717.

2009-11-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: Implement removal of rows the Correct Way by creating a
	copy of the indexes, as any direct write access to the source will cause to
	reset the entire selection - also, do the linear de-selection in
	reverse order to avoid any index mismatch in the source, due to out of
	synchronization removing the rows.

2009-11-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGridTextBoxColumn.cs:
	* DataGrid.cs: Don't use this add-pending behaviour to try to add a
	new row until we have the first input char - it was helping us to fix
	other issues we have/had, but it's not matching .net.

2009-10-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBoxBase.cs: When returning the preferred height, and we are
	supposed to be borderless, return the TopMargin value - usually in
	borderless mode it has a value of 0, but in the ToolStrip controls we
	need to set the margin manually.
	Fixes #551214.

2009-10-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolTip.cs: ShowAlways works at the form level, not at the control
	level. Fixes #544565.

2009-10-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ButtonBase.cs: Usually the click routines are handled in Control,
	but in this class we are handling it ourselved, thus we need to have
	the same calls, and we were missing the call to MouseClick.
	Patch by Eric Petit <surfzoid@gmail.com>.

2009-10-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When setting Text and data source is being used, if the
	passed value is not matching any of the items in the source, don't
	pass it to GetItemText, since it's useless, as GetItemText expects a
	valid item.
	Fixes #546009.

2009-10-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When retrieving an item in virtual mode, as part of the
	process calculate its layout, instead of trying to do it later.
	* ListViewItem.cs: There's no need to try to infer whether we need to
	compute layout or not anymore - we just do it every time we are
	returning an item.
	This way we should be fixing View changes with cached items, which
	were storing the previous value, and not updating their contents
	properly.

2009-10-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ColumnHeader.cs: Remove the double linear search in the Index
	property, by removing the call to Contains, which is not needed.
	Also, Columns collection can never be null.

2009-10-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ColumnHeader.cs: When calculating the width and height of the
	column, try to expand to the right and use all the free space if we
	are the last column *and* the resize mode is set to -2/header content.
	Fixes #544716.

2009-10-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When retrieving the top item, take into account the
	offset represented by the header control, to retrieve the proper
	value. Patch by Christoph von Wittich (Christoph at ApiViewer.de)
	Fixes the remaining bits of #543773.

2009-10-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: TopItem setter should set the value as the top, not
	only ensuring its visibility.
	Fixes part of #543773.

2009-10-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: For virtual mode, when navigating the items using keyboard,
	don't use the matrix of positions, and instead calculate the positions
	based on the number of cols and rows, taking advantage of the fixed
	positions of items. Use the same idea to implement FirstVisibleIndex,
	so we avoid iterating over all the items. Patch by Stephen Robinson
	mono at esar.org.uk.
	Fixes part of #467418.

2009-10-12  Dick Porter  <dporter@codicesoftware.com>

	* Splitter.cs: Adjust offsets when more than one splitter is
	present in a control.  Fixes bug 509472.

2009-10-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When computing the value for groups height don't use
	text_size field, since in LargeIcon view it sometimes contains a
	double height value - use Font.Height directly, and also improve the
	padding value.
	* ThemeWin32Classic: The same as above.
	This way the space between the group header, the line, and the items
	area is not that big in LargeIcon view.

2009-10-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When retrieving the fixed positions for the items in
	virtual mode, use the row value to compute the coords of the item,
	instead of the col value, as opposed to SmallIcon/LargeIcon views.

2009-09-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: The location of the items should be computed on the fly
	in virtual mode - that decreased speed overall, but reduces the load
	time.that decreased speed overall, but reduces the load time. Also,
	handle the cases where we were using data structures we don't need to
	use/create for this mode.
	Fixes part of #467418.

2009-09-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Tile view and VirtualMode can't be applied together.
	Patch by Stephen Robinson <mono@esar.org.uk>.

2009-09-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When calculating the layout for Details view, don't ask
	for the items *at all* in case we are in virtual mode. This should
	re-enable the proper behaviour of virtual mode.

2009-09-26  Jonathan Pobst  <monkey@jpobst.com>

	* TreeNode.cs: When we invalidate a node, make sure we start at
	0, instead of the node's Bounds.Left, which does not include
	the +/-, checkbox, or stateimages.
	[Fixes bug #542481]

2009-09-24  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Compare the name and not displayname of properties 
	when checking if the column is already bound.

2009-09-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: For SelectedRtf, after inserting the stream, adjust
	the position of the caret by adding the needed chars represented by the new line chars,
	according to the system, using rich *or* hard new lines as needed. Also do a
	check to be sure we don't move the cursor position beyond the limits
	of our text. This should avoid problems with text being pasted,
	regarding the position of the caret.

2009-09-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When SelectedRtf is set, and we are in the 0
	position in the x axis, force to re-use any already available line,
	even if it is not empty. This way pasting text into our textbox in the
	beginning for non empty lines should work fine.

2009-09-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When we are inserting a flow of rtf text, and we are
	*not* loading it from a file, try to re-use a line if already
	available, since the default behaviour of the parser is to create new
	lines for the document.
	This should fix a regressions we found after the last fix for #513030.

2009-09-14  Tom Hindle <tom_hindle@sil.org>

	* ToolStripOverflow.cs: Fixes #536036 by adding null ptr check.

2009-09-11  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Hide the splitter when the help is hidden.

2009-09-11  Ivan N. Zlatev  <contact@i-nz.net>

	* InternalWindowManager.cs: Call Invalidate-Update instead of 
	Refresh for MS compitability. Note also that Refresh is virtual 
	and several controls override it in order to provide data refresh 
	functionallity on top of the redraw and they do not expect this 
	extra refresh call.
	* Control.cs: In Refresh Invalidate the control and all children 
	insead of calling Refresh for each of them.
	[Fixes bug #538336]

2009-09-11  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Always set the help panel properties on the 
	internal control, because they are inherited and can change with 
	the parent.
	[Fixes bug #525305]

2009-09-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When processing rtf, don't add a new line if we
	already have one for that position. This way we avoid overriding by
	mistake our lines when copying/pasting.
	Fixes #513030.

2009-09-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextControl.cs: When inserting new lines, look for the end of file
	char, and remove chars after it. This is unlikely to happeng either
	loading a file, pasting text or pressing a char, but can happen using
	the TextBox.Text property.
	Fixes #535884.

2009-09-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Line.cs: In DeleteCharacters, cache line.Length for every tag, since
	tag.Start changes will modify it indirectly and then we would end up
	with wrong values.
	Fixes #512521.

2009-09-03  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: Implement support for chained data sources.
	* ListBindingHelper.cs: Add support for ICurrencyManagerProvider and 
	clean up.
	[Fixes part of bug #536547]

2009-09-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When saving the text to a file using SaveFile use
	Environment.NewLine to separate the lines. This way we should be
	saving the files according to the system.
	Fixes the remaining part of #511515.

2009-08-31  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichText.cs: Remove some unix new line characters and use
	Environment.NewLine. Fixes part of #511515.

2009-08-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBoxBase.cs: Modified should *not* be modified from the Text
	property, as our new tests show. It should be to false, however, in
	Append and Clear; and Paste, Cut, Undo, and direct user input should set it
	to true. Also, as opposed to what the .net docs say -but proven by our
	tests-, the changes should be generating a ModifiedChanged event
	(thus we set the property, instead of the field).
	Fixes #511267.

2009-08-27  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fire the CellDoubleClicked event.
	[Fixes bug #533430]

2009-08-27  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Add support for column DataGridViewAutoSizeColumnMode
	DisplayedCells and DisplayedCellsExceptHeader.
	[Fixes bug #533435]

2009-08-27  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextControl.cs: When removing a simple char, actually record the
	action in the undo manager. This way we both support undoing the
	removal of chars using backspace/delete, as well as keeping data
	integrity when other undo tasks are performed.
	Fixes #531983.

2009-08-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs: Remove the ancient code in ResetText, which was setting
	the internal field to String.Empty, instead of doing it for our Text
	property, as .net does (which also causes a TextChanged event and all
	the other related routines).
	Fixes #531587.

2009-08-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: Correctly implement Contains by using a
	linear search - there's no possible way to use a binary search, since
	the node instances are not implementing IComparable, nor have a
	specific order.
	Fixes #529927.

2009-08-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: If we are *not* changing a row
	already added to the source, and thus we are adding a new 
	row instead, try to move to the previous row when Esc is
	pressed -if possible-.
	Fixes some bits of #322974.

2009-08-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGridTextBoxColumn.cs:
	* DataGrid.cs: Moving the cell to the add row (the last one) should
	not immediately add a new row - this should happen until the very
	first change happens in that textbox.
	Fixes part of #322974.

2009-08-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripDropDown.cs: When assigning the owner item, use its Font as
	well.

2009-08-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripItem.cs: When the owner changes its Font, call the
	OnFontChanged event, so we let our users know that we likely have a
	new font - since Font is an ambient property.
	* ToolStripDropDownItem.cs: When our Font changes, propagate that
	information to our DropDown control, if any.
	Fixes #531515.

2009-08-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: 
	* ThemeWin32Classic.cs: When the user clicks on a new cell, we should reset any
	previous selection, just like .net does. Also, in the cases where a
	cell is being edited and it keeps the selected status, use the normal
	colors for it, and use the selected colors for the rest of the columns of
	that row.
	Fixes the remaining bits of #323051.

2009-08-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When getting ProcessKeyPreview fired, call Edit() if we
	are not editing already - so the edition is actually active on our
	column style textbox. Also, it seems the code handling process the
	grid keys is repeated, but instead of removing it, just comment it for
	now.
	Fixes part of #323051.

2009-08-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* AsyncMethodResult.cs: Store a exception field in case the called
	method actually caused an exception. This way we can throw it later.
	* XplatUIDriver.cs: Check if the async method result has an exception
	- throw it if needed. 
	The idea is that Control.Invoke throws the exception from the thread
	that called it, not the main MWF thread. 
	Patch by Tom Spink <tspink@gmail.com>. Fixes #497175.

2009-08-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: In mouse move we need to shift the selection in case
	the pointer is on the row headers.
	Fixes #323052.

2009-08-11  Ivan N. Zlatev  <contact@i-nz.net>

	* SplitContainer.cs: Avoid updating the splitter distance if it hasn't 
	moved. Updating the distance was causing a re-layout which was resetting 
	the clicks counter and preventing DoubleClick from every firing.
	[Fixes bug #521387]

2009-08-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When a new TableStyle is added, don't create new
	columns for it unless it is empty - this is the correct way to both
	respect the columns if they were provided by our user, or create them
	for him in case the column collection is empty.
	Fixes #323111.

2009-08-10  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* DataGrid.cs: Actually call BindColumns in the handler for
	ListManager.MetaDataChanged, since the current code is already taking
	into account the scenario when a custom table style is used - this was
	confusing us before, and that's why we commented the call to
	BindColumns. Also call CallAreasAndInvalidate, to properly reflect the
	changes as needed.
	Fixes #465021.

2009-08-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When setting the data source, if we have a user
	provided table style available, force a complete bind in case the
	column styles for that table style is empty.

2009-08-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: Handle null and DBNull values.

2009-08-07 Rodrigo Kumpera  <rkumpera@novell.com>

	* ListBindingHelper.cs: Fix the 1.0 build by making this type available
	under that profile.

2009-08-07  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs: Remove duplicate code.

2009-08-07  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewCell.cs, DataGridViewColumn.cs: 
	Massive population performance boost. From seconds to ms.
	[Fixes bug #528887]

2009-08-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: When handling mouse down on a column, don't do any sort
	even if the list supports it if we are empty. This way we avoid an exc
	sorting the empty list, and keep the UI compatible with .net.

2009-08-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGrid.cs: In Edit () check we have any row before trying to use
	the current row. Fixes a IOOR exc with an empty data grid.

2009-08-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataGridColumnStyle.cs: Don't call CheckValidDataSource when setting
	the owner DataGrid - even if this seems to be the right thing to do,
	.net is not doind this check at this point, but in later operations.
	Fixes #465019.

2009-07-28  Mike Gorse  <mgorse@novell.com>

	* ToolStripMenuItem.cs: Added UIA CheckOnClickChanged event.

2009-07-28  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* Application.cs: Make FilterMessage internal for 1.1. Fixes the 1.1 build.

2009-07-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs:
	* XplatUIWin32.cs: We need to filter the messages using
	Application.FilterMessage for our DoEvents implementations. Observe
	that I don't like the idea of XplatUI call the upper level Application
	class, but at this point is easier and simpler to do this call - based
	on the fact it's only one simple call.
	Fixes #516735.

2009-07-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNodeCollection.cs: When removing the selected node, set the
	SelectedNode value of TreeView to null if there aren't more nodes left - 
	this is better than to clear the selected node in Clear, since we need
	to handle the situation in the Remove methods as well.
	Fixes #525002.

2009-07-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripItemCollection.cs: Find should do a case insensitive
	search, and should throw an ArgumentNullException if the parameter is
	an empty string.

2009-07-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* PropertyGrid.cs: Use click handlers for each ToolStripButton instead
	of using a global handler for the ToolStrip. This way the buttons can
	be recovered and can have its PerformClick method called properly.
	Fixes #522454.

2009-07-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Implement support for XdndActionList, so we can get the
	complete list of the supported actions in the drag source, and use the
	action passed in the Position message only as a fallback. This will
	help us with dnd operations with non winforms apps.
	Fixes #402158.

2009-07-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripItemCollection.cs: Use a List<> instead of an ArrayList in
	Find. This should fix the exception we were getting when trying to
	convert the ArrayList to an array of objects (since we were losing the
	type parameter).
	Fixes #519944.

2009-07-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RadioButton.cs: Setting Checked when none of the sibligs is checked
	should happen *not* in GotFocus, but in the Enter event. This is
	specially important since we should get that Checked behaviour even if
	no handle is created yet - and thus, no actual GotFocus call happens at
	the time.
	Fixes #520764.

2009-07-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Adjust manually the top border for out internal
	ComboBox, since removing the border from it leaves it without any
	margin. This is not noticeable in a default ComboBox, but it is in an
	instance shown on top of ToolStrip.
	Fixes the remaining part of #507462.

2009-07-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBoxBase.cs: Expose the margin top width as a property, to keep
	the code clean.
	* ToolStripTextBox.cs: Since we are actually using no border in the
	default TextBox impl, and we are drawing the border ourselves, we need
	to manually set the top margin.
	Fixes part of #507462.

2009-07-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* PrintPreviewDialog.cs: Record when left was pressed, so we can
	simulate Tab+Alt when moving the focus throughout our buttons and
	controls.
	Fixes the remaining bits of #509142.

2009-07-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When computing the width of each tab page, use the
	page's Font instead of the tab control one.
	Fixes #514368.

2009-07-03  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MenuAPI.cs: When handling the Keys.Left key, don't close the menu if
	the current menu is specifically a ContextMenu (this is what .net does
	as well). This way we also avoid a crash caused by MenuTracker trying
	to use the menu when it was already hidden.

2009-07-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* PrintPreviewDialog.cs: Remove the code used to handle the
	DropDown menu, since we are now doing it by default in ToolBar, and
	just call the base impl as needed.Also, deactivate the dropdown menu
	before moving the focus to a different button in our toolbar, as .net
	does.
	* ContextMenu.cs:
	* MenuAPI.cs: Make as internal the needed bits to deactivate a
	ContextMenu, and also to keep some beauty in our api.

2009-07-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolBar.cs: When handling the key down message, if we are on a
	drop down button, either show the DropDownMenu or pass the key to its
	ProcessCmdKey method as needed.
	Fixes the remaining bits of #509985.

2009-06-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolBar.cs: Isolate the event logic related to OnButtonClick. Also
	set current_item when navigating with the keyboard, so we can use it
	properly later. Finally, handle both Enter and Space to fire
	OnButtonClick *only*, without any other impact, as .net does.
	Fixes part of #509985.

2009-06-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MenuAPI.cs: Close any active menu when we get a simple Alt.
	Fixes #509299.

2009-06-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolBar.cs: In OnButtonClick only change the Pushed value for
	buttons with toogle style. We were previously doing it for
	DropDownButton's buttons, but that's not what .net is doing.
	Fixes #510030.

2009-06-26  Atsushi Enomoto  <atsushi@ximian.com>

	* XplatUICarbon.cs : support multi-byte text input.
	  Fixed bug #501276.

2009-06-22  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListBox.cs: When creating DrawItemEventArgs, pass either
	Theme.ColorHighlightText or ForeColor depending on the selected state
	of our item, as .net does.
	Fixes #512115.

2009-06-22  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When handling WM_CHAR, process the message first, and
	send it to the textbox only if it wasn't handled.
	Fixes #507459.

2009-06-18  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Only do my big sort at the end of AddRange if
	the combobox is actually set to Sorted.

2009-06-18 Tom Hindle <tom_hindle@sil.org>
	
	* XplatUIX11.cs: Enabled Text to coexist with custom data formats.
	Fixes #511849.

2009-06-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When calculating the scrollbars for non MultiColumn
	mode, force the use of the horizontal scrollbar only if
	ScrollAlwaysVisible is true as well.
	Fixes #513029.

2009-06-17  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: When using AddRange on a sorted combobox, don't
	try to use our inefficient sorted insert method, just append
	it and sort the whole thing at then end.
	[Fixes bug #511247]

2009-06-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolBar.cs: Expose as internal the code used to show a dropdown menu.
	* PrintPreviewDialog.cs: Handle the down/up arrow keys for our
	DropDown element.
	Fixes #509152.

2009-06-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Scrolling fixes.
	[Fixes bug #512816]

2009-06-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewRowCollection.cs: Clean up a bit and 
	optimize for batch adding rows.

2009-06-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Avoid calling ReBind twice during the initial data 
	binding.
	[Fixes bug #512807]

2009-06-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Suppress invalidation during data binding.
	[Fixes part of bug #512807]

2009-06-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* PrintPreviewDialog.cs: Tune the navigation among the buttons and
	controls that are part of our ToolBar, so we can mimic the behaviour
	observed in .Net, by handling also the arrow keys and doing the
	preprocess for them too.
	Fixes the remaining bits of #509142.

2009-06-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolBar.cs: Expose the current item as internal.
	* PrintPreviewDialog.cs: Tune the TabStop property for
	PrintPreviewControl/ToolBar so we match the .net scenario regarding
	Tab navigation. Also implement support to navigate throughout the
	items in the ToolBar.
	Fixes #509142.

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewComboBoxCell.cs, DataGridViewComboBoxColumn.cs: 
	Implement items syncing in the non-databound scenario.
	[Fixes bug #494031]

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Call OnCellValidating and OnCellValidated and 
	handle the Cancel accordingly.
	[Fixes bug #506838]

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewBand.cs: Fix a typo in DefaultHeaderCellType.
	[Fixes bug #506796]

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewColumnCollection.cs, DataGridViewRowCollection.cs, 
	DataGridView.cs: Fire CollectionChangeAction.Refresh collection 
	changed when Clearing the collections so that the DataGridView 
	can know and reset the current cell.
	[Fixes bug #492549]

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: In ResetBindings use the ListChangedEventArgs ctor 
	with the PropertyDescriptor parameter instead of index, because the 
	latter will set some irelevant indices. Fixes a bug uncovered by recent
	 fix to ListChangedEventArgs.

2009-06-09  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* DataObject.cs: When looking for any specific format, do a case
	insensitive search, as .net does.
	Fixes #509199.

2009-06-09  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs: In AllowNew firstly check if the list is a 
	IBindingList and proxy to AllowNew. IBindingList has slightly differet 
	logic and eventhough it's an IList IsReadOnly should not be used in this 
	case as it might be True but AllowNew could be True as well.
	Fixes a bug uncovered by a fix to the Array class.

2009-06-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBindingHelper.cs: In GetListItemType do a null check when
	looking for IList.Item, since the impl could be explicit, and thus
	private. Fix by Florent Fayolle (p.ricca at odyssee-ingenierie.com).
	Fixes the remaining part of #507120

2009-06-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DataObject.cs: Map StringFormat/Text/UnicodeText formats properly,
	to match them in all the cases, as this is exactly what .net does.
	Fixes #510728.

2009-06-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBindingHelper.cs: In GetListItemType handle gracefully the case
	where an instance of IEnumerator returns a null value for its Current
	property. Fix by Florent Fayolle (p.ricca at odyssee-ingenierie.com).
	Fixes #507120.

2009-06-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Properly detect whether we need to use our vertical
	scrollbar or not, specially for DropDownList/DropDown styles,
	depending on the value of DropDownHeight.
	Fixes #508541.

2009-06-01  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ToolTip.cs: Call the base implementation in Dispose, but do it
	before anything else to avoid a regression. This way we do the default
	routines related to any System.ComponentModel.Container.
	Fixes #508586.

2009-06-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Clipboard.cs:
	* XplatUIX11.cs:
	* DataFormats.cs: Implement support for serializable types in our
	clipboard.
	Fixes #357642.

2009-05-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ColorDialog.cs: Actually add the help button to the form, so it can
	be visible.
	Fixes #478555.

2009-05-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* PrintPreviewDialog.cs: Don't use Dock.Fill for the
	PrintPreviewControl, since it will be hidden in the top by our
	toolbar. Use manual location and anchoring instead.
	Fixes #474889.

2009-05-25  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* FileDialog.cs: When saving the size of the dialog, use the
	ClientSize instead of Size, so we have always the same size for the
	form. Patch by Alex Shulgin.
	Fixes #503064.

2009-05-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MessageBox.cs: When showing the dialog call XplatUI.AudibleAlert to
	show a beep, similar to what .net does. 
	Fixes #473725.

2009-05-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ContainerControl.cs:
	* MenuStrip.cs
	* ToolStrip.cs: Implicit mnemonic processing should happen for every
	ToolStrip child, not only for MenuStrip, so we are going to do that in
	ToolStrip.ProcessMnemonic, where we already had that exactly
	functionality, but we are only just checking that either this instance
	is a ToolStripDropDownMenu instance or Alt has been pressed. Finally
	remove the extra code, since we are not going to use it now.
	Fixes the remaining bits of #503663.

2009-05-21  Neville Gao  <nevillegao@gmail.com>

	* ContextMenu.cs: Cleaned up UIA properties.

2009-05-20  Dick Porter  <dick@acm.org>

	* XplatUICarbon.cs: Add more locking around MessageQueue
	manipulations.

2009-05-18  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* DateTimePicker.cs: Call Focus in HideMonthCalendar to avoid
	duplication of code, as well as actually getting the focus back in
	*any* scenario where the drop down is closed.

2009-05-18 Tom Hindle <tom_hindle@sil.org>
	* ScrollableControl.cs: Ignore setting properties HScroll and 
	VScroll when AutoScroll is true.
	[Fixes bug #500213]

2009-05-18  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripRenderer.cs: Apply patch from Thomas Goldstein to make
	disabled graphics look closer to the ones that .Net produces.
	[Fixes bug #473660]

2009-05-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: When calculating the max width for the year part,
	use the current value, since *all* the possible values are exactly a 4
	digits number. This way we avoid a ArgumentOutOfRangeException trying
	to check against different values.
	Fixes #500917.

2009-05-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MessageBox.cs: When handling ProcessDialogChar, check that
	CancelButton is not null before trying to use it, to avoid a null ref
	exception. We don't need to do that on the ok/yes buttons, since they
	always exist.
	Fixes #503935.

2009-05-15  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListBox.cs: Handle the key down event in WndProc instead of doing it
	in an event handler, as we need to avoid any operation in case
	the user has handled it in its own OnKeyDown handler, and this can't
	be achieved since our handler would be the first one always.
	* FontDialog.cs: Update the calls since our method handling key down
	has been renamed.
	Fixes #503469.

2009-05-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Application.cs: We should dismiss the active ToolStrip when we
	receive a WM_SYSKEYDOWN message, instead of WM_SYSKEYUP, so the next
	keyboard short cut can be properly processed by another menu item.
	Fixes part of #503663.

2009-05-13  Andreia Gaita  <avidigal@novell.com>

	* HtmlDocument.cs: If the objects are strings, wrap them in ""

2009-05-13  Andreia Gaita  <avidigal@novell.com>

	* HtmlDocument.cs: Fix InvokeScript call (duh).

2009-05-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Expose IsAutoCompleteAvailable as internal.
	* ComboBox.cs: If auto complete is being used, it is needed to update
	the actual value of the combo box, doing it immediately if the user
	presses Enter, or doing it when our combo box loses focus. Finally,
	when handling Enter and Escape keys for the combobox, don't try to
	hide the listbox if it is not visible in the first place. 
	Fixes part of #489339.

2009-05-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripDropDownMenu.cs: Use the height returned by
	ToolStripItem.GetPreferredHeight to calculate our own height.

2009-05-10  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* TreeNode.cs: When setting Checked, do a double null check, since the
	current node can still get a null parent handling
	TreeView.OnAfterCheck.
	Fixes #502567.

2009-05-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs: When assigning ContextMenu, do a null check before
	assigning its container field.

2009-05-08  Brad Taylor  <brad@getcoded.net>

	* DateTimePicker.cs: Add a UIA-specific property to ensure that if
	is_checkbox_checked is changed, we won't break.

2009-05-08  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolStripItem.cs: Prevent NRE when our holder is a
	ToolStripDropDownButton and we get Select()ed.

2009-05-08  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ToolStripControlHost.cs: DefaultSize must return the current size of
	the Control, not the value returned by GetPreferredSize. Also connect
	a handle to the control Resize event, and use it to fire
	OnHostedControlReize.
	Fixes the remaining bits of #483146.

2009-05-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripDropDown.cs: When performing the layout, use
	ToolStripItem.GetPreferredSize ().Height instead of
	ToolStripItem.Height, since we are already using it that way in this
	same method.
	Fixes part of ##483146.

2009-05-08  Brad Taylor  <brad@getcoded.net>

	* DateTimePicker.cs: Wrap UIA specific code in NET_2_0 wrappers.  Send
	OnUIASelectionChanged when ShowCheckbox is true and the checkbox
	recieves focus.  Part of fix for #502029.

2009-05-06  Mike Gorse  <mgorse@novell.com>

	* FileDialog.cs: Add UIAFocusedItemChanged to PopupButtonPanel.
	Add PerformClick and PerformDoubleClick to PopupButton.
	Fixes #499851.

2009-05-04  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* TabControl.cs: call Focus() to emit GotFocus event at the
	proper time when SelectionIndex changes. Fixes #499887.

2009-05-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MonthCalendar.cs: In SetBoundsCore always do the bounds check to
	have valid values, even if BoundSpecified is not including
	Size/Height/Width - this is useful when we are in a control using Dock
	or Anchor.
	Fixes part of #483146.

2009-04-27  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When losing the focus, if our textbox is not null,
	close its auto complete list, if any.
	Fixes part of #489339.

2009-04-27  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ListView.cs: Make OnColumnClick +internal to be used by a11y.

2009-04-27  Brad Taylor  <brad@getcoded.net>

	* ToolStripButton.cs: Emit an internal event when CheckOnClick is
	changed.

2009-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* XplatUIX11.cs: Properly support UTF8 when handling the
	SelectionRequest event - this is helpful supporting some window
	managers, such KDE, that explictly request the text in utf8, as
	opposed to gnome, that supports ascii.
	Fixes #489393.

2009-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripDropDownItem.cs: When assigning a new
	ToolStripDropDownMenu, let it know we are its OwnerItem. This way the
	Capture duties performed by Application/ToolStripManager are handled
	nicely and we don't end up in an inconsisten stat.
	Fixes #492815.

2009-04-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStrip.cs: Even if we are not exactly a MenuStrip instance, close
	any ToolStripDropDownItem when receiving a mouse down event in an
	empty area.

2009-04-24  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: add UIA events for style and dropdownmenu changes.

2009-04-24  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: rename a method to include UIA prefix.

2009-04-24  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: change visibility of some UIA methods from
	protected virtual to private.

2009-04-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStripDropDown.cs: In OnVisibleChanged, if we have an OwnerItem,
	fire OnDropDownOpened/OnDropDownClosed depending on the new
	visibility. This also ensures that any direct access to this instance
	will fire the mentioned events for the OwnerItem.
	* ToolStripDropDownItem.cs: Remove the invocations to
	OnDropDownOpened/OnDropDownClosed, since they are handled in
	ToolStripDropDown, as well as updating the
	OnDropDownHide/OnDropDownShow calls to be in the right order.
	Fixes #496193.

2009-04-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs, ContextMenuStrip.cs, ToolStripMenuItem.cs: Only process any 
	shortchut in ToolStripMenuItem.ProcessCmdKey if the control generating the 
	event is the same as the owner of the menu item. Also set properly 
	SourceControl for ContextMenuStrip, as well as add an internal field to 
	contain the control that owns the ContextMenuStrip (we need to know this 
	even before the public property is assigned).
	Fixes bits of #393775.

2009-04-20  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* StatusStrip.cs: Use the same icon as .net when the mouse is over the
	size grip.
	Fixes #492828.

2009-04-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When calculating the height of the ComboListBox,
	specially for the 2.0 profile, use MaxDropDownItems if the
	DropDownHeight property hasn't been set, and use the later if it has
	been set. This way we support both properties.
	Fixes #493308.

2009-04-14  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ThreadExceptionDialog.cs: Draw the error icon, previously missing.
	Fixes #474253.

2009-04-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ContainerControl.cs: Implement support for Control.CausesValidation,
	by adding a pending list of controls to be validated in the top
	container control, and postpone validation as needed. 
	Also remove any control in the validation chain in case it gets removed 
	from its owner before the pending validation actually happens.
	Fixes #457170.

2009-04-09  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListBox.cs: The default instance StringFormat field used to draw our
	items should use the StringFormatFlags.NoWrap value, so it doesn't try
	to put in a different line the text that doesn't fit our bounds, but
	show it partially.
	Fixes #475581.

2009-04-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* CheckedListbox.cs: When executing OnItemClick check that the index
	is different to -1 before trying to retrieve an item using that value.
	Fixes a ArgumentOutOfRangeException thrown when the horizontal
	scrollbar was visible but not needed, and then a clicked was received
	on its area.

2009-04-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: If Insert is pressed, change the internal
	overwrite mode for our default value.
	Fixes some bits of #477395.

2009-04-06  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: In EnsureVisible avoid any direct access to items if we
	are using virtual mode - otherwise use the bounds stored in a specific
	item in a given index. This is specially important when using groups
	or when items are re-arranged, since the position in the items
	collection can be different than that one being displayed.
	Fixes the rest of ##491978.

2009-04-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: Include the previous check for ListView in a
	2.0 define as needed.

2009-04-06  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ThemeWin32Classic.cs: Don't draw ListView's gridlines if we are using groups.
	Fixes part of #491978.

2009-04-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolTip.cs: New fields to store the title/icon information.
	* ThemeWin32Classic.cs: Implement support for tooltip's title and
	icon.
	Fixes #491978.

2009-04-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When removing a tab that was previously selected, set
	internally the value of selected_index to -1, to avoid trying to
	access the previous one when trying to set the new one (and was
	already removed from the collection). This is what .net seems to do
	too.
	Fixes #490937.

2009-04-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs, X11Clipboard.cs: Text and Rtf formats must be
	separated, and we cannot fallback on Text if Rtf is requested but not
	present.
	* Clipboard.cs: Actually use the format specified by our user when
	putting data.

2009-03-31  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Clipboard.cs: Actually look for the RtfText format when calling
	GetRftText in our clipboard formats list, instead of using the
	generical Text format.

2009-03-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Process auto completion properly when we are using the
	internal source provided by ComboBox, and also remove some repeated
	checks.
	Fixes #489339.

2009-03-30 Tom Hindle <tom-hindle@sil.org>
	
	* DataGridView added Support for Invisible Columns to 
	AutoFillColumnsInternal method.

2009-03-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Structs:
	* X11Clipboard.cs: Move internal ClipboardStruct from X11Structs to
	its own file, since it is adding some functionality and thus is not a
	simple struct as before.
	* XplatUIX11.cs: Add support to store different formats that could
	have been specified by the user when puting data in the Clipboard -
	this is important when more than one format is supported (such plain
	text and rtf text). Update in the needed places, as well as simplify
	the code.
	Fixes #489625.

2009-03-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When handling the SelectionRequest event, use
	SelectionRequestEvent instead of SelectionEvent, so we get the right
	data for the app asking for clipboard data. Set the member of
	SelectioneEvent.property to indicate the place where we are storing
	the information as well - this is specially important for gnome/kde
	apps using the TARGETS atom to ask for the supported permission before
	actually asking for a specific format.
	Fixes #489393.

2009-03-28  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: We don't support drawing all types of cell borders, 
	so fallback and at least draw something instead of nothing.

2009-03-27  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: If the column header isn't visible allow resizing 
	using the cell column border. Also be sure to reset the cursor properly.
	[Fixes bug #489929]

2009-03-26   Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ToolStrip.cs: When disposing, iterate over the items in reverse
	order, since disposing the items modifies the collection.
	* ToolStripItem.cs: Remove from the owner when disposing.
	Fixes #485769.

2009-03-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Add an implementation for UpdateRowHeightInfo. No 
	longer throws a NotImplementedException.
	  Based on a patch by Tom Hindle <tom_hindle@sil.org>
	[Fixes bug #488319]

2009-03-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Implement IsCurrentRowDirty. No longer throws 
	NotImplementedException.

2009-03-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewColumn.cs, DataGridViewTextBoxColumn.cs: 
	Fix SortMode clash handling.
	[Fixes bug #488263]

2009-03-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not show the vertical scrollbar if there is only 
	one row or less. For the sake of MSNET compatibility.
	[Fixes bug #487988]

2009-03-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: When the current cell is moved out of the editing row 
	be sure to reset it back to a place holder row.

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: If IsHandleCreated and the very first row is added 
	to the grid in a non-databound scenario - select the first cell.
	[Fixes bug #486881]

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: If we are not databound and empty once the first row 
	gets added select the first cell.
	[Fixes bug #486881]

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewColumn.cs: Do not set Row/CellTemplate's
	DataGridView. They do not belong to a DataGridView.
	[Fixes bug #486645]

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCellCollection.cs, DataGridViewColumnCollection.cs: 
	Set indices and associate with DataGridView only after the item is 
	add to the internal list.
	[Fixes part of bug #486645]

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not add any cells to the FullRowTemplate in RowCount. 
	FullRowTemplate already contains all the cells.
	[Fixes part of bug #486645]

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewCellCollection.cs: Split the column removal 
	to perform Pre and Post removal actions to allow the current cell to be 
	moved and all events fired properly before the column is removed.

2009-03-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewRow.cs: Split the row removal to perform Pre and 
	Post removal action to allow the current cell to be moved and all events fired 
	properly before the row is removed.

2009-03-18  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fire CellEnter and CellLeave events for the Cell.
	[Fixes bug #486640]

2009-03-18  Jonathan Pobst  <monkey@jpobst.com>

	* XplatUICarbon.cs: Commit patch from Alex Shulgin that fixes window
	placement of popup windows on OSX.

2009-03-18  Matt Guo  <matt@mattguo.com>

	* FontDialog.cs: Override "ToString" for FontDialog.ColorComboBox.ColorComboBoxItem
	[Fixes bug #482690]

2009-03-18  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Implement the CellMouseDoubleClick event.
	[Fixes bug #486262]

2009-03-18  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix scrolling to take into account that the 
	scrollbars are actually inside the client area of the datagridview.

2009-03-18  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Implement mouse wheel scrolling.
	[Fixes bug #486159]

2009-03-17  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: When DataSource changes the rebinding should happen 
	not if IsHandleCreated but if BindingContext != null.
	[Fixes bug #486013]

2009-03-17  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Browsable(false) properties should be skipped when 
	autogenerating the columns.
	[Fixes bug #486021]

2009-03-16  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* DomainUpDown.cs: When ReadOnly is true, all the text entered by the
	user should use a different handling, trying to use every pressed char
	as a unique and only one prefix to compare against the items. Also,
	refactor some input check code to avoid duplication.
	Fixes #458607.

2009-03-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: In OwningColumng Handle invalid column index 
	silently.
	[Fixes bug #485278]

2009-03-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewBand.cs: Update our State whenever a property changes.
	* DataGridView.cs: Don't be so generous in reseting Displayed, because 
	it will spawn lots and lots of unneeded State changed events.
	[Fixes bug #484989]

2009-03-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewRow.cs, DataGridViewColumn.cs: 
	Add support for invisible rows and columns.
	[Fixes bug #484951]

2009-03-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: Escape literal { in ToString.
	* DataGridViewTextBoxCell.cs: Fix ToString.
	[Fixes bug #484923]

2009-03-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MenuAPI.cs: When navigating items using the keyboard properly handle
	the case when no item is selected - this way we should try to select
	the first or the last item depending on the direction, but no the
	second or third one, etc.

2209-03-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Form.cs: When calling ProcessCmdKey, just after checking for any
	MainMenu, check if there's an active ContextMenu that is *not* owned
	by the form - this is needed when a non-focusable control owns a
	ContextMenu but its ProcessCmdKey method can't be called since it
	can't receive any input.
	Fixes #477655.

2009-03-13  Neville Gao  <nevillegao@gmail.com>

	* ToolBar.cs: Sent ButtonClick events when button style is DropDown.
	* ContextMenu.cs: Add UIA Framework property UIAVisible to detect if
	ContextMenu is displayed.

2009-03-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: In GetMessage when F1 gets pressed, besides sending a
	WM_HELP message for the associated window, don't call
	NativeWindow.WndProc *at all*, since this could send a WM_*
	key-related to Control.WndProc. Also, return the keypress message, in
	case it needs to be preprocessed for any menu.
	Fixes #478476.

2009-03-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: When removing the first displayed row and moving 
	the current cell up one we must invalidate the first displayed row 
	index before calculating the row heights, etc.
	[Fixes bug #483202]

2009-03-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix three column bugs:
	   - Rows should be cleared (but not removed) if columns become 0.
	   - The current cell should get moved
	   - ColumnCount increase was adding too many columns.

2009-03-07  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix RowCount decrease which wasn't working well 
	in both scenarions - with and without editing row.

2009-03-06  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Be compatible with MS in that the scroll to 
	selection has a synchronous effect. The trick here is that in 
	order to avoid unnecessary calculations each time a row/column 
	is added/removed we recalculate the whole grid size just before 
	just before the scroll to selection.
	[Fixes bug #482478]

2009-03-06  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* RichTextBox.cs: LoadFile(string path) should pass by default
	RichTextBoxStreamType.RichText, without caring about the detection or
	extension of the file.

2009-03-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When calling LoadFile, remove the extra EOL
	introduced by StreamReader, since it will convert the EOF to an EOL.
	Fixes #479646.

2009-03-06  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownMenu.cs: Use Math.Max instead of calculating
	preferred size twice.

2009-03-06  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripMenuItem.cs: Don't draw the dropdown arrow or shortcut
	string if we aren't on a ToolStripDropDownMenu.

2009-03-06  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownButton.cs, ToolStripItem.cs: Refactor some Button
	code from Item to Button.  Patch from Alex Shulgin.

2009-03-05  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDrowDown.cs: Remove some hardcoded values and assumptions.
	* ToolStripDropDownButton.cs: This should use a ToolStripDropDownMenu,
	not a ToolStripDropDown.
	* ToolStripItem.cs: Don't use the item margins on a ToolStripDropDown.

2009-03-04  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix RowCount/ColumnCount decreasing.

	  Based on a patch by Tom Hindle <tom_hindle@sil.org>
	  [Fixes bug #482133]

2009-03-04  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewElement.cs: 
	   - Always calls OnDataGridViewChanged() if the new DGV is 
	   not the same/null as the current one.
	   - Do not throw NREs when setting TopLeftHeaderCell to null
	   - Unset the DGV for TopLeftHeaderCell when replacing it
	  Based on a patch by Tom Hindle <tom_hindle@sil.org>
	  [Fixes bug #481681]

2009-03-04  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDown.cs: When dismissing control due to ESC, don't
	hit a NRE if we are a ContextMenuStrip and do not have a parent.
	[Fixes bug #478616]

2009-03-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When removing items from a ListViewItemCollection
	contained in ListView (not in ListViewGroup), before actually removing
	the items remove them also from their -if any- associated groups. If
	the item is present in ListViewGroup.Items but not in ListView.Items,
	then don't remove it - this is *exactly* what .net seems to do.
	Fixes the remaining bits of #478689.

2009-02-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: In our MouseDown handler in ItemControl use the item in
	the very specific *real* position where the mouse was pressed, using
	GetItemAtDisplayIndex for that purpose, instead of directly accessing
	Items - this is specially useful when groups with Details view is
	used. This is what we do in other places when using groups.
	Fixes part of #478689.

2009-02-27  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MaskedTextBox.cs: Properly replace selection when a new valid key
	is pressed - even when IsOverwriteMode is false. This is what .net
	does.

2009-02-27  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: When setting Text and RejectOnFirstFailure is
	true, use MaskedTextProvider.Set instead of MaskedTextProvider.Replace, 
	since Set will keep the previous value in case of error (just what we
	need), but still call MaskedTextProvider.Clear if
	RejectOnFirstFailure is false - match .net.

2009-02-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: When setting Text use the very precise algorithm
	that .net uses: iterate over every char of the new value, trying to
	use every char, and use a normal call to MaskedTextProvider.Replace
	call if RejectInputOnFirstFailure is true. Fire OnMaskInputRejected 
	in case of error in both cases, as well.
	Fixes #477408.

2009-02-25  Neville Gao  <nevillegao@gmail.com>

	* ColorDialog.cs: Added UIA Framwork Property:
	UIASelectedSmallColorControl.

2009-02-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: Forgot to update the call of the new method
	introduces in the previous patch.

2009-02-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: Handle OnKeyDown to properly process the Delete
	key. Also create a new method to avoid code duplication between
	OnKeyDown and OnKeyPress.
	Fixes #477388.

2009-02-24  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: Invalidate the datagrid when the cell is selected 
	or deselected.
	[Fixes bug #479124]

2009-02-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: In OnKeyPress the IsOverwriteMode check is
	actually inversed, so put it the right way. Also, don't automatically
	look for the next editable item after adding a new one, but way for
	the next insertion (this is what .net does) - this is not needed when
	MaskedTextProvider.InsertAt is called however, since it already looks for the
	next editable position.
	Fixes the remaining bits of #477383.

2009-02-23  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MaskedTextBox.cs: In OnKeyPress handle backspace by calling
	MaskedTextProvider.RemoveAt method. Also for setting the SelectionStart
	property after the text was modified, adjust the testPosition value
	depending on what method was called.
	Fixes part of #477383.

2009-02-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: For EnsureVisible, adjust the view port bounds based on
	the existence of the column headers, as well as using this information
	to adjust the vscrollbar value, so items never get hidden by the
	column headers.
	Fixes #478498.

2009-02-23  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Make the ScrollBars property work properly.

2009-02-22  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Some code lifting for AutoComplete's support. First,
	when handling non-navigation keys, save the original Text typed by the
	user, and don't motify it BEFORE. This was a design mistake, since the
	re-assignation happens only when navigating the append/suggest list,
	not while creating the matches. Also, process the Delete key just like 
	the backspace one. Finally, when handling WM_CHAR, ignore both Escape
	and Enter keys.
	Fixes some missing bits of #469967.

2009-02-22  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix row removal in the data-bound scenario.

2009-02-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: Use strict equality comparison in order to 
	prevent superfluous CellValueChanged events.

2009-02-19  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not reset the columns when the data list changes, 
	but only the rows. Fixes multiple bugs related to sorting, custom 
	column styles being reset and more.

2009-02-19  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Respect a PictureBox's Padding when
	drawing the image.

2009-02-18  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: Oops, use the correct event (fix r127298).

2009-02-17  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: Event for Enabled property (needed to fix
	  UIA #474197).

2009-02-16  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* TextBox.cs: When handling WndProc with autocomplete activated,
	event if the new text is not causing any change in the look up
	algorithm, save it as we normally do when numbers and letters.
	Fixes #469967.

2009-02-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNode.cs: When Text/StateImageIndex/StateImageKey/NodeFont change
	Invalidate the proper bounds in the TreeView, not only resetting the
	width.
	Fixes #475542.

2009-02-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNode.cs: Don't return TreeView.BackColor when retrieving our own
	BackColor property. This is what .net does in both 1.1 and 2.0.
	* TreeView.cs: When selected_node is not the same as highlighted_node,
	we need to handle the back color in a different way, trying to use the
	node's BackColor if it's not Color.Empty.
	Fixes #464200.

2009-02-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When canceling selection in our MouseUp handler,
	invalidate also the previous selected node bounds.
	Fixes #464191.

2009-02-07  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: End or if end fails then cancel the current edit 
	operation before clearing the data source.

2009-02-07  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Data-bind only after the handle is created.
	[Fixes bug #473680]

2009-02-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When handling the MouseMove event, check if
	focused_node and selected_node fields are null - usually they are non
	null, since we have always a selected node, but canceling selection by
	handling BeforeSelect event leaves the two of them as null.
	Fixes #470451.

2009-02-06  Neville Gao  <nevillegao@gmail.com>

	* TabControl.cs: Control enabled to support accessibility.
	[Fixes Bug #472428]

2009-02-05  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewRowCollection.cs, DataGridView.cs: Fix row insertation: 
	   - Use ArrayList.Insert instead of the Item property so that the item 
	   is actually inserted and not an existing item replaced.
	   - Call DataGridView.OnRowsAddedInternal and drop internal from 
	   OnRowsAdded for binary compitability. This also fixes several 
	   redrawing issues.
	[Fixes bug #472968]

2009-02-05  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: Doh, fire OnUIATextChanged *after* setting
	  the value.

2009-02-04  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton.cs: Add another event (OnUIATextChanged).

2009-02-04  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBarButton: Fix typo in previous commit (r125704).

2009-02-04  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBar.cs, ToolBarButton.cs: Add new UIA events to know
	when a button gets focus, firing the events from the ToolBar.
	r: jpobst

2009-02-04  Mario Carrion  <mcarrion@novell.com>

	* ColumnHeader.cs: Raising ListView.ColumnWidthChanged when setting 
	Width.
	* ListView.cs: Internal method added: RaiseColumnWidthChanged, used by
	ColumnHeader to raise ColumnWidthChanged.
	[Fixes Bug #467086]

2009-02-03  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewRowCollection.cs, DataGridView.cs: Move row completion 
	code in the row collection code, so that the completion happens before 
	the CollectionChanged event, also better encapsulation.
	[Fixes bug #471987]

2009-02-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: When editing is finished do not remove the editing 
	row, because it has already become a real one. Instead add a new one.
	[Fixes bug #471754]

2009-02-02  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* TreeView.cs: When drawing the node's image, check that the index
	specified by the node is valid for the ImageList.
	Fixes #471094.

2009-02-02  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ToolBar.cs: Add new UIAPerformClick method to be called by
	UIAutomationWinforms when someone calls Invoke() on the
	ToolBarButtonProvider. r: jpobst

2009-02-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Don't send a WM_SHOWWINDOW message when receiving
	MapNotify/UnmapNotify events - we are already firing those events in
	the proper places, so we avoid this way to send the same message two
	times. I'm leaving the handling code in case we could break something
	in the future, as this change seems dangerous (but needed).
	Fixes #467546.

2009-02-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Complete incomplete rows when they are added to 
	the grid.
	[Fixes bug #471068]

2009-02-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewColumnCollection.cs: Ensure that the 
	binding is cleared prior to setting it to null. Fixes a regression 
	causing exceptions when the DataSource is set to null and then set 
	again to a data source.

2009-02-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewImageColumn.cs, DataGridViewCell.cs: 
	   - Make Image/Bitmap cells work.
	   - Handle images with size greater than the cell.
	   - Default to MiddleCenter alignment for image cells.
	[Fixes bug #471101]

2009-01-30  Ivan N. Zlatev  <contact@i-nz.net>

	* UpDownBase.cs: Force Height to PreferredHeight.

2009-01-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: We should use utf8 handling clipboard transference
	with other x11 applications, and use utf16 when handling clipboard
	data in the class library. Update the related points as well.
	Fixes #468683.

2009-01-28  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: Format strings according to the supplied 
	CellStyle.Format.
	[Fixes bug #470384]

2009-01-28  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Reset the hover cell if it gets moved due to row(s) 
	addition or removal. Fixes multiple crashes in OnMouseMove.

2009-01-27  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix a NRE when setting the CurrentCell to null.

2009-01-27  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Fire Timer.Tick even if there is no MainForm for the 
	current context.
	[Fixes bug #469239]

2009-01-26  Andreia Gaita  <avidigal@novell.com>

	* WebBrowser.cs: fix initial value of ScrollbarsEnabled, so they
	won't be disabled by default.
	Fixes #468690

2009-01-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not clear the rows if we are not databound.

2009-01-26  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not be too smart about selecting the first cell 
	when the first row is added as this is not what MS does. Fixes the 
	failing unit tests.

2009-01-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeNode.cs: NextVisibleNode and PrevVisibleNode properties don't
	take into account the fact that OpenTreeNodeEnumerator needs to call
	MoveNext/MovePrevious to actually put the passed node as the one
	retrieved in Current. This way this property should work as really
	expected in .net.
	Fixes part of #467225.

2000-01-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When calculating the scrollbars, don't use
	TreeNode.Bounds, since it still can have the values of the previous
	-and now invalid- layout -which depends on TreeView.skipped_nodes, and
	could not have been updated as well-, and use the actual number of
	visible number of nodes to compute the height needed to contain all
	the nodes. Also reset the value of vbar to 0 when disabled - this way
	we make sure that, when re-enabled, it will update the visible area of
	the treeview, even if the previous value before disabling it is the
	same as now. Finally don't do anything for the vbar.ValueChanged
	handler - for the case wheer we manually set the value but don't the
	vbar is disabled already.
	Fixes part of #467225.

2009-01-23  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStrip.cs: Switch from foreach to for, in case the collection
	somehow changes while enumerating it.

2009-01-23  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewCell.cs: Fix crashes when there is no 
	editing control.

2009-01-23  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix new row adding/editing in the non-databound 
	scenario.

2009-01-21  Mike Gorse  <mgorse@novell.com>

	* TrackBar.cs: Make LargeIncrement/Decrement internal so that UIA can
	  use them.
	  Added UIAValueParamChangedEvent.

2009-01-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: In CollapseAll, set vbar to the maximum value, instead
	of trying to set as top node the highest parent of the previous top
	node. Moving to the bottom of the TreeView after a call to CollapseAll
	is exactly what .net does. This should avoid some nasty issue when
	CollapseAll is called and we don't need the vertical scroll bar.

2009-01-21  Mario Carrion <mcarrion@novell.com>

	* Form.cs: UIA Support: Internal events added: UIAWindowStateChanged
	and UIATopMostChanged.

2009-01-21  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* MenuItem.cs: Add UIACheckChanged, UIARadioCheckChanged,
	UIAEnabledChanged, and UIATextChanged events.

	* Form.cs: Add UIAMenuChanged event.

	* Menu.cs:
	* MenuAPI.cs: Note which internal APIs are being used by UIA.

2009-01-21  Neville Gao  <nevillegao@gmail.com>

	* ToolBar.cs: Control enabled to support accessibility.
	[Fixes Bug #455950]

2009-01-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When handling mouse up event, check whether
	highlighted_node is null or not - usually it should be non-null
	alwaays, since the mouse down handler sets it, but some externa
	operations, such TreeNodeCollection.Clear, could set it to null.
	Fixes #438650.

2009-01-19  Ivan N. Zlatev  <contact@i-nz.net>

	* ThemeWin32Classic.cs: Draw the menu item shortcut even if the menu 
	item is disabled.

2009-01-19  Ivan N. Zlatev  <contact@i-nz.net>

	* MenuAPI.cs: Do not handle shortcuts if the menu item is disabled.
	[Fixes bug #467285]

2009-01-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MonthCalendar.cs: When handling the selection changes using the
	mouse, don't set SelectionRange if the selection range didn't actually
	change. This matters because, even if we set the range to the same
	previous range, an extra DateChanged event is fired. Just to be clear:
	SelectionRage property doesn't check whether the new value is
	different to the previous one (by ref equals doesn't work here).
	Fixes other bits of #364914.

2009-01-19  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MonthCalendar.cs: Remove the extra OnDateChanged call when handling
	selection using the keyboard, since we are already firing this event
	when setting SelectionRange. Also don't set SelectionRange if the
	previous and the new value are the same (the property, just as .net
	does, doesn't check whether the previous value and the new one are the
	same). This saves us from firing OnDateChanged event if the selection
	range didn't change actually.
	Fixes the remaining bits of #364914.

2009-01-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When removing an item and the last item is selected,
	remove it from the selection, and if selection mode is One try to
	select the new last item.
	Fixes #465422.

2009-01-16  Mike Gorse  <mgorse@novell.com>

	* Splitter.cs: Make MaxSize internal so that UIA code can use it.

2009-01-16  Mario Carrion <mcarrion@novell.com>

	* ColumnHeader.cs: UIA Support: raising internal event UIATextChanged 
	when changing Text. 

2009-01-16  Carlos Alberto Cortez <calberto.cortez@ggmail.com>

	* X11Structs.cs:
	* XplatUIX11.cs: Properly encode/decode the unicode strings we
	store/retrieve in the Clipboard. Also, since we try to convert the
	data to different formats, separate the source and the result of
	it, so we can always fallback to the original and don't mix wrong
	conversions.

2009-01-16  Mike Gorse  <mgorse@novell.com>

	* TextControl.cs: Add UIASelectionChanged event.

2009-01-16  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Forward the first key events to the editing control.
	[Fixes bug #457307]

2009-01-14  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* Application.cs: Oops, launch the copied handler of PreRun instead of
	the global one (gendarme would bark otherwise). (Improving r123375)

2009-01-14  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* XplatUI.cs:
	* Application.cs: Move the PreRun event fire to the end of the XplatUI
	static ctor (we don't move the PreRun event to this class because its
	usage would cause the call to the static ctor). This way we can get
	a11y support for dialogs that run without App.Run.

2009-01-14  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* ListView.cs: New internal property to know the inner array's length of
	the location of items, in order to avoid a try-catch strategy for the
	case when this array has not been resized yet (for reference, look at
	r123288). r: jpobst

2009-01-13  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* Application.cs: Simplify UIA initialization, reducing it from 4 to 1
	reflection calls. This requires UIAutomationWinforms r123213.

2009-01-12  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MonthCalendar.cs: Detect selection changes in MouseDown/MouseMove
	handlers and fire the DateSelected event until MouseUp is reached,
	like .net does, instead of firing it for each mouse event.
	Fixes part of #364914.

2009-01-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TreeView.cs: When the selection gets canceled using the BeforeSelect
	event, invalidate the previous highlighted_node bounds, to show the
	user that the item was *not* selected.
	Fixes #464191.

2009-01-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Separate some scroll logic: setting SelectedIndex, as
	well as -in DropDown and Simple modes- writing in the textbox should
	try to set the requested item as the top one, but navigating with the
	keyboard and handling mouse selection don't need that behaviour. Also,
	when resetting selected_index handling key press events, reset
	ComboListBox.HighlightIndex. 
	Fixes the remaining bits of #464188.

2009-01-11  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix crashes when shortcut keys are pressed, but 
	there are no cells:
	   - CurrentCellAddress should be -1, -1 and not 0, 0.
	   - Be tolerant and fall back to clearing the current cell if either 
	   column or row is -1 in MoveCurrentCell.
	   - Misc. more -1 checks.

2009-01-11  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Preserve the column index. Fixes a regression 
	introduced by the data binding position tracking code.

2009-01-11  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: If the bottom of the row matches the client height 
	do not regard the row as partially visible. Fixes the weird scrolling 
	when there is no scrollbar.

2009-01-11  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewComboBoxCell.cs: Implement/Fix the data binding.

2009-01-09  Mario Carrion  <mcarrion@novell.com>

	* MessageBox.cs: Fixed internal UIAIconRectangle property.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCheckBoxCell.cs: Respect the ReadOnly state of the Cell.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Track the Position in the CurrencyManager.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Implement data-bound new item editing/addition.
	* DataGridViewRowCollection.cs: Make it possible for us to internally 
	remove the edit row.
	[Fixes bugs #457107, #457308, #325240]

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs: Even if Position is set to a greater value than the 
	list count reset it to position of the last item.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: AddNew doesn't set index/add_pending for IBindingList. 
	Fix that in order to make CancelNew to work.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: When adding a new item try to delegate to the internal 
	list first before throwing an exception.

2009-01-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When setting the text and adjusting the top_item, do it
	*only* if the current item is *not* visible already.
	Fixes part of #464188.

2009-01-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Requesting the CurrencyManager for the first time can 
	lead to unexpected OnBindingContextChanged calls and recursive rebinding. 
	Fix that.
	[Fixes bug #464493]

2009-01-08  Brad Taylor  <brad@getcoded.net>

	* ComboBox.cs: Expose a few private fields as internal UIA properties.

2009-01-07  Mario Carrion <mcarrion@novell.com>
	
	* DataGrid.cs: CWL removed.

2009-01-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RadioButton.cs: When setting Checked, we should first update the
	check state of the current RadioButton, as well as invalidating it,
	and after that actually update the siblings. This is done to match
	.net.
	Fixes the remaining bits of #463028.

2009-01-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RadioButton.cs: Setting Checked to false should set TabStop to stop
	as well. Also, when we get the focus and no other RadioButton is
	selected in the parent control, we should mark ourselves as Checked.
	Fixes part of #463028.

2009-01-05  Mario Carrion <mcarrion@novell.com>

	* DataGrid.cs: UIA suppport. internal events: 
	UIAGridCellChanged, UIAColumnsHeadersVisibleChanged, 
	UIASelectionChanged, UIACollectionChanged. Internal properties: 
	UIARowHeight, UIACellsArea, UIACaptionArea, 
	UIAColumnHeadersArea, UIASelectedRows, UIACurrentTableStyle, 
	UIAVScrollBar and UIAHScrollBar.

2009-01-05  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripSplitStackLayout.cs: Enable the overflow button if any
	of the buttons are set to Overflow = Always.
	[Fixes bug #463013]

2009-01-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingNavigator.cs: Properly enable/disable the toolstrip buttons,
	based on whether the binding source is availble or not. Fixes #463008.

2009-01-03  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs: We should return a value even if we are not bound 
	to a DataGridView.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs, DataGrid.cs: 
	   - Rename CanAddRows to AllowNew. The CurrencyManager has no 
	   concept of "rows".
	   - Add two more internal properties AllowRemove and AllowEdit.
	* DataGridView.cs: Refactor in a data-bound situation AllowUserToAddRows, 
	AllowUserToDeleteRows and cell ReadOnly state to be also checked against the 
	CurrencyManager data source.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix crashes caused by assigning negative values to 
	ScrollBar.LargeIncrement when the ClientSize.Width/Height is less than 
	the column/row heights/widths.
	[Fixes bug #462684]

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Non-autogenerated columns that have a data property 
	set that exists in the current datasource should be set to be data-bound.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix column sorting for columns containing null 
	values. A "null" value is not always "null" (e.g could be String.Empty) 
	and thus parsing numeric types throwed an exception for "null" values.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Detach the editing control when the edit is 
	finished.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Multiple fixes to handle last column/row removal 
	and cell movement after that instead of throwing exceptions.

2009-01-02  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCellCollection.cs: When cells are removed the column 
	indices become invalid if the cell is not the last one and have to 
	be refreshed.

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Return false in CommitEdit if there was an error.

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Remove a leftover Console.WriteLine.

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewRow.cs: Access the indexer of the data manager directly 
	instead of the internal list.

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCell.cs, DataGridView.cs, DataGridViewCheckBoxCell.cs: 
	Rewrite the value getting, setting, parsing, formatting logic:
	   - If data-bound value get/set should actually get and set from the 
	     data source.
	   - Make proper usage of TypeConverters for value parsing/formatting.
	   - Raise DataError if setting the new value fails.
	   - Get rid off the internal valueType field and get/set the ValueType 
	   property instead.
	[Fixes bug #462051]

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Rewrite the DataBinding layer:
	   - Get rid off all BindingSource/IBindingList/DataSet/DataTable 
	   specific code.
	   - Get rid off the per DataSource type column autogeneration code.
	   - Use the CurrencyManager for everything that is DataBinding related.

2009-01-01  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs: Do not fire duplicate ListChanged events.

2008-12-31  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewRow.cs: Add a new internal property 
	DataManager to fetch the CurrencyManager for the DataGridView and to 
	spare this logic for the other components to follow.

2008-12-31  Mario Carrion  <mcarrion@novell.com>

	* MessageBox.cs: UIA support: new properties: UIAMessage, 
	UIAMessageRectangle and UIAIconRectangle.

2008-12-31  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* FileDialog.cs: Add PopupButtonPanel.PopupButton.PerformClick method
	and DirComboBox.DirComboBoxItem.ToString override for UIA support.

2008-12-31  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not autogenerate duplicate column for a 
	data member that has already problematically been assigned one.
	[Fixes bug #457305]

2008-12-30  Jonathan Pobst  <monkey@jpobst.com>

	* ProfessionalColorTable.cs: Better detection of user's theme.
	[Fixes bug #462766]

2008-12-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: In the case where there are no autogenerated 
	columns and the user adds columns problematically we must generate 
	the rows after the very first column is added.

2008-12-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: When increasing/decreasing the value of month
	with ShowUpDown set to true, moving from december to january, and
	moving from january to december should adjust the year to the next and
	the previous year, respectively.
	Fixes the remaining bits of #459674.

2008-12-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: If a new cell is selected edit mode should be 
	immediately enabled only if EditOnEnter is set. Whether the mouse 
	or not was used to select the cell is irrelevant.

2008-12-29  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Remove a bogus ReBind call, which was causing 
	recursive rebinding.

2008-12-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: Handle the "MMMM" month format.
	Fixes #459674.

2008-12-23  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: 
	   - Make ReBind private and refactor various calls to call ReBind 
	   instead of ClearBinding/DoBinding
	   - Rebind when the column collection changes
	* DataGridViewColumnCollection.cs: 
	   - Leave the rebinding on change to be handled by the DataGridView.

2008-12-23  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Add a ReBind convenience method.
	* DataGridViewColumnCollection.cs: Rebind when a column is added.
	[Fixes bug #462019]

2008-12-23  Neville Gao  <nevillegao@gmail.com>

	* StatusBar.cs: Modified argument variable.
	* SplitContainer.cs: Control enabled to support accessibility.
	[Fixes Bug #455950]

2008-12-22  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripMenuItem.cs: Guard against an NRE.
	[Fixes bug #457110]

2008-12-22  Mario Carrion  <mcarrion@novell.com>

	* Control.cs: AccessibleXXXX properties don't return 
	AccessibleObject.XXXX, instead a local referece is returned.

2008-12-22  Neville Gao  <nevillegao@gmail.com>

	* PrintPreviewControl.cs: Added internal properties to support
	accessibility.
	[Fixes Bug #459699]

2008-12-19  Mario Carrion  <mcarrion@novell.com>

	* Control.cs: Reverted r121561. 

2008-12-19  Andrés G. Aragoneses  <aaragoneses@novell.com>

	* X11DesktopColors.cs: Since r121873 we don't need gtk a11y checks here,
	it has been moved to the bridge.

2008-12-18  Brad Taylor  <brad@getcoded.net>

	* DateTimePicker.cs: Add a few UIA specific events, and a couple
	internal methods useful for UIA.

2008-12-18  Mario Carrion <mcarrion@novell.com>

	* ListBox.cs: Fixed GetItemRectangle when MultiColumn is true.
	[Fixes Bug #455752]

2008-12-17  Mike Gorse  <mgorse@novell.com>

	* ListView.cs, ListViewItem.cs: Send OnUIAFocusedItemChanged if an
	  item's Focused property is set.

2008-12-17  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* TreeView.cs:
	* TreeNode.cs:
	* TreeNodeCollection.cs: Add events for UIA support:
	UIACheckBoxesChanged, UIALabelEditChanged, UIANodeTextChanged, and
	UIACollectionChanged.

2008-12-17  Bill Holmes  <billholmes54@gmail.com>

	* ListViewItem.cs (ListViewSubItem.ctor): Initalizing the 
	  SubItemStyle member field. 

	Contributed under MIT/X11 license.

2008-12-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: In MultiColumn mode don't use top_index to calculate the
	y coord, since it's useless in this case, and we need to rely only on
	the number of rows and ItemHeight to compute this value.
	Fixes part of #257471.

2008-12-15  Mike Gorse  <mgorse@novell.com>

	* StatusBar.cs: Send OnUIACollectionChanged in Remove().

2008-12-15  Mario Carrion  <mcarrion@novell.com>

	* Control.cs: Accessibility properties instantiate AccessibilityObject when
	needed.
	[Fixes Bug #459223]

2008-12-15  Brad Taylor  <brad@getcoded.net>

	* ToolStripItem.cs: Add a UIA specific event for listening for when a
	ToolStripItem becomes selected or deselected.

2008-12-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MonthCalendar.cs: Select the date in MouseDown, not in MouseUp, as
	.net does. Use the date in the point of the mouse move coords as the
	new range as well, if the left button of the mouse is being pressed.
	Fixes #364914.

2008-12-12  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* MonthCalendar.cs: When modifying either AnnuallyBoldedDates,
	MonthlyBoldedDates or BoldedDates call UpdateBoldedDates, to
	effectively repaint the control.
	Fixes the remaining bits of #417961.

2008-12-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MonthCalendar.cs: When setting MaxDate/MinDate, adjust the selected
	range to contain only dates within the new possible range.
	Fixes part of #417961.

2008-12-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MaskedTextBox.cs: MaskedTextService.Replace doesn't expect the
	length of the text, but the end position, so we need to substract 1 to
	have a valid value. Also, in the same InputText method, don't use
	SelectionLength as the length of the text, since the selected text
	could actually be empty, but we need to set the value anyway.
	Fixes #457370.

2008-12-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Don't do any auto complete task if the custom source is
	null or empty. Also avoid duplication of code.
	Fixes #457743.

2008-12-09  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Refresh column sizes when new rows are added.
	[Fixes bug #457050]

2008-12-09  Carlos Alberto Cortez <calberto.cortez@gmail.com> 
	* RichTextBox.cs: When parsing the contents of a rtf file, don't call
	Split to create a line - we are already doing this, by _adding_ a new
	one when rtf_cursor_x is 0 (this field gets this value just after we
	receive the newline param as true). This avoids having a proportional number
	of empty lines in the end of the rich text box.
	Fixes #396664.

2008-12-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RichTextBox.cs: When saving the contents as a plain text, don't add
	a new line for every Line structure, since the data in Document
	already contains the new line characters. This avoids duplicated new
	lines using the Save methods.
	Fixes #445618.

2008-12-09  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* TreeView.cs: Expose ScrollBars as internal properties, for use by UIA
	framework.  Fixes bug #457678.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewRow.cs: Prevent an exception on a not yet databound grid, 
	where datasource is null.
	[Fixes exception reported in bug 441240]

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: EndEdit validation fixes.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: This is the cool patch that adds support for 
	actually updating the data in the databinding backend after editing. 
	With bonus firing and handling the DataError event.

2008-12-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Line.cs: When calculating the text tags's Shift value, store it as
	pixels instead of points. This way we can actually handle different
	fonts in the same RichTextBox, as well as the right size of the caret.
	Fixes part of #351938.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewCheckBoxCell.cs: Fix to make it work. Wrong value was 
	casted to CheckState causing InvalidCastExceptions.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix the DataGridViewEditMode.EditOnEnter behavior 
	to not depend on the item being clicked.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Implement NotifyCurrentCellDirty, so that it no 
	longer throws a NotImplementedException.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Set EditingControlFormattedValue when preparing an 
	IDataGridViewEditingControl for editing.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewComboBoxCell.cs: Implement data binding support.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Use the CurrencyManager to update the data source 
	binding position instead of casting the data sourcde to BindingSource.
	This enables position updating for other type of data sources.

2008-12-08  Ivan N. Zlatev  <contact@i-nz.net>

	* ComboBox.cs: Update the SelectedIndex before updating the Text 
	in OnDisplayMemberChanged.

2008-12-07  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix our support for IDataGridViewEditingControl.
	[Fixes bug #457112]

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Sorting fixes:
	   - Be strict when sorting is enabled.
	   - If there is a data source delegate the sorting request.

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* Binding.cs: When converting the data also try with the destination 
	type typeconverter. This indirectly adds support for Nullable types 
	in our databinding layer.

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: When cell editing is finished focus back the 
	DataGridView. Fixes keyboard navigation post-editing.

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix the cell editing by delaying the currentCell 
	setting to after EndEdit is called for the old cell.

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: Reset the bindings. Fixes a NotWorking test.

2008-12-06  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Send WM_HELP only to the focused window.

2008-12-05  Ivan N. Zlatev  <contact@i-nz.net>

	* CurrencyManager.cs: Fix exceptions when resetting the data source 
	for the same time (e.g. in ComboBox): 
	   - Do not set the list position if we are still transferring data
	   - When resetting the list firstly push the data then update the 
	   binding.
	* Binding.cs: Check BindingManager.Position == -1 instead of 
	BindingManager.Current == null in order to avoid unexpected 
	exceptions.

2008-12-05  Brad Taylor  <brad@getcoded.net>

	* MonthCalendar.cs: Add UIA specific events so that we can know when
	the selection changes, and when MaxSelectedCount changes.

2008-12-05  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Cleanup rows_displayed out of OnPaint. It's not 
	used for anything.

2008-12-05  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix scrolling and selection of cells/rows prior
	to the control being drawn for the first time by:
	   - Implement DisplayedRowsCount to not rely on the control being
	   already painted. Also added support for the partial row flag.
	   - Fix scrolling to take into account partial rows and scroll to
	   them.
	[Fixes bug #456527]

2008-12-05  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Do not reset the CurrentCell when the handle is
	created if the user has already set it.

2008-12-05  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix CurrentCell to actually select the cell.

2008-12-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Add support to RichTextFormat by reading it as ascii
	text and then let the underneath users of IDataObject interpret and
	parse by themselves. 
	Fixes #439251.

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix my previous commit to actually update what it 
	was supposed to.

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Ensure that when a row is removed the all the 
	current row/column/cell get updated. Fixes multiple exceptions.

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Fix scrolling to the current cell when key navigation 
	is used.
	[Fixes bug #443560]

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewCell.cs: Fire CellStateChanged events.
	* DataGridViewCell.cs: Set the cell as selected prior to setting the 
	new state.
	[Fixes issue 1 in bug #443560]

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Invalidate after the current row/column seletion 
	chagnes.
	[Fixes bug #438434]

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Refresh the data if the data list is reset, etc.

2008-12-01  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Handle datasource state changes:
	   - IBindingList - list changes
	   - BindingSource - list changed and datasource changes

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Select the first cell when databound. 
	Visually select when CurrentCell is set.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Set the current cell before raising CellClick.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Cleanup MoveCurrentCell to not fire any CellEnter, 
	CellLeave events as this is already done in SetCurrentCellAddressCore.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Set the minimum size for the columns to be the 
	width of their header, so that the columns don't get squashed 
	all together.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: After the data is bound PerformLayout, so that 
	the columns get autosized.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Move all currentCell setting code into 
	one central place - SetCurrentCellAddressCore. That way the 
	current cell is properly updated when programatically set.
	Fire RowEnter/Leave events.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs: Update the CurrencyManager.Position, so that 
	when a BindingSource is used BindingSource.Current will be correct.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* GroupBoxRenderer.cs: Fix when VisualStyles disabled:
	   - No caption text is drawn because Color.Empty is used.
	   - Fix top and height off by 1.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridViewRow.cs: Implement DataBoundItem.

2008-11-30  Ivan N. Zlatev  <contact@i-nz.net>

	* BindingSource.cs: Return null for Current if there is no data present.

2008-11-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* MenuAPI.cs: Add a Menu.SelectedItem null check when navigating the
	menus using the arrow keys. Also when handling the left arrow key, don't 
	assign the current menu to the parent one, if the parent is null.
	Fixes #446392.

2008-11-24  Everaldo Canuto  <ecanuto@novell.com>

	* PrintPreviewDialog.cs: Fix toolbar size, height must be 26. Fixes bug
	#413501.

2008-11-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Scrollbar.cs:
	* ScrollableControl.cs: Simplify the code to manually set the size of
	the thum area, avoiding duplication of code, and also preserving the
	right value for different code paths - this can happen when size
	changes are made to the scrollbar after setting LargeChange, Maximum
	or related properties for the ScrollBar.

2008-11-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ScrollableControl.cs: When scrolling, don't invalidate the entire
	area, and call to XplatUIX11.ScrollWindow instead. This is exactly
	what .Net does: copy the visible area, and only invalidate the part of
	the area that wasn't visible before scrolling.
	Fixes #441738.

2008-11-24  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Listen for a DataTable's TableCleared event so we
	can clear ourselves when it is raised, we don't have a newrowindex
	if we don't have any columns.
	* DataGridViewRowCollection.cs: Ensure we always delete all the rows,
	re-index after each delete so the NewRow will have the correct index.
	[Fixes bug #448005]

2008-11-24  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Don't change min/max size if it is empty.
	[Fixes bug #447873]

2008-11-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ScrollBar.cs:
	* ScrollableControl.cs: When the manual thumb size is used, the
	maximum allowed value should depend on that thumb size, instead of
	LargeChange (using the maximum - LargeChange + 1 value). But
	LargeChange should be used normally when incrementing/decrementing.
	Fixes the remaining part of #441546.

2008-11-23  Andreia Gaita  <avidigal@novell.com>

	* WebBrowser.cs, WebBrowserBase.cs: Delay loading of DocumentStream 
	until an about:blank has been loaded (according to spec). Fix 
	ScrollbarsEnabled to set when a document is loaded (since we use js 
	for it). Fix url so it reflects the current loading document and not 
	the previous one. Send StatusChanged events.

2008-11-23  Andreia Gaita  <avidigal@novell.com>

	* Application.cs: If a message comes in for an embedded control
	(like webbrowser) when we're capturing the keyboard, release the
	capture and continue.
	[fixes #429462]

2008-11-22  Andreia Gaita  <avidigal@novell.com>

	* XplatUI.cs: Only use PlatformID.MacOSX enum when not building on VS

2008-11-21  Andreia Gaita  <avidigal@novell.com>

	* WebBrowser.cs, HtmlDocument.cs: Fixes for #428172
	
2008-11-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ScrollBar.cs:
	* ScrollableControl.cs: Set manually the thumb size for the
	ScrollableControl scrollbars, so any further changes to the underneath
	scrollbars respect the original size.
	Fixes part of #441546.

2008-11-21  Geoff Norton  <gnorton@novell.com>

	* XplatUI.cs: Ensure that we can run on .net 2.0 with mono 2.2 where
	PlatformID.MacOSX now exists.

2008-11-20  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: Provide a default implementation for ChangeBackColor.
	Having something internal abstract isn't very nice for people who want
	to inherit from this class.

2008-11-20  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItem.cs: Don't crash if ImageIndex or ImageKey is set to an
	invalid value.  Just return null for the Image, and use the ImageList's
	ImageSize for calculations.

2008-11-20  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Call HideWindow instead of Hide when closing the dropdown
	through DroppedDown so the proper events get called and state gets reset.
	[Fixes bug #446805]

2008-11-18  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnCollection.cs: Make sure we re-index the columns after
	the collection is modified.

2008-11-17  Jonathan Pobst  <monkey@jpobst.com>

	* DomainUpDown.cs: Remove string cache and reflection optimizations.  They
	aren't always correct, and fixing them for every case is not worth the
	negligible benefit they provide.
	[Fixes bug #445713]

2008-11-17  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: We should never add actual cells to the RowTemplate.
	Internally, use RowTemplateFull to give us a new row with cells.
	* DataGridViewColumnCollection.cs: Clear Rows when we clear Columns.
	* DataGridViewRowCollection.cs: Use RowTemplateFull.

2008-11-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Forms without borders should be able to change its
	size - specially they should be able to be maximized, adding the
	respective MotifFunctions.Resize bit when setting window properties as
	well as *not* marking the Hwnd as size fixed.
	Fixes #444347.

2008-11-12  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCellStyle.cs: Allow SelectionBackColor to have
	an alpha value.
	[Fixes bug #444348]

2008-11-11  Andrés G. Aragoneses  <aaragoneses@novell.com>

       * Application.cs: After UIA assembly is successfully loaded,
       dump any exception that happens on initialization to stderr.

2008-11-11  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Add internal to OnAutoSizeColumnModeChanged.
	* DataGridViewColumn.cs: Recalculate columns when AutoSizeMode changes.  Raise
	AutoSizeColumnModeChanged.
	[Fixes bug #443609]

2008-11-11  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRowCollection.cs: Guard against the user deleting the
	NewRow.  Add an internal delete so we can still delete it.
	* DataGridView.cs: Use the new internal delete when deleting the NewRow.
	[Fixes bug #442181]

2008-11-10  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: Add some order of operation to our math so
	we don't end up with a negative height for our invalidate rect.
	[Fixes bug #381889]

2008-11-10  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: When our enabled changes, notify our implicit children
	controls as well as our regular controls.
	[Fixes bug #441523]

2008-11-08  Andreia Gaita <shana@jitted.com> 

	* HtmlElement.cs: Small code cleanup

2008-11-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingNavigator.cs: MoveFirstItem should be enabled only if
	position is larger than 0, not only different than 0. Also Position
	and Count items should be enabled if the BindingSource is non null and
	non empty.
	Fixes #439961.

2008-11-05  Jonathan Pobst  <monkey@jpobst.com>

	* TabControl.cs: Don't raise SelectedIndexChanged until we have
	actually modified the tab collection, so TabCount will be correct.
	[Fixes bug #441896]

2008-11-05  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* ListViewItem.cs: Mark ListViewSubItem.UIATextChanged event as
	NonSerialized to fix serialization of ListViewItem.

2008-11-04  Mike Gorse  <mgorse@novell.com>

	* ListView.cs: Call OnUIAFocusedItemChanged after completing the
	  focus change, and always call in SetFocusedItem.
	* ListBox.cs: Add UIAFocusedItemChanged as in ListView.

2008-11-04  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Only call OnDrawItem when we are using an OwnerDraw
	mode.  Based on a patch by John Mortlock.
	[Fixes bug #436790]

2008-11-04  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: Use the UsingGroups property where needed, instead of
	duplicating the check in other places.

2008-11-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When calculating layout, refresh the count of items
	belonging to the default item, insteas of doing it only one time. This
	was already working fine for icon views, not not for details.
	Fixes #438948.

2008-11-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs:
	* ListViewItem.cs:
	* ThemeWin32Classic.cs: Don't render Tile view if there wasn't a call
	to Applicatin.EnableVisualStyles, and use LargeIcon view, as .net
	does.
	Fixes #437933.

2008-11-03  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* ListView.cs: Wrap call to OnUIAFocusedItemChanged with #if NET_2_0.

2008-11-03  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* ListView.cs: Add internal UIAFocusedItemChanged event.  Fixes bug
	#441280, patch by Mike Gorse <mgorse@novell.com>.

2008-11-03  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: When doing ExpandAll, don't scroll to the bottom
	if there is no scrollbar.
	[Fixes bug #440885]

2008-11-03  Jonathan Pobst  <monkey@jpobst.com>

	* ProgressBar.cs, ThemeWin32Classic.cs, ThemeVisualStyles.cs: Commit
	patch from Andy Hume that fixes many issues with ProgressBar.
	[See bug #440220]

2008-11-03  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Don't allow MinimumSize and MaximumSize to conflict.
	[Fixes bug #438866]

2008-11-03  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* UpDownBase.cs:
	* DomainUpDown.cs:
	* NumericUpDown.cs: Internal events added to UpDownBase:
	UIAUpButtonClick and UIADownButtonClick.  Patch by Neville Gao
	<ngao@novell.com>.

2008-11-03  Sandy Armstrong  <sanfordarmstrong@gmail.com>

	* ToolStripLabel.cs: Internal event added: UIAIsLinkChanged.

2008-11-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs:
	* ThemeWin32Classic.cs: Don't use groups nor insertion mark in
	Application.EnableVisualStyles hasn't been called.
	Fixes part of #437933.

2008-10-31  Andreia Gaita  <shana@jitted.com>

	* Form.cs (SetVisibleCore): since set_ActiveControl no longer calls focus
	  if the container is not focused already, we need to specifically set
	  focus to the first available control, or to the form itself if there
	  are no controls.

2008-10-31  Andreia Gaita  <shana@jitted.com>

	activate message fix: a call to .Show now waits until both WM_SHOWWINDOW and
	WM_ACTIVATE have been processed before returning, so it is guaranteed that
	once it returns and the form is visible, it is actually on the screen on X11

	* ContainerControl.cs: Only send focus to the control if the top container
	  is already focused. This is so that, when a form is first shown, all
	  the enter/leave events are done first before any focus stuff comes in.
	  If a control has no top container, there's an extra check on Control.Focus
	  to make sure it gets focused in this particular case.

	* Control.cs: Force focus if the control is active but did not receive
	  focus after being set as active.

	* MdiClient.cs: Dispose the form when closing

	* XplatUIX11.cs: When mapping and unmapping windows, make sure the call
	  doesn't return until both WM_SHOWWINDOW and WM_ACTIVATE have come in
	  if the window is a top Form.
	  Reset all hwnd properties when the window has been destroyed so that
	  we don't land in any codepaths that might try to do something with it.
	  Added a bunch of debugging messages. If TRACE is defined, all X calls
	  are logged through DebugHelper. Set a few missing EntryPoint attributes.

2008-10-29  Mario Carrion <mcarrion@novell.com>

	* ListViewItem.cs: Control enabled to support Accessibility:
	- Internal events: UIATextChanged, UIASubItemTextChanged.
	- Internal event UIATextChanged in ListViewSubItem that triggers
	UIASubItemTextChanged.
	* ListView.cs: Control enabled to support Accessibility:
	- Internal events: UIACheckBoxesChanged, UIAMultiSelectChanged, 
	UIAShowGroupsChanged, UIAViewChanged and UIALabelEditChanged.
	- Internal event UIACollectionChanged in ColumnHeaderCollection.
	- Internal event UIACollectionChanged in ListViewItemCollection.
	- Internal properties: UIAHeaderControl, UIAColumns, UIARows, 
	UIADefaultListViewGroup, UIAHScrollBar and UIAVScrollBar.
	- Internal methods: UIAGetHeaderBounds.

2008-10-25  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ScrollableControl.cs: Actually fire the 2.0 Scroll event when we get
	the event from the respective scrollbars.
	Fixes #436709.

2008-10-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Use the new CanNavigateAutoCompleteList property of the
	textbox to know whether any navigation key will be handled or not. If
	not, don't pass the message to the textbox, and use it here instead. 
	* TextBox.cs: Define a new CanNavigateAutoCompleteList property -which
	is more precise- than the previous AutoCompleteMatches one.
	This should the keyboard navigation in ComboBox when using auto
	complete modes.

2008-10-24  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Fix item height calculation based off Font to match .Net.
	[Fixes bug #436730]

2008-10-24  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownItem.cs: Call OnClick instead of base.OnClick so
	overridden methods will get called.
	* ToolStripItem.cs: Raise Click before MouseUp.
	* ToolStripSplitButton.cs: Fix up some bounding rectangles to take
	the item's location into account.
	[Fixes bug #437683]

2008-10-24  Neville Gao  <nevillegao@gmail.com>

	* NumericUpDown.cs: Control enabled to support accessibility.
	[Fiexes bug #438135]

2008-10-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Check that we actually have items no navigate, select
	text when pressing enter, as well as handle direction keys only if
	mode is different to Suggest or the suggest listbox is visible.

2008-10-23  Andreia Gaita  <shana@jitted.com>

	* WebBrowser.cs: Use the new ContentStream property to retrieve
	  a stream encoded from the document content

2008-10-23  Andreia Gaita  <shana@jitted.com>

	* HtmlDocument.cs,
	  HtmlElement.cs,
	  HtmlWindow.cs: Fix GetHashcode for null objects

2008-10-22  Andreia Gaita  <shana@jitted.com>

	* HtmlDocument.cs,
	  HtmlElement.cs,
	  HtmlWindow.cs: Fix equality operators (fixes #428173)

2008-10-21  Jonathan Pobst  <monkey@jpobst.com>

	* XplatUIWin32.cs: Apply patch from John Mortlock that ensures
	mouse_state gets set during WM_MOUSEMOVE and WM_NCMOUSEMOVE.
	[Fixes bug #436772]

2008-10-21  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Fire SelectedIndexChanged when the user selects the
	same item with the mouse as was already selected.
	[Fixes bug #436789]

2008-10-21  Brad Taylor  <brad@getcoded.net>
	
	* TextControl.cs: Break out code to get the visible range into
	  GetVisibleLineIndexes to be used in UIA code.
	
	* Line.cs:
	* TextControl.cs:
	* TextBoxBase.cs: Add comments indicating that the method or property
	  is used via reflection from UIA code.

2008-10-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewItem.cs: Match .net serialization.
	Fixes remaining part of #417520.

2008-10-20  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripProfessionalRenderer.cs: Don't paint over a set BackgroundImage.

2008-10-20  Mario Carrion <mcarrion@novell.com>

	* ErrorProvider.cs, ToolTip.cs, HelpProvider.cs: UIA internal property 
	added: UIAToolTipRectangle.

2008-10-19  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListViewItem.cs: When deserializing enumerate over the data, instead
	of accessing the data directly. This way we handle much better the
	cases were we lack information.
	Fixes #417520.

2008-10-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When removing an item from a main ListView.Items
	collection (and not a ListViewGroupCollection.Items one), remove it
	also from the group, as .net does. Patch by Mario Carrion (mario at
	novell dot com).
	Fixes #436653.

2008-10-19  Andreia Gaita  <avidigal@novell.com>

	* Form.cs: Forms that get closed without a handle being created are
	disposed in 2.0. Fixes failing FormTest.FormClose and
	FormTest.FormClose2 on windows.

2008-10-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: If both scrollbars are visible, the vertical one
	shouldn't extend too far down.
	Fixes #435771.

2008-10-17  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Add the ability to resize columns and rows with
	the mouse.  Also support double-clicking to autoresize.
	* DataGridViewColumn.cs: Invalidate the grid if a column's width changes.
	* DataGridViewRow.cs: Invalidate the grid if a row's height changes.
	* DataGridViewTextBoxCell.cs: Add 1 to preferred width so ellipsis
	isn't shown on autoresize.
	[Fixes bug #420193]

2008-10-17  Mario Carrion <mcarrion@novell.com>

	* ComboBox.cs: Remove UIAListbox.

2008-10-17  Mario Carrion <mcarrion@novell.com>

	* ComboBox.cs, ListBox.cs: Using added/removed item in 
	  OnUIACollectionChangedEvent instead of index.

2008-10-17  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: When we are sorting the items, if the item's type
	doesn't support IComparer, use a default one that compares based
	off the item's visible text.
	[Fixes bug #436328]

2008-10-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ColumnHeader.cs: Invalidate ListView.header_control when setting
	ImageIndex/ImageKey.
	* ThemeWin32Classic.cs: When drawing the column header, draw a image
	for the column if available, and make the required adjustments to the
	text location.
	Fixes #435105.

2008-10-17  Neville Gao  <nevillegao@gmail.com>

	* StatusBarPanel.cs: Control enabled to support accessibility.
	[Fixes bug #435988]

2008-10-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: When a user begins an edit in the 'new row',
	make that a real row, and add a new 'new row'.  If the user
	cancels the edit, remove the new 'new row' and reset everything.
	Also, ensure UserAddedRow and UserRemovedRow events are raised.
	[Fixes bug #430954]

2008-10-16  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutSettings.cs: Fix NREs when deserializing and 
	panel is not yet set.
	[Fixes bug #436199]

2008-10-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Invalidate after deleting a row.

2008-10-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Handle Enter and Escape keys.
	  - Move call to EndEdit to MoveCurrentCell.
	  - Remove call to EndEdit from navigation key routines.
	  - Fire CellLeave and CellEnter.

2008-10-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Some fixes to the new cell border
	painting code.

2008-10-16  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeEngine.cs: Enable visualstyles rendering by default
	(on platforms that support it).

2008-10-15  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs, XplatUICarbon.cs: Do not Timer.Tick before 
	MainForm.OnLoad has completed unless DoEvents is forced.
	[Fixes bug #412536]

2008-10-15  Jonathan Pobst  <monkey@jpobst.com>

	* ToolTip.cs: Ensure that Timer.Internal cannot be set to 0.

2008-10-15  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Make our implementation of DrawToBitmap better 
	match WmPaint.  [Fixes bug #435579]

2008-10-14  Andreia Gaita  <avidigal@novell.com>

	* WebBrowser.cs: Use DocumentElement as the document's root for the
	whole content. Should fix DocumentText and DocumentStream problems.

2008-10-14  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnCollection.cs: Remove calls to OnColumnAddedInternal,
	these will get called in DGV.OnCollectionChanged.  Make sure 
	OnCollectionChanged always gets called.
	* DataGridView.cs: Make a OnColumnRemovedInternal that removes the cells
	from every row.  Call this in OnCollectionChanged.
	[Fixes bug #433669]

2008-10-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: WM_KEYDOWN and WM_KEYUP messages should be sent to the
	textbox if auto complete is used, since we need to navigate over it.
	And in this case don't pass this messages to the base impl. Also hide
	the auto complete list box when displaying the drop down listbox.
	* TextBox.cs: new internal members to expose some of the auto complete
	functionality to combobox.

2008-10-13  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs, XplatUICarbon.cs, Form.cs: Do not Timer.Tick before 
	MainForm.OnLoad has completed.
	[Fixes bug #412536]

2008-10-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Apply an old-approved patch that adds autocomplete's
	Append support to this controls. We need it to apply new patches.

2008-10-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs: When updating z order in child controls, send to back
	the implicit controls. Also, do it explicitly, instead of making
	GetAllControls return the implicit controls in a specific order, and
	thus avoid depending on that, which could change in the future.
	Fixes #434304.

2008-10-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Try to call Application.DoEvents before returning in a
	call to StartDrag, since we must fire DragDrop/DragLeave *before*
	that, as .net does - instead of firing DragDrop/DragLeave *after* the
	call to Control.DoDragDrop has completed. This is needed since at the
	point of returning, we have sent related dnd ClientMessages, but we
	need to wait for them to fire the wmf respective ones.
	Fixes #325076.

2008-10-09  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Recreate link pieces when change Padding.

2008-10-09  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Take Padding into account when recreate link pieces.
	[Fixes bug #412530]

2008-10-08  Everaldo Canuto  <ecanuto@novell.com>

	* Control.cs: Implement internal property PaddingClientRectangle, it will be
	useful for drawing controls that must take care about Padding property.

2008-10-08  Jonathan Pobst  <monkey@jpobst.com>

	* BindingSource.cs: Make item_type internal so we can access it in DGV.
	* DataGridView.cs: Add support for autogenerating columns from a
	BindingSource.

2008-10-07  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Comment out an exception that is getting thrown
	too often currently.

2008-10-07  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Always rebind to the datasource, as things may
	have changed in it that we aren't capturing yet.

2008-10-07  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewTextBoxCell.cs: Don't default to VerticalCenter font
	drawing mode.  If we are top aligned, give ourselves some top padding.

2008-10-06  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* X11Dnd.cs: When firing the default dnd enter/leave events, fire the
	events on the control under the mouse pointer, instead of firing them
	on the window generating the dnd operation. To achieve this re-use the
	code used to get the window under the pointer when getting MouseMove
	events.
	Fixes #381876.

2008-10-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Don't check that that the window sending the dnd events
	is the owner of the selection. Although Gtk+ sets it that way, it's
	not a requirement of the XDnd protocol, and Qt doesn't seem to do it.
	So, just as Gtk+ does, we set our window sending the dnd events as the
	owner of the selection, but don't check it when receiving them. This
	should fix interoperability with Qt/Kde.
	Fixes #324251.

2008-10-06  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Make sure we take the vertical scrollbar into
	account when autosizing columns.

2008-10-06  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Handle sorting datetimes.

2008-10-04  Ivan N. Zlatev  <contact@i-nz.net>

	* ButtonBase.cs, Control.cs, Label.cs, PictureBox.cs, TabControl.cs, 
	TextBoxBase.cs, ToolBar.cs, TrackBar.cs, TreeView.cs: Cleanup 
	compilation warnings.

2008-10-03  Ivan N. Zlatev  <contact@i-nz.net>

	* RTF.cs, Application.cs, BindingContext.cs, BindingSource.cs, 
	ContextMenuStrip.cs, Control.cs, Hwnd.cs, Line.cs, MaskedTextBox.cs, 
	ProgressBar.cs, SaveFileDialog.cs, TextControl.cs, Theme.cs, 
	ToolBar.cs, ToolStripItemCollection.cs, TrackBar.cs: Cleanup 
	compilation warnings.

2008-10-03  Ivan N. Zlatev  <contact@i-nz.net>

	* DataGridView.cs, DataGridViewCell.cs, 
	DataGridViewCellValidatingEventArgs.cs, 
	DataGridViewComboBoxEditingControl.cs, DataGridViewHeaderCell.cs, 
	DataGridViewRow.cs, DataGridViewRowHeaderCell.cs, 
	DataGridViewTextBoxEditingControl.cs: Cleanup compilation warnings.

2008-10-03  Ivan N. Zlatev  <contact@i-nz.net>

	* HtmlElementEventArgs.cs, HtmlWindowCollection.cs: 
	Cleanup compilation warnings.

2008-10-03  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIWin32.cs: Cleanup compilation warnings.

2008-10-03  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Cleanup compilation warnings.

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRow.cs: Only clear the row background if we
	are going to paint a new background.

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs, DataGridViewColumnHeaderCell.cs,
	DataGridViewRowHeaderCell.cs: Remove PaintPartBorder and
	use PaintBorder instead.	

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: When CellBorderStyle is set, update the
	AdvancedCellBorderStyle to match.

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Add helper methods to convert Alignment
	to TextFormatFlags and align rectangles.
	* DataGridViewTextBoxCell.cs: Use Alignment when painting text.
	* DataGridViewImageCell.cs: Use Alignment when painting the image.

2008-10-02  Ivan N. Zlatev  <contact@i-nz.net>

	* ToolTip.cs: Display tooltips only for controls on the active form.
	[Fixes bug #428115]

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Make OnCellValueNeeded internal.
	* DataGridViewCell.cs: Raise the CellValueNeeded event so the
	user can supply their own value if they choose.

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnHeaderCell.cs: Create a new style object
	so the DefaultCellStyle doesn't get changed.

2008-10-02  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItem.cs: Check to make sure the owner is actually
	changing in InternalOwner before doing any work.  Fixes some
	failing tests.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnHeaderCell.cs: Correctly calculate style.
	* DataGridView.cs: Use a column header's inherited style instead
	of just using the default.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* SplitContainer.cs: Raise SplitterMoved when the splitter is
	moved through code.

2008-10-01  Mario Carrion <mcarrion@novell.com>

	* ScrollBar.cs: Internal property added: UIAThumbPosition.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripOverflowButton.cs: Use InternalOwner instead of Owner.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItem.cs: When the user sets Owner, we need to remove
	it from its previous owner and then add it to the new owner's
	item collection.  Also, create InternalOwner, so we can set the owner
	that doesn't do this new stuff.
	* ToolStripItemCollection.cs: Use InternalOwner instead of Owner.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItem.cs: When our parent changes, recalculate our text
	size, since we may be getting our Font from our parent.  When our
	owner's Font changes, recalculate ourselves as we may be using
	that font.

2008-10-01  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Select the first option of a popup when opening the popup via
	return key. [Fixes bug #413792].

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItem.cs: Make Font, BackColor, and ForeColor be
	ambient properties.  (Get their value from their parents if
	values haven't been set.)

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripSystemRenderer.cs: Call overridden methods' bases
	after our logic, so users can do painting by handling the events.
	Currently, we draw over any user painting.

2008-10-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripProfessionalRenderer.cs: Call overridden methods' bases
	after our logic, so users can do painting by handling the events.
	Currently, we draw over any user painting.

2008-09-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Prevent NRE when deactivate menu. Fixes #413636.

2008-09-30  Jonathan Pobst  <monkey@jpobst.com>

	* TreeNode.cs, TreeView.cs: Move logic that determines the node
	image to draw to TreeNode.  Give Index/Keys put on the node
	precedence over the global one for the TreeView.

2008-09-30  Jonathan Pobst  <monkey@jpobst.com>

	* TreeNode.cs: Setting ImageIndex or ImageKey should reset the other.

2008-09-29  Mario Carrion <mcarrion@novell.com>

	* ListBox.cs: Index fixed.

2008-09-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When expanding the tab -because it's selected now-,
	using Right alignment, instead of adding some selected delta value to
	the X origin, substract it, so it gets a location adjacent to the panel, 
	instead of be more separated.
	Fixes #409170.

2008-09-29  Jonathan Pobst  <monkey@jpobst.com>

	* MessageBox.cs: Use SystemIcons for graphics instead of keeping our
	own copies of them.

2008-09-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: source and related fields should be set to IntPtr.Zero,
	as well as the other static fields, to avoid using their previous
	values my mistake when handling the dnd events. This should avoid
	handling any status event after the drop has been finalized/cancelled.

2008-09-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: We have to send a dnd enter event as soon as we start the
	operation, instead of waiting until we get any movement - this will
	help us to have the data available in case no movement was detected
	and _still_ we have to fire DragEnter and DragLeave/DragDrop events.
	Finally add a windows.forms-only fallback to fire the mentioned events
	if no movement at all was detected, just like .net does.
	Fixes #381876.

2008-09-27  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: When drawing a status bar panel, don't
	return early if the text is empty because the icon doesn't get
	drawn then.  [Fixes bug #428113]

2008-09-25  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* FileDialog.cs: Implement basic support for sorting by columns in
	Details view. Patch by Eric Petit.
	Fixes #428006.

2008-09-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classis.cs: When drawing gridlines take into account the
	case where ListView.ItemSize hasn't been computed, and provide a
	fallback as well. This prevents a division by 0.

2008-09-24  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeVisualStyles.cs: Use ClientRectangle instead of Bounds to
	correctly draw tooltip backgrounds.

2008-09-24  Jonathan Pobst  <monkey@jpobst.com>

	* ImageList.cs: Change CopyTo implementation to ensure clones are
	created of our images.
	[Fixes bug #409169]

2008-09-24  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: When setting fonts, we need to ensure we change our
	reference to the new font object, even if it represents the same
	font as before.  If we don't, the original font can get disposed
	and we will still try to use it.
	[Fixes bug #386450]

2008-09-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* FileDialog.cs: Take into account Tile view when selecting the view
	(2.0 profile).

2008-09-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: When drawing gridlines for ListView don't use
	the item bounds, since we can't iterate over them in virtual mode.
	Also fix wrong calculation of the gridlines when using scrolling.
	Fixes #400390.

2008-09-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When handling EnterNotify events, take into account
	both the public and implicit controls when trying to detect the
	grab/ungrab process. This should fix ListView selection in Details
	view.

2008-09-23  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Redraw the whole node area when the selected node changes.
	Things like state images were not getting redrawn because the invalid
	rectangle was too small.
	[Fixes bug #428211]

2008-09-23  Mario Carrion  <mcarrion@novell.com>

	* ListBox.cs: UIA Selection Pattern fully supported in ListBox control.
	[Fixes bug #428993]

2008-09-23  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Do not set the Form's icon in the backend if showicon = false.
	[Fixes bug #428114]

2008-09-23  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Allow tooltips to be multiline.
	[Fixes bug #427884]

2008-09-23  Jonathan Pobst  <monkey@jpobst.com>

	* StatusBar.cs: Add tooltip support.
	[Fixes bug #428113]

2008-09-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: Use StringAlignment.Center for the vertical
	alignments of sub items in Details view. Patch by John Mortlock (johnm at 
	hlaustralia.com.au).
	Fixes #425360.

2008-09-23  Neville Gao  <nevillegao@gmail.com>

	* StatusBar.cs: Add UIA event in AddInternal () to support accessibility.
	[Fixes bug #419079]

2008-09-22  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: Set Text to "" instead of null in Clear().
	[Fixes bug #428107]

2008-09-22  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: Don't do anything when EnsureVisible is called inside a
	BeginUpdate/EndUpdate block.
	Fixes #425049.

2008-09-22  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewItem.cs: The semantics for the public .ctor of
	ListViewSubItemCollection need us to already have a Text value for the
	item, which in our implementation have as available *after* adding the
	first sub item. So create an internal .ctor that satisfies our needs
	and let the public .ctor have the same semantics as .net.
	Fixes #427561.

2008-09-19  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListControl.cs: Changes in Formatting related values should call
	RefreshItems, as .net does.
	* ComboBox.cs:
	* ListBox.cs: In the respective overrides of RefreshItems calculate
	layout as well as refreshing - again, this is what .net does.
	Fixes #426168.

2008-09-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: In UpdateTopItem, don' call to XplatUI.ScrollWindow,
	since we are already doing that when we change the value of the
	scrollbar or force the call to ScrollWindow in the same method. This
	way we don't cause a Invalidate call for all the listbox bounds for
	methods calling UpdateTopItem with an already updated top item. This
	was happening specially calling EnsureVisible with already visible
	items.

2008-09-18  Mike Gorse <mgorse@novell.com>

	* Application.cs, IKeyFilter.cs, X11Keyboard.cs, XplatUI.cs,
	  XplatUIStructs.cs: Added KeyFilter
	[Fixes bug #427039]

2008-09-18  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* RelatedPropertyManager.cs: The properties returned by
	GetItemProperties should be that ones of the *actual* object returned
	by the property, not the property type - this is very special when the
	property exposes a type, but the returned object actually is a child
	class and implements more functionality and properties.

2008-09-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: Don't look for the property in the data source if the
	passed string is empty.

2008-09-18  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Comment out _NET_WM_WINDOW_TYPE_DIALOG in order to 
	fix unused variable warnings.

2008-09-18  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Send WM_HELP when F1 is pressed.
	[Fixes bug #427073]

2008-09-18  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: 
	 - Do not set _NET_WM_WINDOW_TYPE_DIALOG for modal forms, because this 
	 leads to the window manager overriding our border style and zorder. 
	 - Allow the activation of non-modal forms, which are children of a 
	 modal form.
	[Fixes bug #423417]

2008-09-17  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs, X11Structs.cs: For mapped windows SetTopMost should 
	ask the window manager to do the work instead of changing the property 
	directly.
	[Fixes bug #423417]

2008-09-17  Everaldo Canuto  <ecanuto@novell.com>

	* CurrencyManager.cs: Check for positon before call ChangeRecordState in
	AddNew to fix some navigation for empty datasets. [Fixes #323053]

2008-09-17  Everaldo Canuto  <ecanuto@novell.com>

	* FileDialog.cs: Remove OnPaint method on PopupButtonPanel and set 
	InternalBorderStyle to BorderStyle.Fixed3D. It is the best way to get 3d
	border and fixes some drawing issues when resize form.

2008-09-17  Everaldo Canuto  <ecanuto@novell.com>

	* FileDialog.cs: Lots of layout fixes to mimic Win32. [Fixes #408752]
	
	* ThemeWin32Classic.cs: We don't need to reduce button size when it is
	AcceptButton.

2008-09-17  Ivan N. Zlatev  <contact@i-nz.net>

	* TextBoxBase.cs: For standard textbox the scrollbars are always 
	visible if Multiline is true.
	[Fixes bug #426896]

2008-05-12  Everaldo Canuto  <ecanuto@novell.com>

	* DataGridTextBoxColumn.cs: Uncomment code accidentally commited in last
	patch.
	
2008-05-12  Everaldo Canuto  <ecanuto@novell.com>

	[Fixes most od DBNull and HeadersVisible problems]
	
	* DataGrid.cs:
	- ShowingColumnHeaders removed because we dont need it, ColumnHeadersVisible
	returns the value that we need.
	- Fixed FromPixelToColumn method that return zero for first	column and for
	row header cell, now it returns -1 for row header cell.
	- Fixed HitTest to check row header cell in column header area, it now
	returns HitTestType.None. [Fixes #322864]
	- Fixed the calculation of visible columns in UpdateVisibleColumn, now it
	checks for RowHeadersVisible and other things.
	- If an exception occurs when setting CurrentCell and user type 'yes' in
	message dialog, invalidade current and new cell and set setting_current_cell
	to false to prevent future errors. [Partially fixes #323050]

	* DataGridColumnStyle.cs: Don't call EndEdit after set property_descriptor
	value (SetColumnValueAtRow), it must be done by grid to properly show 
	messages. [Fixes #323050]

	* ThemeWin32Classic.cs: Lots of fixes in DataGridPaintColumnHeaders to
	better draw column and row header. Also dont draw anything when column
	headers is not visible.

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Hook ListViewItems into the ShowFocusCues
	logic.

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Don't start editing a node on right click, only
	left click.

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* NativeWindow.cs: Reenable the ThreadExceptionDialog I accidentally
	disabled over a year ago.
	* Form.cs: Wrap calling Load in a try/catch because it can happen
	before the catch-all one in NativeWindow.
	[Fixes bug #425414]

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownMenu.cs: Calculate the connected area better
	to take into account when the drop down is not directly under the
	owner item.
	* ToolStripProfessionalRenderer.cs: Draw the whole unconnected area.

2008-09-16  Mario Carrion <mcarrion@novell.com>

	* ScrollBar.cs: New event added: UIAValueChanged, generated when
	  LargeChange, SmallChange, Maximum or Minimum values are changed.
	[Fixes bug #426464]

2008-09-16  Mario Carrion <mcarrion@novell.com>

	* ErrorProvider.cs: Component enabled to support accessibility.
	* Application.cs: Updated to Initialize UIA in ErrorProvider.
	[Fixes bug #426459]

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: Flag has_been_focused when SelectionStart is set
	so we don't highlight on first focus.
	[Fixes bug #360869]

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: Correctly calculate the height of the area we 
	need to invalidate when we have started scrolling and viewport_y
	is used.  [Fixes bug #387608]

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: When getting the SelectedText, don't add in
	NewLine characters, as they are already contained in the lines.
	[Fixes bug #388115]

2008-09-16  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: Replace the buggy Lines setter with one that
	simply concats the lines and send it to the Text setter.
	[Fixes issue #2 and #3 of 388115]

2008-09-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: The default value of DataSourceNullValue should be
	Convert.DBNull actually. Also, the NullValue should only be used *if*
	itself is not null, and use the null/Convert.DBNull value instead.

2008-09-15  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: Add a method to convert a string newline to the
	newline enum.
	* TextBoxBase.cs: When the user hits enter, insert a native newline.
	[Fixes part 1 of bug #388115]

2008-09-15  Mario Carrion <mcarrion@novell.com>

	* ToolTip.cs: UnPopup event set to internal to match public API.

2008-09-15  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: If the user is using Ctrl-Tab to move focus, we
	have to remove the Ctrl in order for the focus moving code to kick in.
	[Fixes bug #426170]

2008-09-15  Jonathan Pobst  <monkey@jpobst.com>

	* CheckedListBox.cs: Return the real item index from Add.  It may not be
	the last item if the list is sorted.  The user can change the NewValue in
	the ItemCheck event, we need to use that value if so.
	* ListBox.cs: Return the real item index from a sorted Add.
	[Fixes bug #426166]

2008-09-15  Ivan N. Zlatev  <contact@i-nz.net>

	* MimeIcon.cs: Add null checks in the GnomeHandler, because it might 
	happen that the icons from the theme is missing or the particular size 
	unavailable.
	[Fixes bug #424981]

2008-09-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When assigning null or DBNull depending on value/ref type,
	use IsValueType instead to get the precise desired value.
	Fixes #424276.

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* TreeNodeCollection.cs: When adding a new node to an opened node,
	we have to invalidate everything below the parent node because
	every node scoots down and we have to repaint them.
	[Fixes bug #411386]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Take CheckBox and RadioButton's CheckAlign
	property into account when drawing.
	[Fixes bug #416064]

2008-09-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When calling Items.Clear(), call
	SelectedIndexCollection.ClearCore instead of normal Clear method, to
	not fire any Selected*Changed event - this is done to match .net and
	don't have invalid values when changing the DataSourceProperty.
	Fixes #424273.

2008-09-12  Mario Carrion  <mcarrion@novell.com>

	* HelpProvider.cs: Control enabled to support accessibility.
	* Application.cs: Updated to Initialize UIA in HelpProvider.
	[Fixes bug #425988]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: When we are showing a dialog box, if its owner is TopMost,
	make the dialog TopMost as well.
	[Fixes bug #425984]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* Win32DnD.cs, XplatUIWin32.cs: Applied patch from Andy Hume that handles
	clipboard data better.
	[Fixes bug #414446]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: Applied patch from John Mortlock that ensures
	TextChanged and SelectionChanged events fire in the same order as .Net.
	[Fixes bug #425725]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: When sorting a column, if it only contains numbers,
	do a numeric sort instead of a string sort.
	[Fixes bug #425849]

2008-09-12  Jonathan Pobst  <monkey@jpobst.com>

	* TableLayoutSettings.cs, TableLayoutStyleCollection.cs: Guard
	against NRE's when the settings have a null panel.
	* TableLayoutPanel.cs: When setting the TableLayoutSettings, ensure
	the panel gets set.
	[Fixes bug #425647]

2008-09-11  Mario Carrion  <mcarrion@novell.com>

	* ToolTip.cs: Control enabled to support accessibility.
	* Application.cs: Updated to Initialize UIA in ToolTip.
	[Fixes bug #425277]

2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Make the custom Enumerator internal to fix build.

2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCheckBoxCell.cs: If our content is clicked and we aren't
	already in edit mode, begin edit mode.  Generally edit mode isn't
	started until the second click, but CheckBoxes are special.

2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* ErrorProvider.cs: Never try to add our icons to ContainerControl,
	since that can be set to anything.  Always add them to the Control's
	parent.  [Fixes bug #416058]

2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* ListView.cs: Use a custom enumerator for ListViewItemCollection
	so items can be deleted in a foreach.
	[Fixes bug #425342]

2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRow.cs: Better implementation of GetPreferredHeight.
	Store the user set explicit height so that the row can be AutoSized
	and then when AutoSize is turned off, it can get its original size back.
	* DataGridView.cs: Use the Row's GetPreferredHeight instead of 
	duplicating the logic.  When setting AutoSizeRowsMode to None, reset
	rows' heights back to their explicit values.
	[Fixes bug #415780]

2008-09-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: When getting focus, select the checkbox if we are
	already showing it. Also, don't change its value when pressing space
	if the checkbox is not visible (ShowCheckBox as false). Finally, the
	checkbox should remain selected as long as Checked is false, and the
	other parts are disabled.
	Fixes #424267.
	
2008-09-11  Jonathan Pobst  <monkey@jpobst.com>

	* MessageBox.cs: Handle shortcut keys to dialog buttons.
	[Fixes bug #425425]

2008-09-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When the value retrieved from the control property is
	null, don't return Convert.DBNull for Nullable instances, since they
	can *actually* get a null value.
	Fixes #424265.

2008-09-10  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Add an internal field to force doublebuffering regardless
	of what the public mechanisms are set to.  This is because MS's native
	controls are doublebuffered even though their .Net bits are set to false.
	* ProgressBar.cs: Set force_double_buffer to true.
	[Fixes bug #406595]

2008-09-10  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCheckBoxColumn.cs: Use the threestate constructor for
	the cell template.
	* DataGridViewCheckBoxCell.cs: Add proper support for threestate.
	* DataGridViewCell.cs: Implement GetEditedFormattedValue for types
	without EditingControls, paint background selection for types without
	EditingControls, reset the EditingCellValueChanged flag when the
	cell's value is committed.
	* DataGridView.cs: Make BeginEdit and EndEdit work with cells that don't
	have EditingControls, remove a double call to a cell's OnContentClickInternal,
	don't do cell changing logic in OnMouseDown if the cell didn't change.
	[Fixes bug #420351]

2008-09-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: Fix the edition of am/pm specifier.

2008-09-09  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: Add "&" to the list of valid characters in a URL.

2008-09-09  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* DateTimePicker.cs: Before incrementing or decrementing any part in
	the textbox, end any current edit. Also when ending the current edit
	use the editing_part_index field instead of the current selected
	value, since they can be out of synch, and we really need to work on
	the *real* current edit part. Finally when PartData.Selected changes,
	always try to end any ongoing edit.
	This should fix some small errors handling mouse navigation and
	increase/decrease operations.

2008-09-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: 'hh' and 'HH' formats (12 and 24 hour formats
	respectively) should handled different, since the 12 hours format
	needs the value typed by the user to be adjusted depending on the
	a.m/p.m value, so it is preserved, and only changed when the value
	reaches the 12 value (when it changes from a.m to p.m).
	Fixes part of #416555.

2008-09-08  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStrip.cs: Ensure MouseDown gets called for MenuStrip items.
	* ToolStripDropDownItem.cs: Don't fire events and such again if
	ShowDropDown is called on an already dropped down item.
	* ToolStripMenuItem.cs: Call ShowDropDown even if there aren't any
	subitems, the user may add some in the DropDownOpening event.
	[Fixes bug #417877]

2008-09-08  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Fix IOORE when setting SelectedItem to null.
	[Fixes bug #424270]

2008-09-08  Jonathan Pobst  <monkey@jpobst.com>

	* MdiClient.cs: When looking for menustrips on a child form to merge,
	look inside ToolStripContainers.
	[Fixes bug #424264]

2008-09-08  Ivan N. Zlatev  <contact@i-nz.net>

	* ErrorProvider.cs: Unbreak my previous commit.

2008-09-08  Ivan N. Zlatev  <contact@i-nz.net>

	* ErrorProvider.cs: Icon should always be 16x16.
	[Fixes bug #424380]

2008-09-07  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Invalidate the child items cache when the property 
	value changes.

2008-09-07  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs, PropertyGridView.cs: 
	   - Update the ReadOnly detection and rendering to finally hopefully 
	   match the one of MSFT.
	   - Niceify and move the debug CWLS.
	[Fixes bug #409028]

2008-09-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Don't call Invalidate at all from SetItemLocation,
	since we are already calling Invalidate for the entire control when
	needed - and call Redraw() when size changes, since we need to paint
	there by ourselved and not anymore from the mentioned method. 
	This should improve the layout process. Also clean some not needed calls 
	here and there.

2008-09-05  Jonathan Pobst  <monkey@jpobst.com>

	* MenuAPI.cs: Add a null check to the Alt-F4 code.
	[Fixes bug #420309]

2008-09-05  Jonathan Pobst  <monkey@jpobst.com>

	* ThreadExceptionDialog.cs: Disable AutoScaling for this dialog.
	[Fixes bug #423040]

2008-09-04  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs, CategoryGridEntry.cs, RootGridEntry.cs, PropertyGrid.cs, 
	PropertyGridView.sc: Implement lazy/delayed propertygrid population 
	on item expansion. Improves performance and fixes bug #417955.
	[Fixes bug #417955]

2008-09-05  Stephane Delcroix  <sdelcroix@novell.com>

	* Control.cs: only check for OptimizedDoubleBuffer in NET_2_0.
	fix the build.

2008-09-04  Jonathan Pobst  <monkey@jpobst.com>

	* TextControl.cs: Add "_" to the list of valid characters in a URL.
	[Fixes bug #423408]

2008-09-04  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: If using OptimizedDoubleBuffer, ensure the clip 
	region gets set.
	[Fixes bug #414166]

2008-09-04  Jonathan Pobst  <monkey@jpobst.com>

	* FontDialog.cs: When storing our font size from the starting font,
	use SizeInPoints instead of Size in case Size is a different unit
	from Points.
	[Fixes bug #416489]

2008-09-04  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs: When enter is pressed on a SaveFileDialog and we
	don't use it for anything else, check if a directory is highlighted.
	If it is, navigate into it.
	[Fixes bug #422087]

2008-09-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When acquiring a BindingManagerBase for the first time,
	check that the specified property actually exists in the data source,
	and throw an ArgumentException if that's not the case - this is only
	done for this scenario, since for later cases (such Position changes)
	we throw different exceptions (match .Net).

2008-09-03  Ivan N. Zlatev  <contact@i-nz.net>

	* ButtonBase.cs CheckBox.cs, Control.cs, FlowLayoutPanel.cs, 
	  FlowLayoutSettings.cs, GroupBox.cs, Label.cs, ListBox.cs, 
	  PropertyGrid.cs, RadioButton.cs, TableLayoutPanel.cs, 
	  TableLayoutSettings.cs, ToolStrip.cs, ToolStripDropDownButton.cs, 
	  ToolStripDropDownMenu.cs, ToolStripItem.cs, ToolStripSplitButton.cs, 
	  ToolStripStatusLabel.cs: Add missing PerformLayout calls to various 
	  properties.
	  [Fixes bug #418684]

2008-09-03  Neville Gao  <nevillegao@gmail.com>

	* StatusBar.cs: Control enabled to support accessibility.
	[Fixes bug #419079]

2008-09-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When connecting the event handler for the "Changed"
	event for the property, only do it for PropertyManager, and not for
	CurrencyManager - this is exactly what does .Net, totally ignoring any
	change in the property of the elements of a list.
	Fixes the tests.

2008-09-02  Jonathan Pobst  <monkey@jpobst.com>

	* XplatUIWin32.cs: Ensure we never send the WS_EX_MDICHILD flag
	to Windows when creating a window, as we fake MDI stuffs.
	[Fixes bug #421858]

2008-09-01  Ivan N. Zlatev  <contact@i-nz.net>

	* TextBox.cs: Invalidate after UseSystemPasswordChar, so that the 
	change takes effect.

2008-08-24  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Provide MouseButtons/State information to the XPlatUI.
	[Fixes bug #419001]

2008-08-27  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Raise CellContentClick event.
	[Fixes part of bug #420351]

2008-08-27  Mario Carrion  <mcarrion@novell.com>

	* ScrollBar.cs: Control enabled to support accessibility.
	[Fixes bug #416759]

2008-08-27  Mario Carrion  <mcarrion@novell.com>

	* ComboBox.cs: Control enabled to support accessibility.
	[Fixes bug #416663]

2008-08-27  Mario Carrion  <mcarrion@novell.com>

	* ListBox.cs: Control enabled to support accessibility.
	[Fixes bug #416640]

2008-08-27  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: Don't suppress the TextChanged event when changing
	the SelectedIndex.
	* ToolStripComboBox.cs: Listen to the ComboBox's TextChanged event
	and re-raise it.
	[Fixes bug #420673]

2008-08-26  Jonathan Pobst  <monkey@jpobst.com>

	* ErrorProvider.cs: Fix a regression NRE when setting properties
	for a control before it has a parent.
	[Fixes bug #420305]

2008-08-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: Use the BindingManagerBase.Current value to obtain
	connect the property "Changed" event, instead of using the data
	sources - this is useful when the property specifies actually a
	multiple objects path.
	Fixes part of #417973.

2008-08-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* RelatedPropertyManager.cs: PropertyManager instances associated to a
	nested properties should return not the properties of the data source
	itself, but the properties of the type of a specific property in the
	data source - match .net.

2008-08-24  Gert Driesen  <drieseng@users.sourceforge.net>

	* ListBox.cs (IntegerCollection): To avoid duplication, moved code for
	AddRange overloads into AddItems method, and added missing NULL check.
	Added extra argument check to RemoveAt for compatibility with MS. 
	Modified IList implementation of Add, Contains, IndexOf and Remove to
	throw an ArgumentException if item is not an int. Modified IList.Insert
	to throw a NotSupportException instead of an Exception. Implemented
	ICollection.
	(ObjectCollection): To avoid duplication, use AddItems method from
	AddRange overloads. On 1.0 profile, first perform NULL check on items
	in AddItems.

2008-08-23  Gert Driesen  <drieseng@users.sourceforge.net>

	* Control.cs: Do not modify bounds directly in .ctor's. Fixes bug
	 #419087.

2008-08-22  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : comment out some Console.WriteLine().

2008-08-22  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : fixed wrong call to XOpenIM() which happened
	  even if premises are not filled. Also XLookupString() was not
	  receiving correct input, which blocked precise input handling
	  on non-XIM mode.

2008-08-20  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* ListView.cs: When calling OnCacheVirtualItems, cast to the right
	type of delegate, instead of EventHandler - this was causing a type
	cast exception in all apps handling this event.
	Fixes #417876.

2008-08-20  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownItem.cs: Always raise DropDownOpening in
	ShowDropDown to give the user a chance to dynamically add
	drop down items.  [Step 1 of fixing bug #417877]

2008-08-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Don't fire pseudo motion DragOver events if we haven't
	had any mouse motion since the call to StartDrag, to match the dnd
	behaviour of .net.
	Fixes part of #381876.

2008-08-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Only do the children control bounds check for EnterNotify
	if mode is NotifyUngrab, and let it flow if mode is NotifyNormal.
	Also, if we are actually moving into a different window after
	grabbing, generate a LeaveNotify event for the previous window, since
	we need to fire the leave events until the grab ends, not when
	actually moving outside of the control.

2008-08-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: The check inside EnterNotify case to fire MouseEnter
	events only for client windows was wrong - we need to compare the
	client window against the window receiving the EnterNotify event, not
	against zero (since client window is never Zero, btw).
	This prevents having unnecessary handling of EnterNotify events for
	non-client windows when a gran begins.

2008-08-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Handling X ButtonPress events, we must *not* generate
	MouseMove/MotionNotify events at all (which should only happen after
	MouseUp/ButtonRelease, as .Net does).
	This avoids firing an extra and unnecessary MouseMove event just after
	every MouseDown event.

2008-08-19  Jonathan Pobst  <monkey@jpobst.com>

	* LinkLabel.cs: Always clear any previous links when LinkArea
	is set.  [Fixes bug #410709]

2008-08-19  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripProfessionalRenderer.cs: Revert last change.
	* ProfessionalColorTable.cs: For Classic, use SystemColors.Window
	for ToolStripDropDownBackground.

2008-08-19  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripProfessionalRenderer.cs: Use Window color for the 
	background of dropdowns to match .Net when the user is not
	using the default white.  [Fixes bug #418108]

2008-08-19  Atsushi Enomoto  <atsushi@ximian.com>

	* XplatUIWin32.cs : SetTimer() used to set wrong window handle and
	  it caused timer registration twice. Fixed bug #418107.

2008-08-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	[Correction: This is the actual change to X11Dnd issue, not the
	previous one, which was actually a different issue.]

	* X11Dnd.cs: Increase the interval for the Timer, to not fire our
	pseudo motion HandleMouseOver method so aggresive. Also, don't call it
	when the pointer is actually in motion, but only when the pointer
	seems to stop (as .net does).
	Fixes part of #381876.


2008-08-18  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Fix CopyTo implementation.
	[Fixes bug #409169]

2008-08-18  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Use ClientRectangle instead of Bounds when
	drawing a ComboBox's background.  Fixes bad disabled rendering when
	the control is not at 0,0.
	[Fixes bug #416063]

2008-08-16  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Leave the ICustomTypeDescriptor handling up to the 
	ComponentModel layer, which will properly prioritize the attributes.
	Avoids wrong prioritization of duplicate attributes when retrieving 
	the converter and editor.
	[Fixes bug #417729]

2008-08-15  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Increase the interval for the Timer, to not fire our
	pseudo motion HandleMouseOver method so aggresive. Also, don't call it
	when the pointer is actually in motion, but only when the pointer
	seems to stop (as .net does).
	Fixes part of #381876.

2008-08-15  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Perform stricter check for the ParentEntry's 
	PropertyDescriptor/PropertyOwner for the ICustomTypeDescriptor 
	implementation.
	[Fixes bug #417567]

2008-08-14  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Properly implement PeekMessage and DoEvents.
	Fixes #396983.  Properly fix ActiveWindow trackin and do not
	prematurely show POPUP windows.

2008-08-12  Carlos Alberto Cortez <calberto.cortez@gmail.com> 

	* XplatUIX11.cs: Handle the obscured regions while scrolling using
	GraphicsExpose event, processing it just after we copy the scrolled
	area. This ensures that the next calls to ScrollWindow will copy
	regions already updated, and the scrolling will be smooth. Also remove
	the code that was trying to detect the obscured regions, since we are
	not using it anymore (too slow).

2008-08-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: Fix the -temporary- broken selection in ListBox for
	MultiExtended mode, by separating some logic between the ctrl/shift
	handling. Also ignore any MouseMove events generated together with
	MouseDown events - we are only interested in the real motion event.
	Fixes part of #414963.

2008-08-08  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Guard against an AOORE when checking if a cell
	is selected.  [Fixes bug #414143]

2008-08-07  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Check if current property is a ICustomTypeDescriptor 
	and not the parent one (the propertyowner). Fixes the behavior of 
	GetConverter/GetEditor.
	[Fixes bug #415452]

2008-08-07  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Refresh should also repopulate the PropertyGrid.
	[Fixes part of bug #415452]

2008-08-05  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: ITypeDescriptorContext should be relative to the parent 
	GridEntry, not the current.
	[Fixes bug #413896]

2008-08-04  Ivan N. Zlatev  <contact@i-nz.net>

	* TextBoxBase.cs: De-internalize max_length field.
	* RichTextBox.cs: Use base.MaxLength - both TextBoxBase and RichTextBox 
	share the same logic.
	[Fixes bug #414454]

2008-08-03  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: Selection changes made in the MouseDown handler should
	use the *Core versions of selection in SelectedIndices collection,
	since the SelectedIndexChanged/SelectedValueChanged events are fired
	until we get a MouseUp event, and thus we need to separate the logic
	from the events, as done in the keyboard navigation. Also, fire those
	selection events from keyboard navigation in SelectionMode.None, even
	if we don't have a selection, as .Net does.

2008-08-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripButton.cs, ToolStripMenuItem.cs: Guard against a NRE my
	last change introduced when an item is clicked but isn't on a toolstrip.

2008-07-31  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBindingHelper.cs: When looking for an object's properties, check
	if it implements ICustomTypeDescriptor, in which case we should
	resolve the propertu based on its GetProperties method, not in its
	actual properties. This is what .Net seems to do.
	Fixes a UsingWebBrowser problem during initialization.

2008-07-31  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStrip.cs: Fix an NRE caused by clicking on a ToolStripButton
	sitting on a MenuStrip.

2008-07-31  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripButton.cs: If we "click" a top button on a menustrip that has
	no children with the keyboard, we need to release the keyboard capture.
	[Fixes bug #413567]

2008-07-31  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripMenuItem.cs: If we "click" a top level menu item that has
	no children with the keyboard, we need to release the keyboard capture.
	[Fixes bug #413567]

2008-07-31  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Made ScrollBar rendering less strict so it supports
	the GTK+-based implementation of VisualStyles.
	* ThemeWin32Classic.cs: Exposed various layout values for use in the
	GTK+-based implementation of VisualStyles: ListViewGetHeaderHeight(Font),
	ListViewGetHeaderHeight(), ProgressBarChunkSpacing, ProgressBarGetChunkSize(),
	ProgressBarGetChunkSize(int), ProgressBarDefaultHeight,
	TrackBarGetThumbSize(), TrackBarVerticalTrackWidth,
	TrackBarHorizontalTrackHeight.

2008-07-31  George Giolfan  <georgegiolfan@yahoo.com>

	* TabControl.cs: Added hot style handling for the scroll buttons.
	right_slider_state, left_slider_state are now of type PushButtonState to
	allow for a hot state. Added tracking of the mouse button being held down
	on a tab page. Extracted HasHotElementStyles, RightScrollButtonArea,
	LeftScrollButtonArea.
	* Theme.cs, ThemeWin32Classic.cs: Removed TabControlGetLeftScrollRect,
	TabControlGetRightScrollRect.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Check for null GrabControl on ProcessMnemonic to prevent 
	runtime errors.

2008-07-30  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Ensure that we reset the shown_raised flag after 
	the form is closed, so that we raise the show events the next 
	time the form is shown.
	[Fixes bug #413141]

2008-07-30  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Ensure closing events are raised only once.
	[Fixes bug #413143]

2008-07-30  Ivan N. Zlatev  <contact@i-nz.net>

	* X11Keyboard.cs: Refactor SendKeyboardInput to accept the keycode, 
	so that we can successfully generate the LParam in-place instead of 
	in KeyEvent, which isn't called for e.g. MainMenu. Fixes keyboard 
	navigation for menus.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: When montion don't set the keyboard navigation state to 
	'navigating'. Fixes bug #411356.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	[Fixed remaining issues of #406773 (#1)]
	* MenuItem.cs: UpdateMenuItem added to track the shotcut changes.

	* MenuAPI.cs: Don't create tracker on TrackPopupMenu, it will be created in
	MainMenu (already done) and ContextMenu creation.

	* ContextMenu.cs: Create tracker on construction. 

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: For ContextMenu set GrabControl on TrackPopupMenu, it make
	possible to instantiate MenuTracker without GrabControl.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: On constructor dont set the GrabControl for non ContextMenu.

	* MainMenu.cs: Set GrabControl on SetForm using current form.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Chage grab_control to GrabControl and make it public.

2008-07-30  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Check if menu is activated before deactivate it in 
	ProcessShortcut.

2008-07-30  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutStyleCollection, TableLayoutStyle.cs, RowStyle.cs, 
	ColumnStyle.cs: 
	Make the TableLayoutStyle owned by the the TableLayoutPanel, so that:
	 - One style instance can only participate in a single style collection.
	 - Styles can request their owner to layout whenever their properties 
	 change.
	 [Fixes bugs #412583 and #412582]

2008-07-29  Ivan N. Zlatev  <contact@i-nz.net>

	* X11Keyboard.cs: Implement the generation of the LParam for 
	all keyboard messages.
	[Fixes bug #378728]

2008-07-29  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Don't let the user set TopIndex so high that it
	scrolls up far enough to show empty items.
	[Fixes bug #412728]

2008-07-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: Actually commit the changes to fix #410880
	(I'm an idiot and forgot to commit the actual changes, as well as
	specify the right file, which is this one, not ListView.cs).

2008-07-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Don't draw ListViewSubItem instances from
	DrawListViewItem - we need to reuse the main item's drawing for the
	first sub item in case owner draw is true, but wants the system to
	do the default draw for the first sub item, without incurring in a
	recursion problem.
	Fixes #410880.

2008-07-28  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripButton.cs: Update Checked for CheckOnClick before
	raising the Click event.  [Fixes bug #412505]

2008-07-28  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Remove some seems leftover code for non-TopLevel's 
	CreateParams, which is breaking ClientSize sizing, because it 
	removes the border window styles.

2008-07-27  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Invalidate the View when the PropertyTab 
	changes.

2008-07-25  Gert Driesen  <drieseng@users.sourceforge.net>

	* WebBrowser.cs: Removed debug output.

2008-07-25  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs: Apply patch from Ernesto to clean up some
	dialog messages.

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutPanel.cs: Perform layout on GrowStyle change, so 
	that the change has an immediate effect.

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* ScrollableControl.cs: Update PerformLayout calls to include 
	provide the name of the property that changed.

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutPanel.cs: Draw relative to the DisplayRectangle 
	location. Fixes drawing of border and cell borders if scrollable.

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* ScrollableControl.cs: Perform layouting after the AutoScroll 
	properties have changed, so that the changes have immediate 
	effect.
	[Fixes bug #409090]

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Non Client area is actually Client such in the 
	case of NotifyIcon, so double check WholeWindow == ClientWindow 
	when adding an expose.
	[Fixes bugs #324237 and #357022]

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutPanel.cs: Invalidate after layouting, so that we 
	repaint the cell borders.

2008-07-25  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGridTextBox.cs: Stop filtering messages prior to our 
	disposal to avoid unexpected ObjectDisposedExceptions.

2008-07-24  Ivan N. Zlatev  <contact@i-nz.net>

	* TableLayoutPanel.cs: Layout on Row/Column count change.

2008-07-22  Gert Driesen  <drieseng@users.sourceforge.net>

	* ListViewItem.cs: Changed binary serialization to match MS. Fixes
	bug #409351.
	* PictureBox.cs: When ImageLocation is set to null or an empty string,
	only set image to null if it was previously initialized from an url
	(or using ImageLocation). In ImageLocation, load specified image
	asynchronously if WaitOnLoad is false. Added support for local file
	paths to LoadAsync, and added missing argument check.

2008-07-22  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* DateTimePicker.cs: 
	* ThemeWin32Classic.cs: Add a editing capability to DateTimePicker, in
	order to set the value as required (which means: when selection
	changes for a part being edited, and not before that if not needed).
	Also use an enum to describe which part are we using, and use the
	selection as a property in PartData, in order to notify the
	DateTimePicker owner that we need to end the current edit.
	Fixes #383462.

2008-07-17  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGridTextBox.cs: Validation should be performed only if we 
	are focused. We can lose focus for example if the Return key is used 
	to set the entry and there is an error. When the message box is 
	displayed we would have validate on click in the message box.

2008-07-16  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Checking for DesignerSerializaitonVisibility.Content 
	in order to determine that we are expandable is wrong. There was a bug, 
	now fixed, in TypeDescriptor that was causing the wrong converter to be 
	returned which caused GetPropertiesSupported == false in most cases.
	[Fixes bug #409027]

2008-07-15  Jonathan Pobst  <monkey@jpobst.com>

	* ImageList.cs: Fix ICollection.CopyTo implementation for
	ImageListCollection.  [Fixes bug #409169]

2008-07-14  Jonathan Pobst  <monkey@jpobst.com>

	* MenuAPI.cs, ToolStripDropDown.cs: Use VirtualScreen instead of
	WorkingArea so that menus can appear on the second monitor
	when one has dual monitors.

2008-07-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Auto complete stuff in WndProc should be 2.0 only.
	Fixes build.

2008-07-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Implement navigation support for auto complete in
	TextBox, as well as refactor the code to show the auto complete window
	when receiving a WM_CHAR message, instead of TextChanged, since
	autocomplete itself should be able to set the Text a lot of times and
	finally only typing should show it, not changes from code.

2008-07-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When expanding the selected tab, don't adjust the
	width if alignment is Right, since it has a different offset than 0,
	as opposed to the other alignments.
	Fixes the selected tab not being painted at all with alignment = Right
	and using FillToRight size mode.

2008-07-14  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Fix ToString to match MS.  [Fixes bug #409029]

2008-07-14  Jonathan Pobst  <monkey@jpobst.com>

	* NumericUpDown.cs: Apply patch from Andy Hume to clamp out of range
	values from the textbox to the boundary values.  [Fixes bug #409026]

2008-07-14  Jonathan Pobst  <monkey@jpobst.com>

	* TreeNodeCollection.cs: We were copying one too many elements when
	doing our array copy.  Fixes a crash when RemoveAt is called.
	[Fixes bug #408999]

2008-07-14  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When doing the layout and need to call FillRow -using
	FillToRight size mode-, use the overload receiving a bool param
	indicating whether we need to do a vertical or horizontal calculation.
	Fixes part of #399583.

2008-07-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: When painting, use the value returned by
	GetLastVisibleItem instead of using the cached last_item field, since
	there could be a desynchronization between the layout and the
	painting. Fixes a AOOR exception in auto complete mode.

2008-07-12  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Disabled when Application.VisualStyleState is
	NonClientAreaEnabled until our VisualStyles is modified to allow it.

2008-07-12  Gert Driesen  <drieseng@users.sourceforge.net>

	* TextBox.cs: Fixed NRE in LostFocus. Avoid unnecessary initialization.

2008-07-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: When focus is lost, if the auto complete listbox is
	visible, hide it.

2008-07-11  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: HandleSizing: Implemented a better minimum
	tracking size for tool windows.
	* Theme.cs, ThemeWin32Classic.cs : Extracted
	ManagedWindowSpacingAfterLastTitleButton.

2008-07-11  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeEngine.cs: Remove the clearlooks, nice, and old gtk themes.
	They are bit-rotted and have always been listed as "unsupported".

2008-07-11  Jonathan Pobst  <monkey@jpobst.com>

	* PictureBox.cs: Don't crash if ImageLocation is set to "" or null.

2008-07-11  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Fixed minimized window height adjustment.

2008-07-10  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Make sure last_item_visible gets reset before we try
	to do a layout due to scrollbars appearing or disappearing.
	[Fixes bug #408139]

2008-07-10  Jonathan Pobst  <monkey@jpobst.com>

	* XPlatUIWin32.cs: Change GetMenuOrigin to calculate borders better
	for different window themes.  [Fixes bug #339140]

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Implemented minimized window border width properly,
	in ManagedWindowBorderWidth.

2008-07-10  Jonathan Pobst  <monkey@jpobst.com>

	* InternalWindowManager.cs: Change MouseMove to take a point, so
	we can use the same point later on.
	* MdiWindowManager.cs: Store point sent to MouseMove so we can
	later reset to it.  On Windows, the Cursor.Position had already
	changed by the time we were resetting to it.
	[Fixes bug #363239]

2008-07-10  Jonathan Pobst  <monkey@jpobst.com>

	* InternalWindowManager.cs: Ignore mouse actions on TitleButtons that
	are inactive.
	* ThemeWin32Classic.cs: Disable or hide MinimizeBox/MaximizeBox if
	user requested it.
	[Fixes bug #398686]

2008-07-10  Jonathan Pobst  <monkey@jpobst.com>

	* MdiWindowManager.cs: Double-clicking on the title bar should not
	maximize a MDI form if MaximizeBox = false.

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Fixed a warning.

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Fixed warnings and formatted.

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Removed ManagedWindowGetMenuButtonSize. The base
	implementation produces a better result.

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Adjusted height and border rendering for minimized
	windows.

2008-07-10  George Giolfan  <georgegiolfan@yahoo.com>

	* Application.cs: Added VisualStylesEnabled because XplatUI.ThemesEnabled
	cannot be used from the ThemeEngine constructor.
	* ThemeEngine.cs: Changed the XplatUI.ThemesEnabled check to
	Application.VisualStylesEnabled because it does not work on X11.

2008-07-09  Jonathan Pobst  <monkey@jpobst.com>

	* StatusBar.cs: Apply patch from Andy Hume to remove lazy instantiation
	that we did not always check for, as well as fixes to the IList
	implementations.  [Fixes bug #402703]

2008-07-09  George Giolfan  <georgegiolfan@yahoo.com>

	* IDeviceContext.cs: Added Dispose.

2008-07-09  George Giolfan  <georgegiolfan@yahoo.com>

	* Control.cs: Added OnSizeInitializedOrChanged.
	* Form.cs: OnLoadInternal: Added a call to
	Control.OnSizeInitializedOrChanged.
	* InternalWindowManager.cs:
	 * HandleTitleBarMouseMove: No longer invalidates the parent window.
	 * DrawTitleButton: Extracted Theme.ManagedWindowDrawMenuButton.
	 * TitleButton: Added Entered.
	 * TitleButtons.MouseMove: Added handling of TitleButton.Entered.
	* MdiWindowManager.cs:
	 * HandleTitleBarMouseMove: Now invalidates the parent window when a mouse
	 move over the maximized title buttons causes a change.
	 * IsActive: Can now be called before the window is added to a MDI parent.
	* Theme.cs: Added ManagedWindowTitleButtonHasHotElementStyle,
	ManagedWindowDrawMenuButton, ManagedWindowOnSizeInitializedOrChanged.
	* ThemeVisualStyles.cs: Implemented proper managed window rendering.
	* ThemeWin32Classic.cs:
	 * Extracted ManagedWindowDrawTitleBarAndBorders, ManagedWindowDrawTitleButton.
	 * DrawTitleButton takes a new form parameter.
	 * Added ManagedWindowTitleButtonHasHotElementStyle,
	 ManagedWindowDrawMenuButton, ManagedWindowOnSizeInitializedOrChanged.

2008-07-09  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeEngine.cs: ThemeVisualStyles is now selected if
	Application.EnableVisualStyles has been called, even if the current system
	configuration does not support rendering with Visual Styles.
	* ThemeVisualStyles.cs: Now falls back to ThemeWin32Classic when Visual
	Styles should not be used.

2008-07-08  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: PreferredHeight is not tied to ItemHeight.  Fixes 3rd
	ComboBox in FormsTest.

2008-07-08  Ivan N. Zlatev  <contact@i-nz.net>

	* ThemeWin32Classic.cs: (ManagedWindowBorderWidth): width 3 is only 
	for fixed toolwindows.

2008-07-08  George Giolfan  <georgegiolfan@yahoo.com>

	* Form.cs: SetBoundsCore: Added minimum size for minimized windows.

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* Control.cs: CreateControl just returns if the Control is diposed 
	and doesn't throw ObjectDisposedException.
	[Fixes bug #406566]

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* Control.cs: Do not create the control if the parent isn't created 
	yet, e.g in the case of a parented form on which .Show is called.
	It will be created when the parent is made visible/created.
	Improves #402446.

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Avoid recursively calling OnSizeChanged due to recursive 
	WM_WINDOWPOSCHANGED caused by the layouting code on win32.
	[Fixes bug #406786]

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: When disposed set owner to null. Improves #402446.

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs, FlowLayoutPanel.cs: When calculating the PreferredSize 
	use children's PreferredSize if in AutoSize mode and ExplicitBounds 
	if not.
	* Form.cs: Take the Padding into account for the PreferredSize.
	[Fixes bug #402849]

2008-07-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Since we don't support more than one direction in
	TabControl rows alignment (this is, the row becomes the
	bottom row when selected), make Direction return always 1. This way
	the layout doesn't get confused about a bad calculation.
	Fixes #399582.

2008-07-07  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Implement NC hit-testing for mouse down/up messages, 
	so that the wparam is properly set.
	Fixes form moving in the test case in bug 402446.

2008-07-07  Jonathan Pobst  <monkey@jpobst.com>

	* FolderBrowserDialog.cs: If we can't find the SelectedPath, display
	the full tree instead of nothing.  [Improves bug #406584]

2008-07-07  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Adjusted minimized window painting.

2008-07-07  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: No longer draws decorations for maximized MDI
	children.

2008-07-04  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Add a null check when using CollapseAll on an
	empty tree.  [Fixes bug #406449]

2008-07-03  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Make OnMenuComplete internal so we can call it.
	* MenuAPI.cs: Raise Form.MenuComplete when a menu item is clicked.
	[Fixes bug #399321]

2008-07-03  Jonathan Pobst  <monkey@jpobst.com>

	* TabControl.cs: Handle Up and Down keys when TabControl is in
	vertical alignment.
	[Fixes bug #399585]

2008-07-03  Jonathan Pobst  <monkey@jpobst.com>

	* TabControl.cs: Invalidate when we remove a tab.  Guard against
	an AOORE when trying to remove a tabpage that is not owned by the
	parent control.
	[Fixes bug #399927]

2008-07-03  Jonathan Pobst  <monkey@jpobst.com>

	* ScrollBar.cs: Change the LargeChange calculation to be correct.
	Ensure we are using LargeChange instead of large_change so we our
	calculations are correct.
	[Fixes bug #403122]

2008-07-03  Jonathan Pobst  <monkey@jpobst.com>

	* TableLayoutPanel.cs: When we change to a serialized TableLayoutSettings,
	we need to ensure the ColumnCount/RowCount gets set.
	[Fixes bug #404851]

2008-07-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When handling item navigation, if selection mode is
	None, call EnsureVisible, since scrolling is normally handled by
	selection, that we are not calling in this case.
	Fixes #398345.

2008-07-02  Jonathan Pobst  <monkey@jpobst.com>

	* ContainerControl.cs: Apply a patch from Ernesto Carrea that adds
	a null check to our focus walking code.  [Fixes bug #394332]

2008-07-02  Andy Hume <andyhume32 at yahoo dot co dot uk>

        * ComboBox.cs: Case missed in bug 379596 "Support item
        navigation by entering text": On _close_ drop-down select
        the first item matching the text in the textbox.  [Fixes bug #397265]

2008-07-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Fix a crash when sorting by column headers, 
	mentioned in bug #404841.  Remove some dead switch cases.

2008-07-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs:
	* TextBox.cs: Implement AutoComplete support for ComboBox, which just
	uses the AutoComplete support in the internal TextBox. Also TextBox
	can store a reference to ComboBox, in case AutoCompleteSource is set
	to ListItems (this is, ComboBox's items, and we don't want to pass an
	additional collection).

2008-07-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewItem.cs: Restore the initial value of bounds rect to
	Rectangle.Empty, and is this value for Layout detection in virtual
	mode. Fixes the tests.

2008-06-30  Jonathan Pobst  <monkey@jpobst.com>

	* XPlatUI.cs: Remove references to "new" X11 backend.

2008-06-28  Ivan N. Zlatev  <contact@i-nz.net>

	* Control.cs: Add an internal virtual OnDragDropEnd method 
	to allow controls such as ListBox, which depend on a sequence 
	of MouseDown+Move+End events, to handle the lack of a MouseUp 
	when a DnD operation is started in MouseDown.
	* ListBox.cs: If a DnD operation is started in MouseDown we won't 
	get a MouseUp, so reset our state whenever a DnD operation ends.

2008-06-28  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Clear the root griditem first thing when 
	new object/s is/are selected. Fixes some rare cases where 
	the View will get a paint request and won't know that the 
	grid is in the process of repopulating.

2008-06-27  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs, InternalWindowManager.cs: 
	If WS_EX_TOOLWINDOW is set in the CreateParams for a form MS 
	doesn't automagically update the FormBorderStyle, so we must 
	double check the CreateParams explicitly to determine if the 
	window is a toolwindow.
	* ThemeWin32Classic.cs: Use InternalWindowManager.IsToolWindow 
	instead of doing custom checks.

	Fixes toolwindows for the test case in bug #402446

2008-06-27  Ivan N. Zlatev  <contact@i-nz.net>

	* Control.cs: Visibility of the control should be false 
	when the handle is destroyed in WmDestroy and not immediately 
	in Dispose(). This is effectively where the disposing process 
	ends even though the control is marked as Disposed immediately 
	after calling Dispose().
	[Fixes bug #402446]

2008-06-27  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGridTextBox.cs: Start monitoring the mouse clicks 
	when the textbox gets focus.
	[Fixes bug #402704]

2008-06-27  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGridTextBox.cs, PropertyGridView.cs: 
	 - Alt + Down should show the drop down editor.
	 - Focus the editor when showing it
	[Fixes bug #402710]

2008-06-25  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Fix from Andy for panel text for panels
	that are not the first panel.
	* StatusBar.cs: Ensure that the X coordinate of panels is always
	stored.  Fix IList implementation of StatusBarPanelCollection to
	call the regular methods.
	[Fixes bug #403599, #402165]

2008-06-23  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Fix position calculation for centered
	text on status bar panels.  [Fixes bug #402165]

2008-06-22  Ivan N. Zlatev  <contact@i-nz.net>

	* Splitter.cs: Fix Splitter to:
	 - Work for arbitrary splitter size
	 - Handle MinSize and MinExtra properly
	 - Get rid of absolute positioning during drag and use relative
	 - Multiple other fixes 
	 [Fixes bug #338966]

2008-06-22  Ivan N. Zlatev  <contact@i-nz.net>

	* Cursor.cs: Show shouldn't hide the cursor.

2008-06-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewItem.cs: When invalidating, add some extra space to bounds,
	since focus rectangle and selection can add some space and need to
	take into account those small offsets - specially in Details view.
	* ListView.cs: Instead of invalidate using item Bounds directly, call
	item.Invalidate, to have the code centralized.
	Fixes focused/selection garbage when selecting and deselecting items
	that are close.

2008-06-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewItem.cs: Set bounds initially to -1 values - thus in virtual
	mode we can check whether we have to force a Layout or not, and can
	cache based on this, instead of avoiding caching all the the time. Do
	this check in GetBounds and TextBounds.
	Fixes selection in Details view.

2008-06-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Make HeaderControl internal, thus the theme engine can
	get its *real* height instead of trying to infere it.
	* ThemeWin32Classic.cs: When drawing gridlines, don't iterate over the items to
	get the position of them, since it's in general a bad idea in general,
	and because we can't do that in virtual mode. Instead get the first
	visible item as well as item height, and draw them.
	Fixes #400390.

2008-06-20  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripSplitButton.cs: We can't add in extra width if
	the button is not AutoSize.  [Fixes bug #401279]

2008-06-20  Ivan N. Zlatev  <contact@i-nz.net>

	* PaddingConverter.cs: 
	 - Implement conversion to InstanceDescriptor
	 - Handle "All" in CreateInstance by using the supplied 
	 ITypeDescriptorContext.
	 [Fixes bugs #396076 and #396078]

	 Patch by Andy Hume  <andyhume32@yahoo.co.uk>
         Code contributed under MIT/X11 license.

2008-06-19  Andy Hume <andyhume32 at yahoo dot co dot uk>

        * ComboBox.cs, ListControl.cs, Control.cs, Button.cs, 
	ButtonBase.cs:
	Add Category attributes.
	Code is contributed under the MIT/X11 license.

2008-06-18  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: 
	 - Fix a NRE when unparenting a form.
	 - Do not recreate or destroy a parented form when 
	unparenting. 

2008-06-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TextBox.cs: Implement basic support for AutComplete with custom
	sources.

2008-06-18  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripSplitButton.cs: Left and Top of ButtonBounds, SplitterBounds,
	DropDownButtonBounds should be from the origin of the button, not the
	ToolStrip.  [Fixes bug #401279]

2008-06-16  Sandy Armstrong <sanfordarmstrong@gmail.com> 

	* X11DesktopColors.cs: Clear GTK_MODULES environment variable before
	  running gtk_init_check.  This prevents GAIL from loading
	  unnecessarily, which was breaking UIA support.  Initial fix for bug
	  #375987.
	* Application.cs: Add UIA support to Winforms.  New static constructor
	  uses reflection to initialize UIAutomationWinforms assembly.  Added
	  PreRun event so UIA can initialize before the mainloop starts, and
	  FormAdded event so UIA can provide a11y support for new Forms in an
	  Application.

2008-06-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: When binding to a dataset, subscribe to table
	and column change events.  Unsubscribe to these when we clear bindings.
	[Fixes bug #399601]

2008-06-14  Everaldo Canuto  <ecanuto@novell.com>

	[DataGrid drawing refactory]

	* DataGrid.cs: Fix the caption size, we need one pixel more for divider.

	* DataGridColumnStyle.cs: Removing PaintHeader code, the draw operations
	must be handle by Theme, now it call DataGridPaintColumnHeader.

	* DataGridTextBoxColumn.cs: Fix the textbox size. It must be one pixel less,
	test cases must be also fixed because it checks for wrong size.

	* ThemeWin32Classic.cs: 
		- Draw the bottom line of grid caption.
		- Prevent to draw caption text when it is empty.
		- Use CPDrawBorder3D for 3D efects to simplify code.
		- Uses 3D (when not flat) to paint corner shared between row and column
		header.
		- Fix header drawing issues on win32, now borders are drawing.
		- Fix column header paint issues to mimic win32.
		- Adjust header drawing for last column, like first one it must be draw
		different.
		- Added DataGridPaintRowHeaderStar to draw star like .net does, it is
		not an character.
		- DataGridPaintColumnHeader created to draw column headers, it also
		paint stuff right on Win32.
		- Use DataGridPaintColumnHeader method instead of DataGridColumnStyle 
		class.

	* Theme.cs: 
		- DataGridPaintRowHeaderStar method added.
		- DataGridPaintColumnHeader method added.

2008-06-13  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Don't reset to Dock style layout if DockStyle is
	set to none.  [Fixes bug #399316]

2008-06-12  Everaldo Canuto  <ecanuto@novell.com>

	* Win32DnD.cs: Fix the check for control not equal null.
	Fixes bug #341420 and #381886. 

2008-06-12  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRowCollection.cs: Update the indexes of rows after
	one has been removed.
	* DataGridViewSelectedRowCollection.cs: Add internal clear method.
	* DataGridViewSelectedColumnCollection.cs: Add internal clear method.
	* DataGridView.cs: Add support for deleting rows via Delete key, deleting
	rows for the Rows collection, or deleting rows from the bound DataSet.

2008-06-12  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Listen to a DataSet's changed event even
	when autogeneratecolumns is false.  Refactor the changed event's
	add row code to use the same as the existing add row code.
	[Fixes bug #399601]

2008-06-11  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: We need to call RaiseSelectionChanged pretty
	much any time the caret moves and there is text, not just when
	the selection changes as one would think.
	* RichTextBox.cs: Override RaiseSelectionChanged and fire
	SelectionChanged.
	[Fixes bug #397271]

2008-06-11  Jonathan Pobst  <monkey@jpobst.com>

	* FontDialog.cs: Forward ListBox keyboard events to the ListBox
	instead of trying to duplicate the code.
	* ListBox.cs: Make method internal so we can send keyboard events.
	[Fixes bug #398344]
	
2008-06-11  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxBase.cs: When pasting and checking the max length,
	subtract the selected text length (the text we will be replacing) from
	the document length.
	* TextControl.cs: Ensure every character insertion is reflected in
	charcount, so max length will work properly.
	[Fixes bug #398605]

2008-06-11  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Ensure scrollbars are updated when a single
	column listbox with an already set top-index is created.
	[Fixes bug #398342]

2008-06-11  Jonathan Pobst  <monkey@jpobst.com>

	* FontDialog.cs: Typing in the font/style textboxes should search
	the list boxes case-insensitively.  [Fixes bug #398343]

2008-06-11  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Managed window title bar layout now uses actual
	widths of icon and buttons instead of hard coded values.

2008-06-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When SelectionMode is None, clicking an item should move focus
	as well as generating a SelectedIndexChanged event, just like .Net does
	-surprise-.
	Fixes #398345.

2008-06-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: When navigating items visually, use FocusedItem as the
	reference point instead of SelectedIndex, since even in
	SelectionMode.None we need to support navigation, and in that case we
	just can't use SelectedIndex.
	Fixes part of #398345.

2008-06-10  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Make a SetBoundsInternal that avoids the new
	SetBounds code.
	* ComboBox.cs, Form.cs, ListBox.cs, ScrollableControl.cs: Use
	SetBoundsInternal instead of SetBoundsCoreInternal.

2008-06-10  Ivan N. Zlatev  <contact@i-nz.net>

	* ScrollableControl.cs: Use SetBoundsCoreInternal instead of 
	SetBounds for the scrollbars.

2008-06-10  Andreia Gaita <avidigal@novell.com> 

	* HtmlDocument.cs: Implement RightToLeft, ContextMenuShowing,
	  FocusingEvent, LosingFocusEvent, OnMouseDown, OnMouseLeave,
	  OnMouseMove, OnMouseOver, OnMouseUp
	* HtmlElement.cs: Optimize InsertBefore. Implement RemoveFocus,
	  ScrollIntoView, Focusing, GotFocus, LosingFocus, LostFocus.
	* HtmlElementCollection.cs, HtmlWindowCollection.cs: Keep a reference
	  to the WebControl object to pass to new collection objects
	* HtmlHistory.cs: Implement support for individual window histories.
	* HtmlWindow.cs: Implement History, Position, Size, WindowFrameElement,
	  AttachEventHandler, DetachEventHandler, RemoveFocus, Error,
	  GotFocus, LostFocus, OnLoad, OnUnload
	* WebBrowser.cs: Implement EncryptionLevel, ScrollBarsEnabled,
	  ContextMenu
	* WebBrowserBase.cs: Implement Cursor, Enabled, UseWaitCursor, Add
	  security level changes and context menu event support.

2008-06-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Pressing Enter should close the dropdown listbox, just
	as happens with Esc, patch my Andy Hume.
	Fixes #396294.

2008-06-10  George Giolfan  <georgegiolfan@yahoo.com>

	* MdiWindowManager.cs: DrawMaximizedButtons now uses
	ManagedWindowGetMenuButtonSize instead of ManagedWindowButtonSize.
	* Theme.cs: Made MenuButtonSize platform dependent. Added
	ManagedWindowButtonSize.
	* ThemeWin32Classic.cs: Added ManagedWindowGetMenuButtonSize.
	* XplatUI.cs, XplatUIDriver.cs, XplatUIWin32.cs: Added MenuButtonSize.

2008-06-10  George Giolfan  <georgegiolfan@yahoo.com>

	* DateTimePicker.cs, Theme.cs, ThemeVisualStyles.cs, ThemeWin32Classic.cs:
	Added support for rendering with VisualStyles.

2008-06-10  George Giolfan  <georgegiolfan@yahoo.com>

	* ComboBox.cs, Theme.cs, ThemeVisualStyles.cs, ThemeWin32Classic.cs: Added
	support for rendering the border with VisualStyles.

2008-06-10  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: Added ShowIcon. Fixed IconRectangleContains when
	the icon is not shown.
	* ThemeWin32Classic.cs: Now uses InternalWindowManager.ShowIcon instead of
	its own logic.

2008-06-10  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: Draw minimized windows even if they don't have
	borders.

2008-06-09  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs, ListBox.cs: Use SetBoundsInternalCore instead of SetBounds.

2008-06-09  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Fill in the defaults for unspecified bounds in SetBounds.
	[Fixes bug #397943]

2008-06-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When snaping height -because of IntegralHeight set to
	true- with ComboBoxStyle.Simple, set the height to PreferredHeight
	if the requested height leaves the listbox area with *less* than the
	required are to see one item. We were setting it to PreferredHeight
	even for values matching the height for a single item.
	Fixes #396297.

2008-06-06  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Simplify GetInheritedStyle by using ApplyStyle.

2008-06-06  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Use property instead of field.

2008-06-06  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs, ThemeWin32Classic.cs: Removed useless Form.Icon
	null checks.

2008-06-06  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs: Added #region around the managed window code. Made the managed
	window methods abstract.
	* ThemeWin32Classic.cs: Added #region around the managed window code.

2008-06-06  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: Now only calls Theme.DrawManagedWindowDecorations
	if it has borders.
	* ThemeWin32Classic.cs: Removed HasBorders checks in
	DrawManagedWindowDecorations.

2008-06-06  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs, Theme.cs, ThemeWin32Classic.cs: Refactored:
	Extracted ManagedWindowGetTitleBarIconArea.

2008-06-05  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCellStyle.cs: Don't clone the font.

2008-06-05  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Ensure we don't pass null to GetConverter.

2008-06-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX1..cs: Use IntPtr size instead of int, as wee need to work
	also on 64 bit machinges. Fixes the BadWindow errors while scrolling
	in 64 bit machines.

2008-06-05  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Correctly get converters for FormattedValue.
	Use Format/FormatProvider before trying converters.
	* DataGridViewCellStyle.cs: ApplyStyle should only apply things that
	are 'set'.  Change constructor to not use ApplyStyle since it wants
	everything applied.  Clone the Font.
	* DataGridViewRowHeaderCell.cs: Start with DefaultCellStyle and
	ApplyStyle the rest.

2008-06-05  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: We need to calculate the scrollbars even if the handle
	hasn't been created - this is needed when methods using scrollbars
	info, such EnsureVisible, are called before control has been created.
	Fixes #397272.

2008-06-05  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: ScrollBar is now rendered with the VisualStyles API
	only if the elements are defined. 

2008-06-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: I'm an idiiot - forgot to commit the last ComboBox
	section. Also, when setting bounds, snap height as well as save the
	requested height if Dock has any value affecting the height: Left,
	Right and Bottom - important if using IntegralHeight as true.

2008-06-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When calling UpdateComboBoxBounds, adjust the height
	passed to SetBounds to reflect the new adjusted height (Integral-wise), 
	instead of doing that only in our SetBoundsCore override, since the 
	bounds cached can be the same as saved one and we could not get the
	new height applied.
	Fixes #396297.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs: Made ToolWindowCaptionButtonSize platform dependent.
	* XplatUI.cs: Added ToolWindowCaptionButtonSize.
	* XplatUIDriver.cs: Changed SmallCaptionButtonSize to 15,15. Added
	ToolWindowCaptionButtonSize.
	* XplatUIWin32.cs: Added ToolWindowCaptionButtonSize.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* MdiWindowManager.cs: Now uses SystemInformation.DoubleClickTime instead of
	hard coded values.
	* Theme.cs: Made DoubleClickTime plaform dependent.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs: Made ToolWindowCaptionHeight platform dependent.
	* XplatUI.cs, XplatUIDriver.cs, XplatUIWin32.cs: Added
	ToolWindowCaptionHeight.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: The adjustment to ensure positive client area
	sizes is now platform dependent (disabled on Windows).
	* XplatUI.cs, XplatUIDriver.cs, XplatUIWin32.cs: Added
	RequiresPositiveClientAreaSize.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* Form.cs: Fixed null handling in Icon (see SettingIconToNull in the tests).

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com>

	* InternalWindowManager.cs: Changed IconicSize to use
	SystemInformation.MinimizedWindowSize.
	* XplatUICarbon.cs, XplatUIX11.cs: Removed MinimizedWindowSize.
	* XplatUIDriver.cs: Changed MinimizedWindowSize to provide a default value.

2008-06-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: If the combobox is anchored both on top and bottom,
	adjust height if IntegralHeight is true when calling SetBoundsCore (as
	likely the height was modified even if Height wasn't specified in
	BoundsSpecified parameter).
	Fixes part of #396297.

2008-06-04  George Giolfan  <georgegiolfan@yahoo.com> 

	* InternalWindowsManager.cs: Changed minimum window size while resizing to
	SystemInformation.MinWindowTrackSize.
	* XplatUICarbon.cs, XplatUIX11.cs: Removed MinWindowTrackSize.
	* XplatUIDriver.cs: Changed MinWindowTrackSize to provide a default value.

2008-06-03  George Giolfan <georgegiolfan@yahoo.com> 

	* MenuItem.cs: Fixed Dispose.

2008-06-03  George Giolfan <georgegiolfan@yahoo.com> 

	* ColumnHeader.cs: CalcColumnHeader now uses the theme to get the height.
	* DataGridView.cs: * EnableHeadersVisualStyles: Fixed default value.
	EnteredHeaderCell, PressedHeaderCell: Added.
	* DataGridViewCell.cs: Refactored: Extracted GetBorderPen.
	* DataGridViewColumnHeaderCell.cs, DataGridViewRowHeaderCell.cs: Gave the
	theme a chance to override default painting.
	* ListView.cs: Added EnteredColumnHeader. Refactored: Extracted
	GetColumnHeaderInvalidateArea, Invalidate(ColumnHeader).
	* Theme.cs, ThemeVisualStyles.cs, ThemeWin32Classic.cs: Added members for
	ListView and DataGridView header rendering.
	
2008-06-03  Ivan N. Zlatev  <contact@i-nz.net>

	* RichTextBox.cs: GetPositionFromCharIndex should return the 
	visual position of the character relative to the viewport.
	[Fixes part of bug #396664]

2008-06-03  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Make HasCustomEditor check for EditStyle != None 
	and not just for the existance of an UITypeEditor. In some cases 
	there is an editor associated just to do PaintValue, but which 
	doesn't actually support editing.
	[Fixes bug #396632]

2008-05-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: page_size as well as vscrollbar.LargeChange should be 1
	if needed, instead of 0 - this should help us in the corner case where
	we have more than one item but we are only partially showing 1 item.
	Fixes part of #374713.

2008-05-02  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUiX11.cs: When scrolling and detecting the obscured areas in a
	control, return immediately if the any parent control's handle hasn't
	been created or isn't visible, as well as avoiding creating the parent
	Form if the handle hasn't been previously created.
	Fixes tests.

2008-06-02  Jonathan Pobst  <monkey@jpobst.com>

	* TableLayoutPanel.cs: Use border sizes when calculating the
	panel's preferred size.  [Fixes part of bug #396433]

2008-06-02  Ivan N. Zlatev  <contact@i-nz.net>

	* SplitContainer.cs:
	 - Fix SplitterDistance to update only if needed. 
	 - Make it force min and max validation.
	 - Handle properly mouse moves outside the resizeable area.
	 [Fixes bug #396232]

2008-06-02  Andreia Gaita <avidigal@novell.com> 

	* WebBrowserBase.cs: Implement support for ScriptErrorsSuppressed
	  (which also suppresses all popup dialogs). Throw NotSupported
	  exceptions for activex getters/setters.
	* WebBrowser.cs: Implement DocumentStream, DocumentType, IsBusy,
	  IsOffline, ReadyState, ScriptErrorsSuppressed, ScrollbarsEnabled,
	  StatusText, Version, GoSearch
	* HtmlDocument.cs: Add DocType support

2008-06-02  Andy Hume  <andyhume32@yahoo.co.uk>

	* TextBox.cs: Implement TextBoxAutoCompleteSourceConverter.
	[Fixes bug 396124]

2008-06-02  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Pass the ITypeDescriptorContext everywhere.

2008-06-02  Jonathan Pobst  <monkey@jpobst.com>

	* TableLayoutPanel.cs: When calculating preferred size, use the
	actual number of columns and rows, not what the user set them to.
	[Fixes bug #396141]

2008-06-02  George Giolfan <georgegiolfan@yahoo.com> 

	* Form.cs: Enabled managed handling of tool window MDI children. Fixes bug
	394311.

2008-06-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: When detecting areas obscured in a control by other
	toplevel windows while scrolling, return if the control hasn't a 
	container form.
	Fixes some tests.

2008-05-01  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* XplatUIX11.cs: Properly detect the visible area of a control being
	scrolled (obscured by other winforms controls and any X toplevel
	windows), to mark as invalid the requested area to be scrolled that
	isn't visible and thus can't be copied.
	Fixes #324513.

2008-05-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBox.cs: Compute the precise amount to vertically scroll when
	using DrawMode.OwnerDrawVariable.
	Patch by jkeymer (j.keymer@gmx.net).

2008-05-30  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Use ListBox-like scrollbar values In ComboListBox 
	to avoid setting an invalid value for the verticall scrollbar 
	when navigating items. And, duh, also remove my silly debug messages
	from previous commits.
	Fixes #374713.

2008-05-30  Ivan N. Zlatev  <contact@i-nz.net>

	* FlatButtonAppearance.cs: Make FlatButtonAppearanceConverter exandable and 
	make it MS compatible.

2008-05-30  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs, PropertyGridView.cs, GridEntry.cs: 
	 - Allow the editing of entries even if their parent is read-only.
	 - Do not render expandable properties read-only.
	 - Refactor expansion checks form PropertyGrid into PropertyGrid.

2008-05-30  George Giolfan <georgegiolfan@yahoo.com> 

	* ScrollBar.cs, Theme.cs, ThemeVisualStyles.cs, ThemeWin32Classic.cs: Added
	support for the hover style.

2008-05-29  Andreia Gaita <avidigal@novell.com> 

	* ContainerControl.cs: Check for null dead-end when traversing the tree
	  of parent controls.
	
	  [Fixes #394332, patch by Ernesto Carrea]

2008-05-29  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Fix a culture-dependent conversion to be the
	constant that it is.  Fixes #393981

2008-05-29  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Add a MonoTODO to the AutoScaleBaseSize setter explaining
	that the user probably doesn't want to set this.

2008-05-29  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Don't let the text size be bigger than
	the control size for CheckBox/RadioBox.
	[Fixes part of bug #394645]

2008-05-29  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Update the state of the sorting buttons in 
	the toolbar if PropertySort is set programatically.

2008-05-29  Ivan N. Zlatev  <contact@i-nz.net>

	* GridItemCollection.cs: Add multiple items with conflicting names 
	support and also preserve name ordering.
	[Fixes #395345]

2008-05-29  Ivan N. Zlatev  <contact@i-nz.net>

	* GridItemCollection.cs: Revert my multiple items with same 
	name patch.

2008-05-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ScrollBar.cs: Scrollbars should only react to left-clicks, not right
	or middle ones.
	Fixes part of #393908.

2008-05-28  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDrowDown.cs: When using the Show () methods that have a
	Control parameter, set the menu owner to that Control.
	[Fixes bug #394345]

2008-05-28  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGridTextBox.cs, PropertyGridView.cs: Implement validation.
	[Fixes bug #362756]

2008-05-27  Ivan N. Zlatev  <contact@i-nz.net>

	* GridItemCollection.cs: Refactor to support multiple items with the 
	same name.
	[Fixes bug #394314]

2008-05-27  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: The 2.0 check for illegal cross thread calls in 
	Control.Handle were throwing an exception when we were getting
	the Handle in order to invoke correctly.  Created a private
	version that does not contain this check.
	[Fixes bug #394531]

2008-05-27  Ivan N. Zlatev  <contact@i-nz.net>

	* PropertyGrid.cs: Respect DefaultTabType.

2008-05-27  Ivan N. Zlatev  <contact@i-nz.net>

	* ListView.cs: SPACE selects an item.
	[Fixes bug #393023]

2008-05-27  Ivan N. Zlatev  <contact@i-nz.net>

	* ListView.cs: Reset the search string whenever the items are 
	modified.
 	[Fixes bug #393020]

2008-05-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListControl.cs: For the first added item PositionChanged is fired
	_before_ ItemChanged, which leave us in a temporary invalid state - so
	we need to set the selected index from ItemChanged handler *if* we
	know that the first item has just been added *and* the items have been
	actually added to the ListControl.
	Fixes #369048.

2008-05-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Only clicks with the left button should be
	handled.
	Fixes #393908.

2008-05-24  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: 
	* FIleDialog.cs:
	* TextBox.cs: Expose an internal method in TextBox to restore the
	original context menu, and call it from ComboBox to re-use it in the
	combobox containing the file name in FileDialog.cs.
	Fixes part of #393775.

2008-05-24  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for the hot ComboBox drop down button
	style.

2008-05-24  George Giolfan  <georgegiolfan@yahoo.com>

	* ComboBox.cs, Theme.cs, ThemeWin32Classic.cs: Added support for the hot drop
	down button style.

2008-05-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Minor correction to previous patch: PageDown should
	also *try* to move by one item if the computed offset is negative,
	just like the PageUp case.

2008-05-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When navigating using PageDown/PageUp the navigation
	should be done for at least 1 item, and not stay at the same item.
	Fixes part of #374713.

2008-05-23  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs: Add a FSEntryComparer, and use it to sort the
	directories.  [Fixes bug #393931]

2008-05-22  Andreia Gaita <avidigal@novell.com> 

	* WebBrowser.cs: Implement DocumentText. Implement AllowNavigation.
	  Don't fire events until the initial about:blank page has finished
	  loading. Clean up events.

2008-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* XplatUIX11.cs : when we call WM_SETFOCUS, call X11Keyboard
	  FocusIn() too. This should fix the issue on switching
	  scim keyboards.

2008-05-22  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : set XIM font size to somewhat reasonable
	  number (ideally the input textbox size, but that could be
	  too messy).

2008-05-22  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripTextBox.cs: List for the TextBox's TextChanged and fire
	the ToolStripItem's TextChanged.  [Fixes bug #393597]

2008-05-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: When invalidating in SelectedIndex and we need to
	inflate to take into account the border of the tabs, make sure that
	the invalidated rect doesn't overflow the control bounds, since that
	would avoid updating at all.

2008-05-21  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Don't substract scroller width from the row width,
	since we need to take into account the total width of the control when
	calculating the position of the tabs. This avoids showing scroller
	when it is actually not needed.
	Fixes part of #322325.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for TextBoxBase.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* RichTextBox.cs, TextBoxBase.cs, Theme.cs, ThemeWin32Classic.cs: Refactored:
	Extracted TextBoxBase.Draw and Theme.TextBoxBase*.

2008-05-21  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Only paint the top left header cell if there
	are columns.

2008-05-21  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: When binding to a BindingSource, get the underlying
	list to bind to.  [Fixes bug #345483]

2008-05-21  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Do not bind to collection properties.
	[Fixes bug #337470]

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for the hot TrackBar thumb style.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeWin32Classic.cs, TrackBar.cs: Added support for the hot
	thumb style.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ToolTip transparent background.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeWin32Classic.cs, ToolTip.cs: Added support for transparent
	background.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ToolBar hot and hot checked styles.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeWin32Classic.cs, ToolBar.cs: Added support for hot and hot
	checked styles.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* TabControl.cs: Extended to handle the hot style.

2008-05-21  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeVisualStyles.cs, ThemeWin32Classic.cs, UpDownBase.cs:
	Extended UpDownBase code to handle hot and disabled styles.

2008-05-20  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Handle databinding to generic list type things.
	[Fixes bug #325239]

2008-05-20  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCellCollection.cs: Add a method to find the cell
	with the given DataPropertyName.
	* DataGridViewColumn.cs: Track if the column was autogenerated or not.
	* DataGridViewColumnCollection.cs: Add a method to clear all
	autogenerated columns.
	* DataGridView.cs: If AutoGenerateColumns is false, don't autogenerate
	columns.
	[Fixes bug #348082]

2008-05-20  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Don't try to update the RowTemplate with
	a null CellTemplate.

2008-05-20  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumn.cs: Allow IsDataBound to be set internally.
	* DataGridViewColumnCollection.cs: Ensure OnColumnAdded is called.
	* DataGridView.cs: Lots of fixes/enhancements to databinding to
	a DataSet.

2008-05-20  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Remove invalidating implicit child controls when
	control is invalidated.  It was causing too many redraws on
	controls with implicit scrollbars.
	* ListView.cs: Listen to the Invalidated event and invalidate
	child controls.

2008-05-20  Andreia Gaita <avidigal@novell.com> 

	* WebBrowserBase.cs, WebBrowser.cs: Hook up page loading events
	* HtmlDocument.cs: Check for nulls

2008-05-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Control.cs: In ControlCollection.RemoveInternal, remove the
	internal control before calling PerformLayout and OnControlRemoved,
	which was leaving us in an invalid state and causing a X error (bad
	match). Observe that Remove () call has the same order.
	Fixes an X error changing ComboBoxStyle.DropDownStyle.

2008-05-19  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* TabControl.cs: Don't paint by ourselved and instead let OnPaint
	being fired if ControlStyles.UserPaint style is activated.
	Fixes #371905.

2008-05-19  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Don't be so strict when setting the value - 
	do not check if what we set is what we get.
	[Fixes bug #389245]

2008-05-19  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: If there are no timers timeout should be 0
	[Fixes bug #363522]

2008-05-19  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: As a followup to invalidating implicit children when
	a control is invalidated, only invalidate them if they are in the
	clip rectangle.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Implemented partial support for ToolTip.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Refactored: Extracted ToolTipDrawBackground.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* GroupBoxRenderer.cs: Fixed text area clipping in the Visual Styles case.
	* XplatUIWin32.cs: Made Win32DeleteObject public.

2008-05-19  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Determine HasDefaultValue more strictly by using 
	PropertyDescriptor.ShouldSerializeValue.
	[Fixes bug #391924]

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Enabled support for ScrollBar element styles not present
	in the classic theme.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* ScrollBar.cs: Added FirstButtonEntered, SecondButtonEntered, ThumbEntered,
	ThumbPressed.
	* Theme.cs, ThemeWin32Classic.cs: Added ScrollBarHasHotElementStyles,
	ScrollBarHasPressedThumbStyle.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* TextRenderer.cs: Included some methods in the 1.1 profile.

2008-05-19  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: When we make a control visible, it may have been
	previously visible and while it wasn't visible, the z-order of
	things may have been shuffled, so the control needs to have its
	z-order updated just in case.  [Fixes bug #391518]

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for GroupBox.

2008-05-19  George Giolfan  <georgegiolfan@yahoo.com>

	* GroupBoxRenderer.cs: Included in the 1.1 profile.

2008-05-16  Atsushi Enomoto  <atsushi@ximian.com>

	* XplatUIX11.cs, X11Keyboard.cs : redoing r103060 with fix for
	  bug #389996; XSelectInput() behaved as mouse handler robber,
	  so remove extra call to it.

2008-05-15  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Simplify ControlCollection.Contains method.

2008-05-15  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRow.cs: Implement GetPreferredSize.

2008-05-15  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewComboBoxCell.cs: Don't declare text twice.  Fixes build.

2008-05-15  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewComboBoxCell.cs: Implement some NIEX stuffs, better
	painting and edit control fixes.

2008-05-14  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs, DataGridViewCell.cs: Work around some external
	checks to make sure we are in an actual row/col for top left header cell.
	* DataGridViewTopLeftHeaderCell.cs: Implement some NIEX's.

2008-05-14  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Use long instead of int when handling WParam from
	mousewheel scrolling.  Int was overflowing on Win64.

2008-05-14  Jonathan Pobst  <monkey@jpobst.com>

	* FlowLayoutPanel.cs, ScrollableControl.cs: We need to layout the
	flow panel without scrolling first, and then calculate the 
	scrolling based on the new layout.  [Fixes bug #390149]

2008-05-14  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Invalidate after scrolling up when selected index
	changes.  [Fixes bug #390151]

2008-05-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When setting mode to Simple *and* height hasn't been
	set, default height to 150. I tried first with DefaultSize, but this
	is not generating a SetBoundsCore call before handle creation time, so
	we can take it into account. This is just what .net does.

2008-05-13  Jonathan Pobst  <monkey@jpobst.com>

	* XplatUIX11.cs, X11Keyboard.cs: Had to revert eno's r103060,
	as it broke some stuff.  Calberto is filing a bug for eno to
	work with.

2008-05-13  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When handling PageDown pressed event, set SelectedIndex
	to 0 is the current value is -1, and if style is not Simple, just
	return, like .net does.
	Fixes part of #374713.

2008-05-13  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs, ThemeVisualStyles.cs: When calculating
	progress bar stuffs, use doubles instead of ints to prevent
	overflow.  [Fixes bug #389798]

2008-05-13  Atsushi Enomoto  <atsushi@ximian.com>

	* XplatUIX11.cs, X11Keyboard.cs :
	  Significant refactoring on XIM support. Now IM engine UI
	  should show up, at mostly-correct preedit position.
	  - Eliminated use of FocusWindow, as it is never mapped
	    and hence blocks correct preedit position. XIC is now
	    created per window, and it must be destroyed too when
	    the window is destroyed.
	  - WM_QUIT messages should not be filtered even when hwnd
	    is zombie. Filtering it could cause endless loop.
	  - Preedit position must move only when the window is alive.
	  - Make it IDisposable and make sure to release XIM/XICs.

2008-05-13  Atsushi Enomoto  <atsushi@ximian.com>

	* Timer.cs, Control.cs, Form.cs, ApplicationContext.cs,
	  XplatUIX11.cs, XplatUIWin32.cs :
	  fix for bug #325033 and #387693;
	  - WM_QUIT should not be sent when no running application
	    exists.
	  - SetTimer/KillTimer (especially on win32) should be
	    invoked for the window that the timer is/will_be attached.
	  - There could be unattached timers to a window when it's
	    started. For those timers, hold pending timers and when
	    a window is mapped, attach them to it.
	  - WaitForHwndMessage() could run into loop when
	    WM_SHOWWINDOW is handled before this method is called.
	    So, strictly check wm_showwindow state.
	  - Tick handler should not be invoked while one Tick handler
	    call is still running (introduced Busy state).

2008-05-13  Andreia Gaita <avidigal@novell.com> 

	* WebBrowserBase.cs: Override Internal alternative methods for
	  SetBoundsCore and OnResize instead of the protected ones.
	* Control.cs: Move SetBoundsCore and OnResize implementations to
	  SetBoundsCoreInternal and OnResizeInternal, so they can be
	  overriden internally (WebBrowserBase needs to catch them but can't
	  override the protected methods without api compat problems)

2008-05-13  Andreia Gaita <avidigal@novell.com> 

	* WebBrowserBase.cs: Hiding away non-public overrides for api compat

2009-05-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs:
	* ListView.cs: Remove debug messages.

2008-05-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: Don't do any calculation for simple mode if the listbox
	area is empty. Also calculate scrollbars in Simple mode based in area
	height and total number of items, not in MaxDropDownItems.
	Fixes part of #371991.

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* PictureBox.cs: Always invalidate on resize.  Fixes an app for jhill.

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* BindingSource.cs: GetListSortDescription is not public.

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* WebBrowser.cs, WebBrowserBase.cs, WebBrowserSiteBase.cs: corcompare.

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* HtmlElement.cs: Fix parameter names to match MS.
	* HtmlWindowCollection.cs: Should not be sealed.

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Always draw the scrollbar area under the thumb
	button, because the thumb button will not get drawn if the scrollbar
	is disabled.  [Fixes bug #389262]

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Handle End key for multi-column listboxen.
	[Fixes bug #389266]

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Fix algorithm to determine which column our item is in.
	[Fixes bug #389265]

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Invalidate when the listbox is resized.
	[Fixes bug #389256]

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: There is always at least one row in the ListBox (if
	we are doing these calculations.)  [Fixes bug #389253]

2008-05-12  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: There is always at least one column in the ListBox.
	[Fixes bug #389250]

2008-05-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: When handle is created call UpdateComboBoxBounds to
	ensure in Simple mode that the height is exactly the requested one.
	Also add the ComboBoxListControl to the controls collection in Simple
	mode even if handle hasn't been created.
	Fixes part of #371991.

2008-05-10  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ComboBox.cs: For ComboListBox control -specially in Simple mode-, give focus to
	our ComboBox owner instead of giving it back to the previous control (
	as done in other controls). Also remove the empty override of Select
	method, since we want to be selected *and* give focus to our owner.
	This should let the user do keys-navigation in Simple mode. 

2008-05-10  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Dont use HIViewScrollRect as it's causing painting
	problems with rapid scrolling of treeviews. Fixes #381084

2008-05-10  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Deactivate the active window before
	activating the desired window.  Completes fixing #386504

2008-05-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When calculating scrollbars, set horizontal scroll bar
	SmallChange to the item size width plus the padding, to match .net.

2008-05-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* FileDialog.cs: Apply the custom filter typed by the user in the file
	name combobox as much as possible while navigating in the file dialog.
	Fixes #385261.

2008-05-09  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: Actually use NullValue if the retrieved value of
	data source is null or DBNull. Makes a test pass.

2008-05-09  Jonathan Pobst  <monkey@jpobst.com>

	* ErrorProvider.cs, Form.cs: Get icons from ResourceImageLoader.
	* MimeIcon.cs: Provide a way to get icons from resources.

2008-05-08  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When the value retrieved from the control to be assigned
	to the data source is null, actually use the 2.0 DataSourceNullValue
	value. Make pass a data binding test.

2008-05-08  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: We need to invalidate implicit children even when
	invalidate is called with invalidatechildren = false.  (Implicit
	children are really part of the parent.)
	* ListView.cs: Double-buffer internal child controls for less
	flicker.
	* ThemeWin32Classic.cs: Remove an extra nested loop in drawing
	owner ListView subitems for greatly increased performance.
	[Fixes bug #388477]

2008-05-08  Carlos Alberto Cortez <calebrto.cortez@gmail.com>

	* FileDialog.cs: When the user types a wildcard character in the
	filename combobox, update the contents of the folder using the text as
	a filter.
	Fixes part of #385261.

2008-05-08  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Various fixes for MultiColumn listboxen.
	[Fixes bug #388114]

2008-05-08  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs: Implement Style property

2008-05-08  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Respect checkboxes when measuring item size.
	* ThemeWin32Classis.cs: When drawing list items, don't draw
	text outside of the item's bounds to prevent overlapping.
	(.Net actually overlaps, but that's just silly.)
	[Fixes bug #388117]

2008-05-08  Everaldo Canuto  <ecanuto@novell.com>

	* NotifyIcon.cs: Call SetForegroundWindow before show context menu. Thanks
	Gert Driesen. Fixes bug #324830. 

2008-05-07  Everaldo Canuto  <ecanuto@novell.com>

	* XplatUI.cs, XplatUIDriver.cs, XplatUIWin32.cs: SetForegroundWindow
	method implemented.

2008-05-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: When calling IsSynchronized, return the value of
	the related IList list.

2008-05-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBindingHelper.cs: Fix some bits in GetListItemProperties, to
	make a test pass.

2008-05-07  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Implement PageUp/PageDown keys.  Extend keyboard
	navigation to scroll the grid if the current cell is not visible.

2008-05-07  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs: Implement TabIndex

2008-05-07  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Respect ScrollAlwaysVisible and HorizontalScrollbar
	properties, even when there are no items.
	[Fixes bug #387611]

2008-05-07  Ivan N. Zlatev  <contact@i-nz.net>

	* NativeWindow.cs: Add support for multiple handles per window.
	* NativeWindows.cs, LibSupport.cs, Control.cs, XplatUIX11GTK.cs, 
	XplatUIX11.cs, X11Display.cs: Do not access NativeWindow.windows_collection 
	directly - use FromHandle instead.
	[Fixes bug #374660]

2008-05-07  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs: Implement InnerHTML setter

2008-05-07  Andreia Gaita <avidigal@novell.com> 

	* HtmlDocument.cs: Implement Focused

2006-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Minor fixes to the the ApplySort and Remove sort
	methods, as well as add messages to the exceptions.

2006-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Setting DataSource should only reset DataMember if
	the previous value was null (make pass a not working test).

2006-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: When EndInit call is postponed and is called until
	DataSource.EndInit is called, remove the handler for data source.

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripManager.cs: Don't use IsAlive, race condition, etc. etc.

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripManager.cs: Store references to toolstrips as
	weak references so they do not prevent forms from getting collected.
	[Fixes bug #386483]

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* TrackBar.cs: We can't set ResizeRedraw because it isn't set
	on .Net.  So do the same thing in WndProc.

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* TrackBar.cs: Commit patch from Andy Hume that corrects
	the clickable areas to better match .Net.
	[Fixes bug #387074]

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* TrackBar.cs: Commit patch from Andy Hume that adds the
	ResizeRedraw control flag so the track bar repaints itself
	when it is resized.  [Fixes bug #387072]

2008-05-06  Jonathan Pobst  <monkey@jpobst.com>

	* TrackBar.cs: Commit patch from Andy Hume that adds better
	support for keyboard navigation when the TrackBar is vertical.
	[Fixes bug #387071]

2008-05-06  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Implement ISupportInitializeNotification support.

2008-05-06  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ToolBar.

2008-05-06  George Giolfan  <georgegiolfan@yahoo.com>

	* ToolBar.cs: Made the Vertical property internal.

2008-05-05  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for TrackBar.

2008-05-05  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Refactored: Extracted TrackBarGetThumbSize,
	TrackBarDrawVerticalTrack, TrackBarDrawVerticalThumbRight,
	TrackBarDrawVerticalThumbLeft, TrackBarDrawVerticalThumb,
	TrackBarGetVerticalTickPainter, TrackBarDrawHorizontalTrack,
	TrackBarDrawHorizontalThumbBottom, TrackBarDrawHorizontalThumbTop,
	TrackBarDrawHorizontalThumb, TrackBarGetHorizontalTickPainter.

2008-05-05  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for UpDownBase.

2008-05-05  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeWin32Classic.cs, UpDownBase.cs: Refactored:
	Extracted Theme.UpDownBaseDrawButton.

2008-05-05  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStrip.cs, ToolStripDropDownItem.cs: Make sure toolstrips are
	removed from the static toolstrips collection in ToolStripManager
	when they are disposed.  Provides a workaround for bug #386483.

2008-05-05  Ivan N. Zlatev  <contact@i-nz.net>

	* GridEntry.cs: Read-only properties with Editor with 
	UITypeEditorEditStyle.Modal shouldn't be read-only in the PropertyGrid.
	[Fixes bug #384184]

2008-05-05  Jonathan Pobst  <monkey@jpobst.com>

	* MenuStrip.cs, ToolStrip.cs: Guard against an NRE when pressing
	the menu key and there are no items on the menu.
	[Fixes bug #386644]

2008-05-05  Sebastien Pouliot  <sebastien@ximian.com>

	* Control.cs: Avoid calling ToString on a string.
	* Form.cs: Avoid calling ToString on a string. Found using Gendarme.
	* GroupBox.cs: In FlatStyle property throw, not just create, the 
	exception. Avoid calling ToString on a string.
	* ProgressBar.cs: Avoid calling ToString on a string. 
	* ScrollBar.cs: Avoid calling ToString on a string. 
	[All issues were found using Gendarme]

2008-05-05  Everaldo Canuto  <ecanuto@novell.com>

	* NotifyIcon.cs: Prevent click events to be trigger after double click 
	events. Fixes remaining issues of bug #324832.

2008-05-05  Everaldo Canuto  <ecanuto@novell.com>

	* NotifyIcon.cs: Trigger click and mouseclick events after mouseup event
	to mimic win32 behavior. Partially fixes bug #324832.

2008-05-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Implement Find methods.

2008-05-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Implement Sort, ApplySort overloads, and
	RemoveSort methods.

2008-05-04  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListBindingHelper.cs: When calling GetListItemProperties and the
	passed object is ITypedList, return the result of
	ITypedList.GetItemProperties instead.

2008-05-04  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Set default value of name on constructor of Link class
	only for 2.0 profile.

2008-05-04  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Fix implementation of LinkCollection.LinksAdded property.
	Fixes remaining issues of bug #346154.

2008-05-04  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Set a default value for name on internal contructor of
	Link class. It fixes assert B5 of LinkCollectionTest.Constructor1.

2008-05-04  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Move links collection from LinkCollection to LinkLabel
	and refer all instances to owner.links. Partially fixes #346154.

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* LinkLabel.cs: Fix linkarea values for empty text, must have start and 
	length equal zero. Also called CreateLinkPieces in constructor. It fixes
	the LinkLabel test 'TestLinkArea'.

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* Form.cs: Remove menu before close form to prevent form to be not gaced.
	[Fixes #386460]

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Dispose popup window after hide. Thanks to Jesse Jones.
	[Fixes #386463]

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Implemented keyboard navigation for ContextMenu.
	[Fixed bug #357004]

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Remove unused ProcessCmdKey method.

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Prevent NRE in menu deactivation when shortcut is used. 
	[Fixes bug #375398]

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Enable implicit mnemonics for menus. Fixes remaining issues
	of bug #367492.

2008-05-03  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Check if mouse down comes from menu, we need it because
	sometimes we open a conext menu on mouse down of some controls and the mouse
	up is dispatched to menu and dont need to. It fix remaining issues of 
	#363711 and other problems related to menu mouse click events.

2008-05-02  Everaldo Canuto  <ecanuto@novell.com>

	* MonthCalendar.cs: Implemented "Go to today" context menu, also changed
	some var names to better fit changes, now we have month_menu and today_menu
	vars. Fixes bug #363711.

2008-05-02  Everaldo Canuto  <ecanuto@novell.com>

	* MonthCalendar.cs: Handle every right mouse click to open context menu,
	right now the default month menu but it will be change to have "Go to today"
	menu.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs, MaskedTextBox.cs, OpenFileDialog.cs: corcompare.

2008-05-02  Everaldo Canuto  <ecanuto@novell.com>

	* ThemeWin32Classic.cs: Fix MonthCalendar arrows drawing.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for TreeView.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* Theme.cs, ThemeWin32Classic.cs, TreeView.cs: Refactored:
	Moved TreeView.DrawNodePlusMinus to Theme.TreeViewDrawNodePlusMinus.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* OpenFileDialog.cs: Implement 2.0 SP1 stuffs.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialogCustomPlace.cs, FileDialogCustomPlacesCollection.cs:
	Implement 2.0 SP1 stuffs.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs: Implement 2.0 SP1 stuffs.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs, ContainerControl.cs, DataGridView.cs, TextBoxBase.cs:
	Implement CanEnableIme property. (2.0 SP1)

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* BindingManagerBase.cs, PropertyManager.cs: Hide GetItemProperties
	from the 2.0 API.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* Control.cs: Provide an internal way for a control to override
	the setting of Height.
	* DateTimePicker.cs: Remove SetBoundsCore from 2.0 profile,
	set height using new method.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawMixedCheckBox.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* ControlPaint.cs, Theme.cs, ThemeWin32Classic.cs: Refactored:
	ControlPaint.DrawMixedCheckBox now calls Theme.CPDrawMixedCheckBox.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for StatusBar.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataObject.cs: Add the other IDataObject interface.

2008-05-02  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Refactored: extracted DrawStatusBarBackground,
	DrawStatusBarSizingGrip, DrawStatusBarPanelBackground.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCheckBoxCell.cs, DataGridViewImageCell.cs: Fix parameter names.
	* ListView.cs: Hide non-public API.
	* MaskedTextBox.cs: Remove extra attribute.

2008-05-02  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewImageCell.cs: Use formatted value instead of value
	to calculate preferred size.

2008-05-01  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Move some initialization around so that selected_indices
	is not accessed before it is created.

2008-05-01  Jonathan Pobst  <monkey@jpobst.com>

	* InputLanguageCollection.cs: Implement the collection better.
	[Fixes bug #385506]

2008-05-01  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripDropDownItem.cs: Get the correct event object for
	DropDownItemClicked.
	* ToolStripMenuItem.cs: Raise DropDownItemClicked on our owner.
	[Fixes bug #385475]

2008-05-01  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRowCollection.cs: We don't currently support shared 
	rows.  Should fix test failures caused by previous commit.

2008-04-30  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRow.cs: Fixes for cloning the row, ensure header cell's
	datagridview gets set.  Only paint cells in visible columns.
	* DataGridViewCell.cs: Draw border after cell content.
	* DataGridView.cs: Invalidate after setting some properties.  Only
	use visible columns.  Fit hit test bug with areas in the col/row header
	area but not in a row or col.  Implement UpdateCell/Row methods.

2008-04-30  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewElement.cs: Don't throw NIEX.
	* DataGridViewColumnHeaderCell.cs: Draw error icons for top left header cells.
	* DataGridViewColumnDesignTimeVisibleAttribute.cs: Don't throw NIEX.
	* DataGridViewCheckBoxColumn.cs: Implement ToString.
	* DataGridViewCheckBoxCell.cs: Allow DBNull as a value.
	* DataGridViewCell.cs: Don't raise CellFormatting for RowHeader cells,
	if the user filled in the formatting Value, use it.

2008-04-30  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewTextBoxCell.cs: Fix for objects that cannot be cast
	to a string.

2008-04-29  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Some corrections to Filter property, as well as
	setting it for our list when resetting it.

2008-04-29  Jonathan Pobst  <monkey@jpobst.com>

	* ScrollBar.cs: Don't let dragging the thumb grip set the value greater
	than the maximum.  Fixes reopened bug #384182.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* ToolStripDropDown.cs: Fix offscreen position for DropDown itens.
	Fixes remaining issues of #367490.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* ToolStripDropDown.cs: Screen.Bound dont return right value then use 
	SystemInformation.WorkingArea to get max_screen value.

2008-04-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingSource.cs: Implement Filter and RemoveFilter.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Prevent sub-menu positon to be less than zero.

2008-04-28  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: When trying to convert data and we know we started the
	dnd loop, don't try to use the cached data if the loop is not running,
	which means that the data has been resetted.
	Fixes #378191.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Force first menu subitem to show from left to right to mimic
	win32 behavior.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Check the screen limits before show sub-menus and prevent
	it to drawn off screen edge. Fixes bug #367490.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: In PopupWindow.RefreshItems uses a temp point var to store
	menu position to have only one assignment of Location var.

2008-04-28  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Implement the right key for sub-menus. Thanks Ernesto Carrea
	for this patch. Fixes bug #384115.

2008-04-28  Jonathan Pobst  <monkey@jpobst.com>

	* ScrollBar.cs: If SmallChange is larger than LargeChange, make them
	the same.  If LargeChange is zero, set a minimum size for the scroll
	thumb grip.  [Fixes bug #384182]

2008-04-28  Jonathan Pobst  <monkey@jpobst.com>

	* TextBoxTextRenderer.cs: Don't turn &A into a prefix for textboxen.
	[Fixes bug #384181]

2008-04-28  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Math.Min should be Math.Max.  [Fixes bug #384183]

2008-04-28  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added partial support for ScrollBar (based on the
	patch from Ernesto).

2008-04-28  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawComboButton.

2008-04-28  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawButton.

2008-04-28  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawRadioButton.

2008-04-28  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawScrollButton.

2008-04-27  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ButtonBase.UseVisualStyleBackColor.

2008-04-27  Andreia Gaita <avidigal@novell.com> 

	* HtmlWindow.cs, HtmlHistory.cs: Throw on DomHistory getter (it's
	  supposed to return a reference to an mshtml interface, which we
	  don't support).
	* HtmlElement.cs: Throw on DomElement getter (it's supposed to return a
	  reference to an mshtml interface, which we don't support). Code
	  formatting cleanup.
	* HtmlDocument.cs: Add DefaultEncoding getter implementation. Throw on
	  DomDocument getter (it's supposed to return a reference to an
	  mshtml interface, which we don't support). Code formatting cleanup.

2008-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Ouch, forgot to commit.

2008-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: 
	* ThemeWin32Classic.cs: Fire the -until now- forgotten CacheVirtualItems event.

2008-04-26  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When calculating box selection for virtual mode, don't
	look for intersection with item's text, but item bounds, since that
	would mean read ListViewItem's text for _every_ item, and that's
	something we just can't do in virtual mode (items are only requested
	when drawn).

2008-04-26  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawCaptionButton and
	partial support for managed windows (based on the patch from Ernesto).

2008-04-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When doing a key search use FindItemWithText method
	instead of doing the search by ourselves, this way we avoid
	duplicating the code and also we handle the special case for virtual
	mode. To achieve that make our private overload of FindItemWithText
	internal and also have a 'roundtrip' parameter.

2008-04-25  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When doing the layout don't request the
	ListViewItem instance if we are in virtual mode (since we can't request it
	until the item is actully drawn).

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ProgressBar (based on the patch 
	from Ernesto).

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeVisualStyles.cs: Added support for ControlPaint.DrawCheckBox (based on 
	the patch from Ernesto).

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeEngine.cs: Added code to select ThemeVisualStyles.
	* ThemeVisualStyles.cs: Added.

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* IDeviceContext.cs: Added a missing using.

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* ButtonBase.cs: Made IsDefault protected internal.
	* ButtonRenderer.cs: Made GetPushButtonRenderer(PushButtonState) internal.

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* Application.cs: Included VisualStyles-related members in the 1.1 profile.
	* ButtonRenderer.cs, CheckBoxRenderer.cs, Padding.cs, PaddingConverter.cs,
	RadioButtonRenderer.cs: Included in the 1.1 profile.
	* IDeviceContext.cs: Added.
	* TextRenderer.cs: Included a member in the 1.1 profile.

2008-04-25  George Giolfan  <georgegiolfan@yahoo.com>

	* ThemeWin32Classic.cs: Added ShouldPaintFocusRectangle(ButtonBase).

2008-04-24  Jonathan Pobst  <monkey@jpobst.com>

	* ErrorProvider.cs: Make the error icons come after the control
	they refer to.  It isn't the way the MS does it, but its better
	than what we were doing.  See bug #368587.

2008-04-24  Jonathan Pobst  <monkey@jpobst.com>

	* InputLanguage.cs, InputLanguageCollection.cs: Apply patch
	from Eric Albright that lazy loads the input language as ensures
	everything gets properly initialized.  Fixes bug #373871.

2008-04-24  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStrip.cs: Don't use ToolStripControlHosts when figuring up
	implicit mnemonics.  [Fixes bug #383000]

2008-04-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: When canceling the operation, automatically restore the
	default cursor - normally the default cursor is restored when the
	mouse buttons are released, but we should be able to restore it even
	if the buttons are still pressed (for example, when pressing ESC to
	cancel).
	Fixes #381894.

2008-04-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: When starting a new drad and drop operation, set control
	field to null, just as the other fields, to avoid calling any
	operation on a previous control. Also, when calling DndLeave on a
	control, set it to null, thus we don't fire that event multiple times
	for that control.
	Fixes #209264.

2008-04-23  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Ensure that we have a valid hwnd before accessing
	the whole_window object.  Fixes #377084.

2008-04-23  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs: Implement RaiseEvent (event injection into the
	  embedded browser)

2008-04-23  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnHeaderCell.cs: Implement some NIEX stuffs.

2008-04-23  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs, HtmlDocument.cs: Implement javscript method
	  invocation

2008-04-23  Andreia Gaita <avidigal@novell.com> 

	* HtmlElement.cs, HtmlDocument.cs: Implement custom event handler
	  attaching/detaching

2008-04-23  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: When the drop was cancelled, or could just not be
	performed, return DragDropEffect.None always (match .net).

2008-04-22  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRowHeaderCell.cs: Fill in some NIEX stuff.

2008-04-22  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewRowCollection.cs: Revert something I didn't mean to commit.

2008-04-22  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Add support for error icon tool tips.
	* DataGridViewCell.cs: ErrorIconBounds needs to call GetErrorIconBounds.
	* DataGridViewRowHeaderCell.cs: Need internal way to get ErrorIconBounds.

2008-04-22  Ivan N. Zlatev  <contact@i-nz.net>

	* X11Structs.cs: Add mouse button masks enum.
	* XplatUIX11.cs, Hwnd.cs: Send WM_ENTERSIZEMOVE and 
        WM_EXITSIZEMOVE only once at the beginning and at the end of the 
	form resize/move operation instead of for each step of it.
	[Fixes bug #346529 for the x11 backend]

2008-04-21  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView*: Implement support for drawing error icons.

2008-04-21  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Make vbar and hbar internal.
	* TreeNode.cs: If collapsing the node removes one of the TreeView's
	scrollbars, invalidate the whole thing.
	[Fixes bug #382001]

2008-04-21  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Calling Sort() sets Sorted = true.
	* TreeNodeCollection.cs: Try to find the owner TreeView to determine
	if the nodes need to be sorted.
	[Fixes bug #382028]

2008-04-21  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Fire SizeChanged for both when the form is minimized and 
	restored.
	* XplatUIX11.cs: Instead of tracking minimization on UnmapNotify track it 
	on PropertyNotify of _NET_WM_STATE. Much much cleaner.

2008-04-21  Jonathan Pobst  <monkey@jpobst.com>

	* ComboBox.cs: If the combobox is disabled, draw a disabled
	background before painting anything else.
	[Fixes bug #381729]

2008-04-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Wehn the drag and drop operation is cancelled don't
	forget to send a Leave event to the target window - just as .net does
	when cancelling dnd operations.

2008-04-20  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* X11Dnd.cs: Stop tracking messages as part of the dnd operation as
	soon as possible - this happens when we send the drop message to the
	target window. This way we avoid firing any DragOver _after_ drop finished.
	Fixes #378179.

2008-04-20  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Send WM_WINDOWPOSCHANGED when a toplevel is minimized.
	* Form.cs: Handle form minimization as a special state, where size doesn't 
	change, but we have to fire SizeChanged.
	[Fixes bug #325122 for the win32 and x11 backends]

2008-04-20  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Win32 doesn't send WM_(KILL|SET)FOCUS 
	if the handle is disabled.
	[Fixes bug #371751]

2008-04-20  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Enable Maximize/Minimize/Close ability (not decorations) 
	for forms with FormBorderStyle.None.
	[Fixes bug #349571]

2008-04-20  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Implement support for WM_ENTERSIZEMOVE and 
	WM_EXITSIZEMOVE.
	[Fixes bug #346529 for the X11 backend]

2008-04-19  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: 
	  - Send a mouse Enter message after say dragging the mouse with a 
	  button down and then release it in another client.
	  - Reset the cursor to prevent X11 from remembering it and setting it 
	  before the control gets WM_SETCURSOR.
	  - Qeueue a mouse move after a mouse enter like win32.
	  [Fixes bug #323234]

2008-04-19  Ivan N. Zlatev  <contact@i-nz.net>

	* XplatUIX11.cs: Implement limited support for WM_SYSCOMMAND. 
	It's sent when the form gets moved, resized, closed.
	* XplatUIStructs.cs: Add SystemCommands enum for WM_SYSCOMMAND.
	[Fixes bug #359193 for X11]

2008-04-19  Ivan N. Zlatev  <contact@i-nz.net>

	* Form.cs: Add a ValidateChildren for the 1.1 profile. Fixes 
	the build.

2008-04-19  Ivan N. Zlatev  <contact@i-nz.net>

	* ListView.cs: Move CalculateDetailsGroupItemsCount to the NET_2_0 
	group. Fixes the 1.1 build.

2008-04-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Use display indexes for selection in Details view, as
	well as do the proper layout based on display indexes for that view
	too.

2008-04-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: Focused item information is now stored as a display
	index, and display indexes are used all over the place for selection,
	instead of ListViewItem.Index values, which doesn't give us enough
	information to modify the selection in groups mode, and was broken.

2008-04-18  Ivan N. Zlatev  <contact@i-nz.net>

	* Control.cs: Do not fire MouseDown if validation of the control has 
	failed.
	* Form.cs: Validate the form before closing.
	[Fixes bugs #330501 and #353310]

2008-04-18  Andreia Gaita <avidigal@novell.com> 

	* WebBrowserBase.cs: Added WndProc, DrawToBitmap,
	  CreateWebBrowserSiteBase implementations
	* HtmlElement.cs: Add missing OuterHTML, OuterText setters, stubbed
	  Style and TabIndex setters

2008-04-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListViewGroup.cs: When returning the actual item count, return the
	proper count for default group.
	Fix the tests.

2008-04-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs:
	* ListViewGroup.cs: When calculating groups layout, get the actual
	number of items per group, since groups added to the group BUT not
	added to the ListView are just ignored, and can cause some nasty
	exceptions because of the lack of synchronization. Also for
	ListViewGroup don't use lazy initialization for items, since we 
	the common scenario is to use it always - and it helps us to  refactor
	and clean the .ctor overloads.

2008-04-18  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When adding an item to a ListViewItemCollection
	belonging to a group (ListViewGroup.Items), don't generate a redraw if
	the added item hasn't beeen previously added to the ListView instance
	refered by the group, since it will be ignored. This should avoid some 
	really nasty flickering.

2008-04-17  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When accessing an item in a specific display
	position, use the helper method GetItemAtDisplayIndex, instead of
	direct access to the reordered_items_indices array. When doing layout
	for groups set the correct Items index for the display position (since
	in groups mode items don't have the same position as in Items
	collection).
	* ListViewGroup.cs: Add a field to store the starting item number,
	which is later used when calculating the layout.

	Fixes #360805.

2008-04-17  Gert Driesen  <drieseng@users.sourceforge.net>

	* Application.cs: Fixed ProductVersion to fallback to the assembly
	version. Fixes regression for bug #325413.

2008-04-16  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: New helper method to retrieve an item in a _specific
	display_ position (the items can be displayed in a different order
	than one of Items collection).
	* ThemeWin32Classic.cs: When drawing, instead of iterating over Items
	collection, use ListView.GetItemAtDisplayIndex, to get an item in a
	specific display position (again remember that items can be sorted
	different than Items).

2008-04-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnCollection.cs: Create a cached copy of our sorted
	list and update it when the collection changes.  We were recreating
	this several times per row paint and for every pixel the mouse moved
	across the grid.
	* DataGridViewColumn.cs: Regenerate cached sorted list when DisplayIndex
	changes.

2008-04-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewColumnCollection.cs: Convert our internal sorted columns
	list to use generics.
	* DataGridView.cs, DataGridViewRow.cs: Use generic sorted column list
	and remove unneccessay casts.

2008-04-16  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewBand.cs: Add internal way to set displayed variable.
	* DataGridViewRow.cs: Don't paint cells in non-displayed columns.
	* DataGridView.cs: Make sure we always keep track of Displayed
	rows and columns, and only draw things that are displayed.

2008-04-16  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs, XplatUIX11.cs : manage key state regardless of
	  whether the key events are filtered or not. Introduced
	  PreFilter() process for this purpose. This fixes atokx3/iiimx
	  shift state issue.

2008-04-16  Andreia Gaita <avidigal@novell.com> 

	* HtmlHistory.cs: Implement Length property

2008-04-15  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Call EndEdit when a sort is performed so we take
	away the edit textbox.  Refactor to reuse column sort code.

2008-04-12  Everaldo Canuto  <ecanuto@novell.com>

	* MenuAPI.cs: Remove the code that save and restore capture status of 
	grab_control, this fixes some Menu and Context menu bugs but maybe it can
	cause some others, I cant figure the possible problems of this patch but
	right now remove the code looks to be better than keep it. This patch fixes
	bugs #357638, #378721 and #379570.

2008-04-12  Andreia Gaita <avidigal@novell.com> 

	* HtmlDocument.cs, HtmlElement.cs, HtmlHistory.cs, WebBrowser.cs:
	Implement OuterHtml, OuterText, Enabled, Scroll*, *Rectangle properties,
	add missing properties and event handlers.
	
2008-04-14  Jonathan Pobst  <monkey@jpobst.com>

	* ListBox.cs: Make sure the LargeChange we are setting is at least
	zero, to prevent an IOORE.  [Fixes bug #379531]

2008-04-13  Andy Hume <andyhume32@yahoo.co.uk>

	* ComboBox.cs: Support item navigation by entering text.  Firstly, 
	in DropDownList mode, for each key-press select the next item 
	starting with that letter.
	For other modes, when no item selected, on arrow-up/-down and open 
	drop-down select the first item matching the text in the textbox.

2008-04-14  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : Control.FromHandle() could return null
	  in MoveCurrentCaretPos().

2008-04-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ListView.cs: When changing the size in VirtualMode, also Reset the
	selection.
	* ListViewItem.cs: Don't call SelectedIndexCollection.Reset when
	changing selection info for VirtualMode.
	Fixes #372618.

2008-04-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* ThemeWin32Classic.cs: When drawing ListViewItem instancesin Details
	view, don't use LineLimit for the first item - use NoWrap *always*
	instead, since ListView.LabelWrap is not used for this view.
	Fixes #378054.

2008-04-12  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: Call UpdateIsBinding when setting control - probably
	Binding is already usable and we don't need to wait to check the
	IsBinding state. Also for 1.1 profile use IsHandleCreated instead of
	Created, just like 2.0 does.
	* CurrencyManager.cs: I'm so lame - the previous check was wrong.

2008-04-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: Just realized we don't need to have a handler for
	BindingContextChanged, since this info should be now consumed directly
	in the BindingManagerBase. And also, the manager.IsBindingSuspended
	state info is checked directly, instead of caching it.

	* CurrencyManager.cs: IsSuspended should return always false if Count
	== 0.

2008-04-11  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* Binding.cs: When calling PushData, return if manager.Count == 0,
	since we just don't have data to be read. Also, when setting the
	Control for binding, hook up some events to refresh the IsBinding
	state when BindingContext change or control gets created; use
	Control.IsHandleCreated instead of Control.Created check to set
	IsBinding state - we *actually* need to modify IsBinding when control
	is created, but we don't have any Created event, only HandleCreated.
	Fixes part of #349364.

2008-04-11  Geoff Norton  <gnorton@novell.com>

	* XplatUICarbon.cs: Expose Caret to the Carbon layer.  Guard against
	warping a null Caret.

2008-04-11  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Implement row/column autosizing methods. Implement
	autosorting.
	* DataGridViewColumnHeaderCell.cs: Add painting of the sort glyph.
	* DataGridViewRowCollection.cs: Add an internal sorting method.

2008-04-11  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeWin32Classic.cs: Apply patch from Ernesto to cache an expensive
	value in ListView drawing code.

2008-04-11  Jonathan Pobst  <monkey@jpobst.com>

	* FileDialog.cs: Only call FileOk when Ok is clicked, not when Cancel
	is clicked.  Respect the user setting Cancel in FileOk.

2008-04-11  Geoff Norton  <gnorton@novell.com>

	* ListView.cs: Avoid setting and resetting control Width/Heights and
	calculate the final value and set it once.  Prevents a feedback loop
	on the mac.

2008-04-10  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Clamp setting the scrollbar value using SafeValueSet.
	[Fixes bug #378869]

2008-04-10  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs, X11Structs.cs : make over-the-spot mode default.
	  Add some on-the-spot code, but it seems we don't need it.

2008-04-10  Jonathan Pobst  <monkey@jpobst.com>

	* Form.cs: Add method for DataGridView to trigger focus cues
	even when it handles the tab keypress.

2008-04-10  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: More keyboard handling, tab, esc.
	* DataGridViewTextBoxEditingControl.cs: Don't request arrow keys
	when at the beginning or end of the text in the text box.

2008-04-09  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Guard against an NRE causing a test to fail.

2008-04-09  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Some fixups for showing and adding the edit control.
	* DataGridViewButtonColumn.cs: Implement ToString.
	* DataGridViewCell.cs: Size and position the control simultaneously.
	* DataGridViewTextBoxCell.cs: Use base to position control.

2008-04-09  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewCell.cs: Fix up some formatting and painting code.
	* DataGridViewImageCell.cs: Implement some NIEX methods.

2008-04-09  Jonathan Pobst  <monkey@jpobst.com>

	* ToolStripItemCollection.cs: What moving an item from one owner
	to another, remove from source owner before adding to destination.
	[Fixes bug #378109]

2008-04-09  Jonathan Pobst  <monkey@jpobst.com>

	* PictureBox.cs: Call Load when ImageLocation is set.
	[Fixes bug #378308]

2008-04-09  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs, XplatUIX11.cs :
	  Implement over-the-spot mode (with some odd offsets).
	  - set preedit position when caret is set.
	  - Wrap XMoveResizeWindow() to move preedit position.

2008-04-08  Everaldo Canuto  <ecanuto@novell.com>

	* X11keyboard.cs: Fix last patch, maxval must be less not greater than
	array lenght.

2008-04-08  Everaldo Canuto  <ecanuto@novell.com>

	* KeyboardLayouts.cs: Uses GENERATING_RESOURCES to make VKeyTableIndex
	and ScanTableIndex public, it fix compilations errors when compiling
	WinForms to generate keyboard layout resources.

2008-04-08  Everaldo Canuto  <ecanuto@novell.com>

	* X11keyboard.cs: Prevent keyboard errors when vitual table theres 
	different element count than scan table. It prevents some errors in non
	standard keyboards.

2008-04-08  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridViewHeaderCell.cs: Implement some NIEX methods.

2008-04-08  Jonathan Pobst  <monkey@jpobst.com>

	* DataGridView.cs: Call OnContentClick.
	* DataGridViewCell.cs: Do a null check on ValueType instead
	of valueType.
	* DataGridViewCheckBoxCell.cs: Implement.

2008-04-08  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : Do not cast IntPtr to int. Use long.

2008-04-08  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : Check XGetIMValues() return value in
	  case it does not return input styles in some environment.

2008-04-08  Atsushi Enomoto  <atsushi@ximian.com>

	* X11Keyboard.cs : sizeof(IntPtr) != 4 on amd64.

2008-04-07  Carlos Alberto Cortez <calberto.cortez@gmail.com>

	* BindingContext.cs: Stub UpdateBinding method.

2008-04-07  Atsushi Enomoto  <atsushi@ximian.com>

        * X11Structs.cs : added couple of structs for XIM support.
        * X11Keyboard.cs :
          Release XIM in case it failed to create XIC. 
          Use consts for XNblah string.
          Add support for IM style customization and XIC creation
          for preedit-position and preedit-callback.
          Right now use MONO_WINFORMS_XIM_STYLE environment variable
          (list of: over-the-spot | on-the-spot | root). Only root
          mode works so far.

	  (redoing r99172 with fix.)

2008-04-07  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Center the checkbox a little better.

2008-04-07  Jonathan Pobst  <monkey@jpobst.com>

	* ThemeClearlooks.cs, ThemeGtk.cs, ThemeNice.cs, ThemeWin32Classic.cs:
	Apply very nice patch from Ernesto Carrea that simplifies our
	scrollbar drawing.  [From bug #376146]

2008-04-07  Jonathan Pobst  <monkey@jpobst.com>

	* TreeView.cs: Correct the location of the root node checkbox when
	ShowRootLines = false.  Don't draw the root lines for the root node
	when ShowRootLines = false.  [Fixes bug #377535]

2008-04-06  Gert Driesen  <drieseng@users.sourceforge.net>

	* WebBrowserBase.cs: Added missing attributes and fixed attributes.
	Fixed line endings.
	* WebBrowser.cs: Added missing attributes and fixed attributes. Fixed
	line endings.
	* MaskedTextBox.cs: Added missing attribute. Code formatting.
	* PageSetupDialog.cs: Added missing attribute. Code formatting.
	* HtmlWindowCollection.cs: Code formatting. Fixed line endings.
	* ImeMode.cs: Added missing field.
	* HtmlWindow.cs: Code formatting. Fixed line endings.
	* HtmlElement.cs: Code formatting. Fixed line endings. Fixed compiler
	warnings.
	* HtmlHistory.cs: Code formatting. Fixed line endings.
	* HtmlDocument.cs: Code formatting. Fixed line endings.
	* ToolStripPanel.cs: Added missing IList implementation.
	* HtmlElementCollection.cs: Code formatting. Fixed line endings.

2008-04-06  Gert Driesen  <drieseng@users.sourceforge.net>

	* BindingContext.cs: Changed argument names to fix corcompare errors.
	* DataGridView.cs: Removed extra explicit interface implementation
	of IDropTarget. Code formatting.
	* FlowLayoutPanel.cs: Changed argument names to fix corcompare errors.
	* ComboBox.cs: Changed argument names to fix corcompare errors.
	* DataGridTextBoxColumn.cs: Changed argument names to fix corcompare
	errors.
	* GridColumnStylesCollection.cs: Changed argument names to fix
	corcompare errors. Removed extra tabs.
	* GridTableStylesCollection.cs: Changed argument names to fix corcompare
	errors.
	* Control.cs: Changed argument names to fix corcompare errors. Code
	formatting. Removed extra explicit IList implementation.
	* TextBox.cs: Changed argument names to fix corcompare errors. Code
	formatting. Use string.Empty instead of "".
	* GridItemCollection.cs: Changed argument names to fix corcompare
	errors. Code formatting.
	* DataGridViewTopLeftHeaderCell.cs: Changed argument names to fix
	corcompare errors. Code formatting.
	* ImageList.cs: Changed argument names to fix corcompare errors.
	* ToolStripItem.cs: Changed argument names to fix corcompare errors.
	* DataGridViewRowCollection.cs: Changed argument names to fix
	corcompare errors. Code formatting.
	* TableLayoutPanel.cs: Changed argument names to fix corcompare errors.
	* DataGridViewSelectedCellCollection.cs: Changed argument names to
	fix corcompare errors. Code formatting.
	* DataGridViewComboBoxCell.cs: Changed argument names to fix
	corcompare errors. Code formatting.
	* LinkLabel.cs: Changed argument names to fix corcompare errors.
	* TreeNode.cs: Changed argument names to fix corcompare errors. Code
	formatting.
	* PropertyGrid.cs: Changed argument names to fix corcompare errors.
	Code formatting.
	* BindingSource.cs: Changed argument names to fix corcompare errors.
	Removed extra explicit interface implementations.
	* DataGridViewSelectedRowCollection.cs: Changed argument names to
